import { __decorate, __metadata } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_NUMBER, PROP_BOOLEAN, StylableComponent, styler, provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';

const registerProps = () => {
    register('wm-marquee', new Map([
        ['class', PROP_STRING],
        ['direction', PROP_STRING],
        ['name', PROP_STRING],
        ['scrollamount', PROP_NUMBER],
        ['scrolldelay', PROP_NUMBER],
        ['show', Object.assign({ value: true }, PROP_BOOLEAN)]
    ]));
};

var MarqueeDirective_1;
const DEFAULT_CLS = 'app-marquee app-container';
const WIDGET_CONFIG = {
    widgetType: 'wm-marquee',
    hostClass: DEFAULT_CLS
};
let MarqueeDirective = MarqueeDirective_1 = class MarqueeDirective extends StylableComponent {
    constructor(inj) {
        super(inj, WIDGET_CONFIG);
        styler(this.nativeElement, this);
    }
};
MarqueeDirective.initializeProps = registerProps();
MarqueeDirective.ctorParameters = () => [
    { type: Injector }
];
MarqueeDirective = MarqueeDirective_1 = __decorate([
    Directive({
        selector: '[wmMarquee]',
        providers: [
            provideAsWidgetRef(MarqueeDirective_1)
        ]
    }),
    __metadata("design:paramtypes", [Injector])
], MarqueeDirective);

const components = [
    MarqueeDirective
];
let MarqueeModule = class MarqueeModule {
};
MarqueeModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], MarqueeModule);

/**
 * Generated bundle index. Do not edit.
 */

export { MarqueeModule, MarqueeDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
