import { __assign, __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_NUMBER, PROP_BOOLEAN, styler, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';

var registerProps = function () {
    register('wm-marquee', new Map([
        ['class', PROP_STRING],
        ['direction', PROP_STRING],
        ['name', PROP_STRING],
        ['scrollamount', PROP_NUMBER],
        ['scrolldelay', PROP_NUMBER],
        ['show', __assign({ value: true }, PROP_BOOLEAN)]
    ]));
};

var DEFAULT_CLS = 'app-marquee app-container';
var WIDGET_CONFIG = {
    widgetType: 'wm-marquee',
    hostClass: DEFAULT_CLS
};
var MarqueeDirective = /** @class */ (function (_super) {
    __extends(MarqueeDirective, _super);
    function MarqueeDirective(inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        styler(_this.nativeElement, _this);
        return _this;
    }
    MarqueeDirective_1 = MarqueeDirective;
    var MarqueeDirective_1;
    MarqueeDirective.initializeProps = registerProps();
    MarqueeDirective.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    MarqueeDirective = MarqueeDirective_1 = __decorate([
        Directive({
            selector: '[wmMarquee]',
            providers: [
                provideAsWidgetRef(MarqueeDirective_1)
            ]
        }),
        __metadata("design:paramtypes", [Injector])
    ], MarqueeDirective);
    return MarqueeDirective;
}(StylableComponent));

var components = [
    MarqueeDirective
];
var MarqueeModule = /** @class */ (function () {
    function MarqueeModule() {
    }
    MarqueeModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], MarqueeModule);
    return MarqueeModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { MarqueeModule, MarqueeDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
