import { __decorate, __metadata } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_ANY, PROP_BOOLEAN, StylableComponent, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';

const registerProps = () => {
    register('wm-tile', new Map([
        ['animation', PROP_STRING],
        ['class', PROP_STRING],
        ['conditionalclass', PROP_ANY],
        ['conditionalstyle', PROP_ANY],
        ['name', PROP_STRING],
        ['show', Object.assign({ value: true }, PROP_BOOLEAN)]
    ]));
};

var TileDirective_1;
const DEFAULT_CLS = 'app-tile';
const WIDGET_CONFIG = { widgetType: 'wm-tile', hostClass: DEFAULT_CLS };
let TileDirective = TileDirective_1 = class TileDirective extends StylableComponent {
    constructor(inj) {
        super(inj, WIDGET_CONFIG);
        styler(this.nativeElement, this, APPLY_STYLES_TYPE.CONTAINER);
    }
};
TileDirective.initializeProps = registerProps();
TileDirective.ctorParameters = () => [
    { type: Injector }
];
TileDirective = TileDirective_1 = __decorate([
    Directive({
        selector: '[wmTile]',
        providers: [
            provideAsWidgetRef(TileDirective_1)
        ]
    }),
    __metadata("design:paramtypes", [Injector])
], TileDirective);

const components = [
    TileDirective
];
let TileModule = class TileModule {
};
TileModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], TileModule);

/**
 * Generated bundle index. Do not edit.
 */

export { TileModule, TileDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
