import { __assign, __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_ANY, PROP_BOOLEAN, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';

var registerProps = function () {
    register('wm-tile', new Map([
        ['animation', PROP_STRING],
        ['class', PROP_STRING],
        ['conditionalclass', PROP_ANY],
        ['conditionalstyle', PROP_ANY],
        ['name', PROP_STRING],
        ['show', __assign({ value: true }, PROP_BOOLEAN)]
    ]));
};

var DEFAULT_CLS = 'app-tile';
var WIDGET_CONFIG = { widgetType: 'wm-tile', hostClass: DEFAULT_CLS };
var TileDirective = /** @class */ (function (_super) {
    __extends(TileDirective, _super);
    function TileDirective(inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        styler(_this.nativeElement, _this, APPLY_STYLES_TYPE.CONTAINER);
        return _this;
    }
    TileDirective_1 = TileDirective;
    var TileDirective_1;
    TileDirective.initializeProps = registerProps();
    TileDirective.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    TileDirective = TileDirective_1 = __decorate([
        Directive({
            selector: '[wmTile]',
            providers: [
                provideAsWidgetRef(TileDirective_1)
            ]
        }),
        __metadata("design:paramtypes", [Injector])
    ], TileDirective);
    return TileDirective;
}(StylableComponent));

var components = [
    TileDirective
];
var TileModule = /** @class */ (function () {
    function TileModule() {
    }
    TileModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], TileModule);
    return TileModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { TileModule, TileDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
