import { __decorate, __metadata } from 'tslib';
import { Injector, ViewChild, ElementRef, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_BOOLEAN, StylableComponent, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';

const registerProps = () => {
    register('wm-navbar', new Map([
        ['class', Object.assign({ value: '' }, PROP_STRING)],
        ['homelink', PROP_STRING],
        ['imgsrc', PROP_STRING],
        ['menuiconclass', Object.assign({ value: 'wi wi-more-vert' }, PROP_STRING)],
        ['name', PROP_STRING],
        ['show', Object.assign({ value: true }, PROP_BOOLEAN)],
        ['title', PROP_STRING]
    ]));
};

var NavbarComponent_1;
const DEFAULT_CLS = 'navbar navbar-default app-navbar';
const WIDGET_CONFIG = { widgetType: 'wm-navbar', hostClass: DEFAULT_CLS };
let NavbarComponent = NavbarComponent_1 = class NavbarComponent extends StylableComponent {
    constructor(inj) {
        super(inj, WIDGET_CONFIG);
        styler(this.nativeElement, this, APPLY_STYLES_TYPE.CONTAINER);
    }
    toggleCollapse() {
        const $navContent = $(this.navContent.nativeElement);
        $navContent.animate({ 'height': 'toggle' });
        if ($navContent.hasClass('in')) {
            setTimeout(() => this.toggleNavCollapse(), 500);
        }
        else {
            this.toggleNavCollapse();
        }
    }
    toggleNavCollapse() {
        this.navContent.nativeElement.classList.toggle('in');
    }
};
NavbarComponent.initializeProps = registerProps();
NavbarComponent.ctorParameters = () => [
    { type: Injector }
];
__decorate([
    ViewChild('navContent', { static: true }),
    __metadata("design:type", ElementRef)
], NavbarComponent.prototype, "navContent", void 0);
NavbarComponent = NavbarComponent_1 = __decorate([
    Component({
        selector: '[wmNavbar]',
        template: "<div class=\"container-fluid\">\n    <div class=\"navbar-header\">\n        <button type=\"button\" class=\"btn-transparent navbar-toggle collapsed\" data-toggle=\"collapse\" (click)=\"toggleCollapse()\" aria-expanded=\"false\">\n            <span class=\"sr-only\">Toggle navigation</span>\n            <i [ngClass]=\"menuiconclass\"></i>\n        </button>\n        <a class=\"navbar-brand\" [href]=\"(homelink | trustAs: 'resource') || '#/'\" *ngIf=\"title || imgsrc\">\n            <img data-identifier=\"img\" class=\"brand-image\" [alt]=\"Brand\" height=\"20\" *ngIf=\"imgsrc\" [src]=\"imgsrc | image\"/>\n            <span class=\"title\" [textContent]=\"title\"></span>\n        </a>\n    </div>\n    <div class=\"collapse navbar-collapse\" #navContent>\n        <ng-content></ng-content>\n    </div>\n</div>",
        providers: [
            provideAsWidgetRef(NavbarComponent_1)
        ]
    }),
    __metadata("design:paramtypes", [Injector])
], NavbarComponent);

const components = [
    NavbarComponent
];
let NavbarModule = class NavbarModule {
};
NavbarModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], NavbarModule);

/**
 * Generated bundle index. Do not edit.
 */

export { NavbarModule, NavbarComponent as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
