import { __assign, __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, ViewChild, ElementRef, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_BOOLEAN, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';

var registerProps = function () {
    register('wm-navbar', new Map([
        ['class', __assign({ value: '' }, PROP_STRING)],
        ['homelink', PROP_STRING],
        ['imgsrc', PROP_STRING],
        ['menuiconclass', __assign({ value: 'wi wi-more-vert' }, PROP_STRING)],
        ['name', PROP_STRING],
        ['show', __assign({ value: true }, PROP_BOOLEAN)],
        ['title', PROP_STRING]
    ]));
};

var DEFAULT_CLS = 'navbar navbar-default app-navbar';
var WIDGET_CONFIG = { widgetType: 'wm-navbar', hostClass: DEFAULT_CLS };
var NavbarComponent = /** @class */ (function (_super) {
    __extends(NavbarComponent, _super);
    function NavbarComponent(inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        styler(_this.nativeElement, _this, APPLY_STYLES_TYPE.CONTAINER);
        return _this;
    }
    NavbarComponent_1 = NavbarComponent;
    NavbarComponent.prototype.toggleCollapse = function () {
        var _this = this;
        var $navContent = $(this.navContent.nativeElement);
        $navContent.animate({ 'height': 'toggle' });
        if ($navContent.hasClass('in')) {
            setTimeout(function () { return _this.toggleNavCollapse(); }, 500);
        }
        else {
            this.toggleNavCollapse();
        }
    };
    NavbarComponent.prototype.toggleNavCollapse = function () {
        this.navContent.nativeElement.classList.toggle('in');
    };
    var NavbarComponent_1;
    NavbarComponent.initializeProps = registerProps();
    NavbarComponent.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    __decorate([
        ViewChild('navContent', { static: true }),
        __metadata("design:type", ElementRef)
    ], NavbarComponent.prototype, "navContent", void 0);
    NavbarComponent = NavbarComponent_1 = __decorate([
        Component({
            selector: '[wmNavbar]',
            template: "<div class=\"container-fluid\">\n    <div class=\"navbar-header\">\n        <button type=\"button\" class=\"btn-transparent navbar-toggle collapsed\" data-toggle=\"collapse\" (click)=\"toggleCollapse()\" aria-expanded=\"false\">\n            <span class=\"sr-only\">Toggle navigation</span>\n            <i [ngClass]=\"menuiconclass\"></i>\n        </button>\n        <a class=\"navbar-brand\" [href]=\"(homelink | trustAs: 'resource') || '#/'\" *ngIf=\"title || imgsrc\">\n            <img data-identifier=\"img\" class=\"brand-image\" [alt]=\"Brand\" height=\"20\" *ngIf=\"imgsrc\" [src]=\"imgsrc | image\"/>\n            <span class=\"title\" [textContent]=\"title\"></span>\n        </a>\n    </div>\n    <div class=\"collapse navbar-collapse\" #navContent>\n        <ng-content></ng-content>\n    </div>\n</div>",
            providers: [
                provideAsWidgetRef(NavbarComponent_1)
            ]
        }),
        __metadata("design:paramtypes", [Injector])
    ], NavbarComponent);
    return NavbarComponent;
}(StylableComponent));

var components = [
    NavbarComponent
];
var NavbarModule = /** @class */ (function () {
    function NavbarModule() {
    }
    NavbarModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], NavbarModule);
    return NavbarModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { NavbarModule, NavbarComponent as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
