import { __decorate, __metadata } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, StylableComponent, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';

const registerProps = () => {
    register('wm-footer', new Map([
        ['name', PROP_STRING],
        ['class', PROP_STRING],
        ['content', PROP_STRING]
    ]));
};

var FooterDirective_1;
const DEFAULT_CLS = 'app-footer clearfix';
const WIDGET_CONFIG = {
    widgetType: 'wm-footer',
    hostClass: DEFAULT_CLS
};
let FooterDirective = FooterDirective_1 = class FooterDirective extends StylableComponent {
    constructor(inj) {
        super(inj, WIDGET_CONFIG);
        styler(this.nativeElement, this, APPLY_STYLES_TYPE.CONTAINER);
    }
};
FooterDirective.initializeProps = registerProps();
FooterDirective.ctorParameters = () => [
    { type: Injector }
];
FooterDirective = FooterDirective_1 = __decorate([
    Directive({
        selector: '[wmFooter]',
        providers: [
            provideAsWidgetRef(FooterDirective_1)
        ]
    }),
    __metadata("design:paramtypes", [Injector])
], FooterDirective);

const components = [
    FooterDirective
];
let FooterModule = class FooterModule {
};
FooterModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], FooterModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FooterModule, FooterDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
