import { __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';

var registerProps = function () {
    register('wm-footer', new Map([
        ['name', PROP_STRING],
        ['class', PROP_STRING],
        ['content', PROP_STRING]
    ]));
};

var DEFAULT_CLS = 'app-footer clearfix';
var WIDGET_CONFIG = {
    widgetType: 'wm-footer',
    hostClass: DEFAULT_CLS
};
var FooterDirective = /** @class */ (function (_super) {
    __extends(FooterDirective, _super);
    function FooterDirective(inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        styler(_this.nativeElement, _this, APPLY_STYLES_TYPE.CONTAINER);
        return _this;
    }
    FooterDirective_1 = FooterDirective;
    var FooterDirective_1;
    FooterDirective.initializeProps = registerProps();
    FooterDirective.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    FooterDirective = FooterDirective_1 = __decorate([
        Directive({
            selector: '[wmFooter]',
            providers: [
                provideAsWidgetRef(FooterDirective_1)
            ]
        }),
        __metadata("design:paramtypes", [Injector])
    ], FooterDirective);
    return FooterDirective;
}(StylableComponent));

var components = [
    FooterDirective
];
var FooterModule = /** @class */ (function () {
    function FooterModule() {
    }
    FooterModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], FooterModule);
    return FooterModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { FooterModule, FooterDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
