import { __decorate, __metadata } from 'tslib';
import { Injector, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, StylableComponent, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';

const registerProps = () => {
    register('wm-header', new Map([
        ['name', PROP_STRING],
        ['class', PROP_STRING],
        ['content', PROP_STRING]
    ]));
};

var HeaderComponent_1;
const DEFAULT_CLS = 'app-header clearfix';
const WIDGET_CONFIG = {
    widgetType: 'wm-header',
    hostClass: DEFAULT_CLS
};
let HeaderComponent = HeaderComponent_1 = class HeaderComponent extends StylableComponent {
    constructor(inj) {
        super(inj, WIDGET_CONFIG);
        styler(this.nativeElement, this, APPLY_STYLES_TYPE.CONTAINER);
    }
};
HeaderComponent.initializeProps = registerProps();
HeaderComponent.ctorParameters = () => [
    { type: Injector }
];
HeaderComponent = HeaderComponent_1 = __decorate([
    Component({
        selector: '[wmHeader]',
        template: "<div class=\"app-header-menu\" data-role=\"page-left-panel-icon\">\n    <a class=\"app-header-action\">\n        <i class=\"wi wi-menu\"></i>\n    </a>\n</div>\n<div class=\"app-header-container\" partial-container-target></div>",
        providers: [
            provideAsWidgetRef(HeaderComponent_1)
        ]
    }),
    __metadata("design:paramtypes", [Injector])
], HeaderComponent);

const components = [
    HeaderComponent
];
let HeaderModule = class HeaderModule {
};
HeaderModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], HeaderModule);

/**
 * Generated bundle index. Do not edit.
 */

export { HeaderModule, HeaderComponent as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
