import { __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';

var registerProps = function () {
    register('wm-header', new Map([
        ['name', PROP_STRING],
        ['class', PROP_STRING],
        ['content', PROP_STRING]
    ]));
};

var DEFAULT_CLS = 'app-header clearfix';
var WIDGET_CONFIG = {
    widgetType: 'wm-header',
    hostClass: DEFAULT_CLS
};
var HeaderComponent = /** @class */ (function (_super) {
    __extends(HeaderComponent, _super);
    function HeaderComponent(inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        styler(_this.nativeElement, _this, APPLY_STYLES_TYPE.CONTAINER);
        return _this;
    }
    HeaderComponent_1 = HeaderComponent;
    var HeaderComponent_1;
    HeaderComponent.initializeProps = registerProps();
    HeaderComponent.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    HeaderComponent = HeaderComponent_1 = __decorate([
        Component({
            selector: '[wmHeader]',
            template: "<div class=\"app-header-menu\" data-role=\"page-left-panel-icon\">\n    <a class=\"app-header-action\">\n        <i class=\"wi wi-menu\"></i>\n    </a>\n</div>\n<div class=\"app-header-container\" partial-container-target></div>",
            providers: [
                provideAsWidgetRef(HeaderComponent_1)
            ]
        }),
        __metadata("design:paramtypes", [Injector])
    ], HeaderComponent);
    return HeaderComponent;
}(StylableComponent));

var components = [
    HeaderComponent
];
var HeaderModule = /** @class */ (function () {
    function HeaderModule() {
    }
    HeaderModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], HeaderModule);
    return HeaderModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { HeaderModule, HeaderComponent as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
