import { __decorate, __metadata } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_NUMBER, StylableComponent, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';
import { switchClass } from '@wm/core';

const registerProps = () => {
    register('wm-right-panel', new Map([
        ['class', PROP_STRING],
        ['columnwidth', PROP_NUMBER],
        ['content', PROP_STRING],
        ['name', PROP_STRING]
    ]));
};

var RightPanelDirective_1;
const DEFAULT_CLS = 'app-right-panel';
const WIDGET_CONFIG = {
    widgetType: 'wm-right-panel',
    hostClass: DEFAULT_CLS
};
let RightPanelDirective = RightPanelDirective_1 = class RightPanelDirective extends StylableComponent {
    constructor(inj) {
        super(inj, WIDGET_CONFIG);
        styler(this.nativeElement, this, APPLY_STYLES_TYPE.CONTAINER);
    }
    onPropertyChange(key, nv, ov) {
        if (key === 'columnwidth') {
            switchClass(this.nativeElement, `col-sm-${nv}`, ov ? ` col-sm-${ov}` : '');
        }
        else {
            super.onPropertyChange(key, nv, ov);
        }
    }
};
RightPanelDirective.initializeProps = registerProps();
RightPanelDirective.ctorParameters = () => [
    { type: Injector }
];
RightPanelDirective = RightPanelDirective_1 = __decorate([
    Directive({
        selector: '[wmRightPanel]',
        providers: [
            provideAsWidgetRef(RightPanelDirective_1)
        ]
    }),
    __metadata("design:paramtypes", [Injector])
], RightPanelDirective);

const components = [
    RightPanelDirective
];
let RightPanelModule = class RightPanelModule {
};
RightPanelModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], RightPanelModule);

/**
 * Generated bundle index. Do not edit.
 */

export { RightPanelModule, RightPanelDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
