import { __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, PROP_NUMBER, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';
import { switchClass } from '@wm/core';

var registerProps = function () {
    register('wm-right-panel', new Map([
        ['class', PROP_STRING],
        ['columnwidth', PROP_NUMBER],
        ['content', PROP_STRING],
        ['name', PROP_STRING]
    ]));
};

var DEFAULT_CLS = 'app-right-panel';
var WIDGET_CONFIG = {
    widgetType: 'wm-right-panel',
    hostClass: DEFAULT_CLS
};
var RightPanelDirective = /** @class */ (function (_super) {
    __extends(RightPanelDirective, _super);
    function RightPanelDirective(inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        styler(_this.nativeElement, _this, APPLY_STYLES_TYPE.CONTAINER);
        return _this;
    }
    RightPanelDirective_1 = RightPanelDirective;
    RightPanelDirective.prototype.onPropertyChange = function (key, nv, ov) {
        if (key === 'columnwidth') {
            switchClass(this.nativeElement, "col-sm-" + nv, ov ? " col-sm-" + ov : '');
        }
        else {
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        }
    };
    var RightPanelDirective_1;
    RightPanelDirective.initializeProps = registerProps();
    RightPanelDirective.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    RightPanelDirective = RightPanelDirective_1 = __decorate([
        Directive({
            selector: '[wmRightPanel]',
            providers: [
                provideAsWidgetRef(RightPanelDirective_1)
            ]
        }),
        __metadata("design:paramtypes", [Injector])
    ], RightPanelDirective);
    return RightPanelDirective;
}(StylableComponent));

var components = [
    RightPanelDirective
];
var RightPanelModule = /** @class */ (function () {
    function RightPanelModule() {
    }
    RightPanelModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], RightPanelModule);
    return RightPanelModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { RightPanelModule, RightPanelDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
