import { __decorate, __metadata } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, StylableComponent, styler, provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';

const registerProps = () => {
    register('wm-top-nav', new Map([
        ['name', PROP_STRING],
        ['content', PROP_STRING]
    ]));
};

var TopNavDirective_1;
const DEFAULT_CLS = 'app-top-nav';
const WIDGET_CONFIG = { widgetType: 'wm-top-nav', hostClass: DEFAULT_CLS };
let TopNavDirective = TopNavDirective_1 = class TopNavDirective extends StylableComponent {
    constructor(inj) {
        super(inj, WIDGET_CONFIG);
        styler(this.nativeElement, this);
    }
};
TopNavDirective.initializeProps = registerProps();
TopNavDirective.ctorParameters = () => [
    { type: Injector }
];
TopNavDirective = TopNavDirective_1 = __decorate([
    Directive({
        selector: '[wmTopNav]',
        providers: [
            provideAsWidgetRef(TopNavDirective_1)
        ]
    }),
    __metadata("design:paramtypes", [Injector])
], TopNavDirective);

const components = [
    TopNavDirective
];
let TopNavModule = class TopNavModule {
};
TopNavModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], TopNavModule);

/**
 * Generated bundle index. Do not edit.
 */

export { TopNavModule, TopNavDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
