import { __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { register, PROP_STRING, styler, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';

var registerProps = function () {
    register('wm-top-nav', new Map([
        ['name', PROP_STRING],
        ['content', PROP_STRING]
    ]));
};

var DEFAULT_CLS = 'app-top-nav';
var WIDGET_CONFIG = { widgetType: 'wm-top-nav', hostClass: DEFAULT_CLS };
var TopNavDirective = /** @class */ (function (_super) {
    __extends(TopNavDirective, _super);
    function TopNavDirective(inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        styler(_this.nativeElement, _this);
        return _this;
    }
    TopNavDirective_1 = TopNavDirective;
    var TopNavDirective_1;
    TopNavDirective.initializeProps = registerProps();
    TopNavDirective.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    TopNavDirective = TopNavDirective_1 = __decorate([
        Directive({
            selector: '[wmTopNav]',
            providers: [
                provideAsWidgetRef(TopNavDirective_1)
            ]
        }),
        __metadata("design:paramtypes", [Injector])
    ], TopNavDirective);
    return TopNavDirective;
}(StylableComponent));

var components = [
    TopNavDirective
];
var TopNavModule = /** @class */ (function () {
    function TopNavModule() {
    }
    TopNavModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], TopNavModule);
    return TopNavModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { TopNavModule, TopNavDirective as ɵa, registerProps as ɵb };
//# sourceMappingURL=index.js.map
