import { OnDestroy } from '@angular/core';
import { EventNotifier } from '../utils/event-notifier';
export declare class IViewportService {
    notify: (eventname: ViewportEvent, options?: Array<any>) => void;
    subscribe: (eventname: ViewportEvent, callback: (data: any) => void) => void;
}
export declare const enum ViewportEvent {
    ORIENTATION_CHANGE = "orientationchange",
    RESIZE = "resize"
}
export declare class Viewport implements IViewportService, OnDestroy {
    orientation: {
        isPortrait: boolean;
        isLandscape: boolean;
    };
    isMobileType: boolean;
    isTabletType: boolean;
    private type;
    _eventNotifier: EventNotifier;
    private screenWidth;
    private screenHeight;
    private selectedViewPort;
    constructor();
    update(selectedViewPort: Object): void;
    private orientationChange;
    private resizeFn;
    subscribe(eventName: any, callback: (data: any) => void): () => void;
    notify(eventName: string, ...data: Array<any>): void;
    private setScreenType;
    ngOnDestroy(): void;
}
