import { __assign, __extends, __decorate, __metadata, __spread } from 'tslib';
import { Injector, HostListener, Component, NgModule } from '@angular/core';
import { BarcodeScanner } from '@ionic-native/barcode-scanner';
import { register, PROP_STRING, PROP_BOOLEAN, styler, APPLY_STYLES_TYPE, provideAsWidgetRef, StylableComponent, WmComponentsModule } from '@wm/components/base';
import { hasCordova } from '@wm/core';
import { CommonModule } from '@angular/common';

var registerProps = function () {
    register('wm-barcodescanner', new Map([
        ['barcodeformat', __assign({ value: 'ALL' }, PROP_STRING)],
        ['caption', __assign({ value: '' }, PROP_STRING)],
        ['class', PROP_STRING],
        ['iconclass', __assign({ value: 'glyphicon glyphicon-barcode' }, PROP_STRING)],
        ['iconsize', __assign({ value: '2em' }, PROP_STRING)],
        ['name', PROP_STRING],
        ['show', __assign({ value: true }, PROP_BOOLEAN)]
    ]));
};

var DEFAULT_CLS = 'btn app-barcode';
var WIDGET_CONFIG = { widgetType: 'wm-barcodescanner', hostClass: DEFAULT_CLS };
var BarcodeScannerComponent = /** @class */ (function (_super) {
    __extends(BarcodeScannerComponent, _super);
    function BarcodeScannerComponent(scanner, inj) {
        var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
        _this.scanner = scanner;
        styler(_this.nativeElement, _this, APPLY_STYLES_TYPE.SCROLLABLE_CONTAINER);
        return _this;
    }
    BarcodeScannerComponent_1 = BarcodeScannerComponent;
    BarcodeScannerComponent.prototype.openBarcodescanner = function ($event) {
        var _this = this;
        this.scan().then(function (text) {
            _this.datavalue = text;
            _this.invokeEventCallback('success', { $event: $event });
        });
    };
    BarcodeScannerComponent.prototype.scan = function () {
        var options;
        if (hasCordova()) {
            if (this.barcodeformat && this.barcodeformat !== 'ALL') {
                options = {
                    formats: this.barcodeformat
                };
            }
            return this.scanner.scan(options)
                .then(function (data) { return data.text; });
        }
        return Promise.resolve('BAR_CODE');
    };
    var BarcodeScannerComponent_1;
    BarcodeScannerComponent.initializeProps = registerProps();
    BarcodeScannerComponent.ctorParameters = function () { return [
        { type: BarcodeScanner },
        { type: Injector }
    ]; };
    __decorate([
        HostListener('click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], BarcodeScannerComponent.prototype, "openBarcodescanner", null);
    BarcodeScannerComponent = BarcodeScannerComponent_1 = __decorate([
        Component({
            selector: 'button[wmBarcodescanner]',
            template: "<i [ngClass]=\"iconclass\" [ngStyle]=\"{'font-size': iconsize}\"></i>\n<span class=\"btn-caption\" [textContent]=\"caption\"></span>",
            providers: [
                provideAsWidgetRef(BarcodeScannerComponent_1)
            ]
        }),
        __metadata("design:paramtypes", [BarcodeScanner, Injector])
    ], BarcodeScannerComponent);
    return BarcodeScannerComponent;
}(StylableComponent));

var components = [
    BarcodeScannerComponent
];
var BarcodeScannerModule = /** @class */ (function () {
    function BarcodeScannerModule() {
    }
    BarcodeScannerModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], BarcodeScannerModule);
    return BarcodeScannerModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { BarcodeScannerComponent, BarcodeScannerModule, registerProps as ɵa };
//# sourceMappingURL=index.js.map
