import { __decorate, __metadata } from 'tslib';
import { Directive, NgModule } from '@angular/core';
import { DateComponent, DatetimeComponent, TimeComponent } from '@wm/components/input/epoch';
import { CommonModule } from '@angular/common';
import { WmComponentsModule } from '@wm/components/base';

let DateDirective = class DateDirective {
    constructor(dateComponent) {
        dateComponent.useDatapicker = false;
        dateComponent.datepattern = 'yyyy-MM-dd';
        dateComponent.updateFormat('datepattern');
    }
};
DateDirective.ctorParameters = () => [
    { type: DateComponent }
];
DateDirective = __decorate([
    Directive({
        selector: '[wmDate]'
    }),
    __metadata("design:paramtypes", [DateComponent])
], DateDirective);

let DateTimeDirective = class DateTimeDirective {
    constructor(dateTimeComponent) {
        dateTimeComponent.useDatapicker = false;
        dateTimeComponent.datepattern = 'yyyy-MM-ddTHH:mm:ss';
        dateTimeComponent.updateFormat('datepattern');
    }
};
DateTimeDirective.ctorParameters = () => [
    { type: DatetimeComponent }
];
DateTimeDirective = __decorate([
    Directive({
        selector: '[wmDateTime]'
    }),
    __metadata("design:paramtypes", [DatetimeComponent])
], DateTimeDirective);

let TimeDirective = class TimeDirective {
    constructor(timeComponent) {
        timeComponent.useDatapicker = false;
    }
};
TimeDirective.ctorParameters = () => [
    { type: TimeComponent }
];
TimeDirective = __decorate([
    Directive({
        selector: '[wmTime]'
    }),
    __metadata("design:paramtypes", [TimeComponent])
], TimeDirective);

const components = [
    DateDirective,
    DateTimeDirective,
    TimeDirective
];
let EpochModule = class EpochModule {
};
EpochModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], EpochModule);

/**
 * Generated bundle index. Do not edit.
 */

export { DateDirective, DateTimeDirective, EpochModule, TimeDirective };
//# sourceMappingURL=index.js.map
