import { __decorate, __metadata, __spread } from 'tslib';
import { Directive, NgModule } from '@angular/core';
import { DateComponent, DatetimeComponent, TimeComponent } from '@wm/components/input/epoch';
import { CommonModule } from '@angular/common';
import { WmComponentsModule } from '@wm/components/base';

var DateDirective = /** @class */ (function () {
    function DateDirective(dateComponent) {
        dateComponent.useDatapicker = false;
        dateComponent.datepattern = 'yyyy-MM-dd';
        dateComponent.updateFormat('datepattern');
    }
    DateDirective.ctorParameters = function () { return [
        { type: DateComponent }
    ]; };
    DateDirective = __decorate([
        Directive({
            selector: '[wmDate]'
        }),
        __metadata("design:paramtypes", [DateComponent])
    ], DateDirective);
    return DateDirective;
}());

var DateTimeDirective = /** @class */ (function () {
    function DateTimeDirective(dateTimeComponent) {
        dateTimeComponent.useDatapicker = false;
        dateTimeComponent.datepattern = 'yyyy-MM-ddTHH:mm:ss';
        dateTimeComponent.updateFormat('datepattern');
    }
    DateTimeDirective.ctorParameters = function () { return [
        { type: DatetimeComponent }
    ]; };
    DateTimeDirective = __decorate([
        Directive({
            selector: '[wmDateTime]'
        }),
        __metadata("design:paramtypes", [DatetimeComponent])
    ], DateTimeDirective);
    return DateTimeDirective;
}());

var TimeDirective = /** @class */ (function () {
    function TimeDirective(timeComponent) {
        timeComponent.useDatapicker = false;
    }
    TimeDirective.ctorParameters = function () { return [
        { type: TimeComponent }
    ]; };
    TimeDirective = __decorate([
        Directive({
            selector: '[wmTime]'
        }),
        __metadata("design:paramtypes", [TimeComponent])
    ], TimeDirective);
    return TimeDirective;
}());

var components = [
    DateDirective,
    DateTimeDirective,
    TimeDirective
];
var EpochModule = /** @class */ (function () {
    function EpochModule() {
    }
    EpochModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], EpochModule);
    return EpochModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { DateDirective, DateTimeDirective, EpochModule, TimeDirective };
//# sourceMappingURL=index.js.map
