import { __decorate, __metadata } from 'tslib';
import { Directive, NgModule } from '@angular/core';
import { FileUploadComponent } from '@wm/components/input/file-upload';
import { hasCordova } from '@wm/core';
import { FileSelectorService } from '@wm/mobile/components/basic';
import { CommonModule } from '@angular/common';
import { WmComponentsModule } from '@wm/components/base';

let FileUploadDirective = class FileUploadDirective {
    constructor(fileSelectorService, fileUploadComponent) {
        this.fileSelectorService = fileSelectorService;
        this.fileUploadComponent = fileUploadComponent;
        fileUploadComponent._isMobileType = true;
        fileUploadComponent._isCordova = hasCordova();
        fileUploadComponent['openFileSelector'] = () => {
            this.openFileSelector(fileUploadComponent.multiple).then((contents) => {
                this.fileUploadComponent.onFileSelect({}, contents);
            });
        };
    }
    openFileSelector(multiple) {
        switch (this.fileUploadComponent['contenttype']) {
            case 'image':
                return this.fileSelectorService.selectImages(multiple);
            case 'video':
                return this.fileSelectorService.selectVideos(multiple);
            case 'audio':
                return this.fileSelectorService.selectAudio(multiple);
            default:
                return this.fileSelectorService.selectFiles(multiple);
        }
    }
};
FileUploadDirective.ctorParameters = () => [
    { type: FileSelectorService },
    { type: FileUploadComponent }
];
FileUploadDirective = __decorate([
    Directive({
        selector: '[wmFileUpload]'
    }),
    __metadata("design:paramtypes", [FileSelectorService,
        FileUploadComponent])
], FileUploadDirective);

const components = [
    FileUploadDirective
];
let FileUploadModule = class FileUploadModule {
};
FileUploadModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], FileUploadModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FileUploadDirective, FileUploadModule };
//# sourceMappingURL=index.js.map
