import { __decorate, __metadata, __spread } from 'tslib';
import { Directive, NgModule } from '@angular/core';
import { FileUploadComponent } from '@wm/components/input/file-upload';
import { hasCordova } from '@wm/core';
import { FileSelectorService } from '@wm/mobile/components/basic';
import { CommonModule } from '@angular/common';
import { WmComponentsModule } from '@wm/components/base';

var FileUploadDirective = /** @class */ (function () {
    function FileUploadDirective(fileSelectorService, fileUploadComponent) {
        var _this = this;
        this.fileSelectorService = fileSelectorService;
        this.fileUploadComponent = fileUploadComponent;
        fileUploadComponent._isMobileType = true;
        fileUploadComponent._isCordova = hasCordova();
        fileUploadComponent['openFileSelector'] = function () {
            _this.openFileSelector(fileUploadComponent.multiple).then(function (contents) {
                _this.fileUploadComponent.onFileSelect({}, contents);
            });
        };
    }
    FileUploadDirective.prototype.openFileSelector = function (multiple) {
        switch (this.fileUploadComponent['contenttype']) {
            case 'image':
                return this.fileSelectorService.selectImages(multiple);
            case 'video':
                return this.fileSelectorService.selectVideos(multiple);
            case 'audio':
                return this.fileSelectorService.selectAudio(multiple);
            default:
                return this.fileSelectorService.selectFiles(multiple);
        }
    };
    FileUploadDirective.ctorParameters = function () { return [
        { type: FileSelectorService },
        { type: FileUploadComponent }
    ]; };
    FileUploadDirective = __decorate([
        Directive({
            selector: '[wmFileUpload]'
        }),
        __metadata("design:paramtypes", [FileSelectorService,
            FileUploadComponent])
    ], FileUploadDirective);
    return FileUploadDirective;
}());

var components = [
    FileUploadDirective
];
var FileUploadModule = /** @class */ (function () {
    function FileUploadModule() {
    }
    FileUploadModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], FileUploadModule);
    return FileUploadModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { FileUploadDirective, FileUploadModule };
//# sourceMappingURL=index.js.map
