import { __decorate, __metadata } from 'tslib';
import { ElementRef, Component, Directive, NgModule } from '@angular/core';
import { addClass, App, AbstractNavigationService } from '@wm/core';
import { provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';
import { PageDirective } from '@wm/components/page';
import { DeviceService } from '@wm/mobile/core';
import { CommonModule } from '@angular/common';

var PageContentLoaderComponent_1;
let PageContentLoaderComponent = PageContentLoaderComponent_1 = class PageContentLoaderComponent {
    constructor(el) {
        addClass(el.nativeElement, 'app-page-content-loader');
    }
};
PageContentLoaderComponent.ctorParameters = () => [
    { type: ElementRef }
];
PageContentLoaderComponent = PageContentLoaderComponent_1 = __decorate([
    Component({
        selector: '[wmPageContentLoader]',
        template: "<div class=\"loader bg-primary\"></div>\n<div class=\"load-info\"></div>",
        providers: [
            provideAsWidgetRef(PageContentLoaderComponent_1)
        ]
    }),
    __metadata("design:paramtypes", [ElementRef])
], PageContentLoaderComponent);

let MobilePageDirective = class MobilePageDirective {
    constructor(app, elRef, deviceService, page, navigationService) {
        this.deviceService = deviceService;
        this.page = page;
        this.navigationService = navigationService;
        addClass(elRef.nativeElement, 'mobile-app-page');
        this._$ele = $(elRef.nativeElement);
        page.subscribe('wmMobileTabbar:ready', () => this._$ele.addClass('has-tabbar'));
        // add backbutton listener on every page.
        this._backBtnListenerDestroyer = deviceService.onBackButtonTap($event => {
            if (app.landingPageName === app.activePageName) {
                window.navigator['app'].exitApp();
            }
            else {
                this.navigationService.goToPrevious();
            }
            return false;
        });
    }
    ngOnDestroy() {
        this._backBtnListenerDestroyer();
    }
};
MobilePageDirective.ctorParameters = () => [
    { type: App },
    { type: ElementRef },
    { type: DeviceService },
    { type: PageDirective },
    { type: AbstractNavigationService }
];
MobilePageDirective = __decorate([
    Directive({
        selector: '[wmPage]'
    }),
    __metadata("design:paramtypes", [App,
        ElementRef,
        DeviceService,
        PageDirective,
        AbstractNavigationService])
], MobilePageDirective);

const components = [
    MobilePageDirective,
    PageContentLoaderComponent
];
let PageModule = class PageModule {
};
PageModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], PageModule);

/**
 * Generated bundle index. Do not edit.
 */

export { MobilePageDirective, PageContentLoaderComponent, PageModule };
//# sourceMappingURL=index.js.map
