import { __decorate, __metadata, __spread } from 'tslib';
import { ElementRef, Component, Directive, NgModule } from '@angular/core';
import { addClass, App, AbstractNavigationService } from '@wm/core';
import { provideAsWidgetRef, WmComponentsModule } from '@wm/components/base';
import { PageDirective } from '@wm/components/page';
import { DeviceService } from '@wm/mobile/core';
import { CommonModule } from '@angular/common';

var PageContentLoaderComponent = /** @class */ (function () {
    function PageContentLoaderComponent(el) {
        addClass(el.nativeElement, 'app-page-content-loader');
    }
    PageContentLoaderComponent_1 = PageContentLoaderComponent;
    var PageContentLoaderComponent_1;
    PageContentLoaderComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    PageContentLoaderComponent = PageContentLoaderComponent_1 = __decorate([
        Component({
            selector: '[wmPageContentLoader]',
            template: "<div class=\"loader bg-primary\"></div>\n<div class=\"load-info\"></div>",
            providers: [
                provideAsWidgetRef(PageContentLoaderComponent_1)
            ]
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], PageContentLoaderComponent);
    return PageContentLoaderComponent;
}());

var MobilePageDirective = /** @class */ (function () {
    function MobilePageDirective(app, elRef, deviceService, page, navigationService) {
        var _this = this;
        this.deviceService = deviceService;
        this.page = page;
        this.navigationService = navigationService;
        addClass(elRef.nativeElement, 'mobile-app-page');
        this._$ele = $(elRef.nativeElement);
        page.subscribe('wmMobileTabbar:ready', function () { return _this._$ele.addClass('has-tabbar'); });
        // add backbutton listener on every page.
        this._backBtnListenerDestroyer = deviceService.onBackButtonTap(function ($event) {
            if (app.landingPageName === app.activePageName) {
                window.navigator['app'].exitApp();
            }
            else {
                _this.navigationService.goToPrevious();
            }
            return false;
        });
    }
    MobilePageDirective.prototype.ngOnDestroy = function () {
        this._backBtnListenerDestroyer();
    };
    MobilePageDirective.ctorParameters = function () { return [
        { type: App },
        { type: ElementRef },
        { type: DeviceService },
        { type: PageDirective },
        { type: AbstractNavigationService }
    ]; };
    MobilePageDirective = __decorate([
        Directive({
            selector: '[wmPage]'
        }),
        __metadata("design:paramtypes", [App,
            ElementRef,
            DeviceService,
            PageDirective,
            AbstractNavigationService])
    ], MobilePageDirective);
    return MobilePageDirective;
}());

var components = [
    MobilePageDirective,
    PageContentLoaderComponent
];
var PageModule = /** @class */ (function () {
    function PageModule() {
    }
    PageModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], PageModule);
    return PageModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { MobilePageDirective, PageContentLoaderComponent, PageModule };
//# sourceMappingURL=index.js.map
