import { __decorate, __metadata } from 'tslib';
import { ElementRef, Directive, NgModule } from '@angular/core';
import { PageDirective } from '@wm/components/page';
import { LeftPanelDirective } from '@wm/components/page/left-panel';
import { addClass } from '@wm/core';
import { DeviceService } from '@wm/mobile/core';
import { CommonModule } from '@angular/common';
import { WmComponentsModule } from '@wm/components/base';

let MobileLeftPanelDirective = class MobileLeftPanelDirective {
    constructor(page, leftPanelRef, deviceService, elRef) {
        this.page = page;
        this.leftPanelRef = leftPanelRef;
        this.deviceService = deviceService;
        addClass(elRef.nativeElement, 'wm-mobile-app-left-panel');
        page.notify('wmLeftPanel:ready', leftPanelRef);
        page.subscribe('wmLeftPanel:expand', () => {
            this._backBtnListenerDestroyer = deviceService.onBackButtonTap(() => {
                leftPanelRef.collapse();
                return false;
            });
        });
        page.subscribe('wmLeftPanel:collapse', () => {
            this.destroyBackBtnListener();
        });
    }
    ngOnDestroy() {
        this.destroyBackBtnListener();
    }
    destroyBackBtnListener() {
        if (this._backBtnListenerDestroyer) {
            this._backBtnListenerDestroyer();
            this._backBtnListenerDestroyer = null;
        }
    }
};
MobileLeftPanelDirective.ctorParameters = () => [
    { type: PageDirective },
    { type: LeftPanelDirective },
    { type: DeviceService },
    { type: ElementRef }
];
MobileLeftPanelDirective = __decorate([
    Directive({
        selector: '[wmLeftPanel]'
    }),
    __metadata("design:paramtypes", [PageDirective,
        LeftPanelDirective,
        DeviceService,
        ElementRef])
], MobileLeftPanelDirective);

const components = [
    MobileLeftPanelDirective
];
let LeftPanelModule = class LeftPanelModule {
};
LeftPanelModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            WmComponentsModule
        ],
        declarations: [...components],
        exports: [...components],
        entryComponents: []
    })
], LeftPanelModule);

/**
 * Generated bundle index. Do not edit.
 */

export { LeftPanelModule, MobileLeftPanelDirective };
//# sourceMappingURL=index.js.map
