import { __decorate, __metadata, __spread } from 'tslib';
import { ElementRef, Directive, NgModule } from '@angular/core';
import { PageDirective } from '@wm/components/page';
import { LeftPanelDirective } from '@wm/components/page/left-panel';
import { addClass } from '@wm/core';
import { DeviceService } from '@wm/mobile/core';
import { CommonModule } from '@angular/common';
import { WmComponentsModule } from '@wm/components/base';

var MobileLeftPanelDirective = /** @class */ (function () {
    function MobileLeftPanelDirective(page, leftPanelRef, deviceService, elRef) {
        var _this = this;
        this.page = page;
        this.leftPanelRef = leftPanelRef;
        this.deviceService = deviceService;
        addClass(elRef.nativeElement, 'wm-mobile-app-left-panel');
        page.notify('wmLeftPanel:ready', leftPanelRef);
        page.subscribe('wmLeftPanel:expand', function () {
            _this._backBtnListenerDestroyer = deviceService.onBackButtonTap(function () {
                leftPanelRef.collapse();
                return false;
            });
        });
        page.subscribe('wmLeftPanel:collapse', function () {
            _this.destroyBackBtnListener();
        });
    }
    MobileLeftPanelDirective.prototype.ngOnDestroy = function () {
        this.destroyBackBtnListener();
    };
    MobileLeftPanelDirective.prototype.destroyBackBtnListener = function () {
        if (this._backBtnListenerDestroyer) {
            this._backBtnListenerDestroyer();
            this._backBtnListenerDestroyer = null;
        }
    };
    MobileLeftPanelDirective.ctorParameters = function () { return [
        { type: PageDirective },
        { type: LeftPanelDirective },
        { type: DeviceService },
        { type: ElementRef }
    ]; };
    MobileLeftPanelDirective = __decorate([
        Directive({
            selector: '[wmLeftPanel]'
        }),
        __metadata("design:paramtypes", [PageDirective,
            LeftPanelDirective,
            DeviceService,
            ElementRef])
    ], MobileLeftPanelDirective);
    return MobileLeftPanelDirective;
}());

var components = [
    MobileLeftPanelDirective
];
var LeftPanelModule = /** @class */ (function () {
    function LeftPanelModule() {
    }
    LeftPanelModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                WmComponentsModule
            ],
            declarations: __spread(components),
            exports: __spread(components),
            entryComponents: []
        })
    ], LeftPanelModule);
    return LeftPanelModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { LeftPanelModule, MobileLeftPanelDirective };
//# sourceMappingURL=index.js.map
