import { __extends, __decorate, __param, __metadata, __read, __spread, __awaiter, __generator, __values, __assign } from 'tslib';
import { Inject, Injectable, Directive, ViewChild, HostListener, TemplateRef, ViewContainerRef, Injector, Input, Component, Self, ElementRef, ComponentFactoryResolver, ChangeDetectorRef, KeyValueDiffers, Compiler, ɵɵdefineInjectable, ɵɵinject, INJECTOR, ApplicationRef, NgZone, ViewEncapsulation, NgModule, CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA, APP_INITIALIZER, LOCALE_ID } from '@angular/core';
import { Router, RouteReuseStrategy, ActivatedRoute, NavigationStart, NavigationEnd, NavigationCancel, NavigationError, RouterOutlet, RouterModule } from '@angular/router';
import { DatePipe, registerLocaleData, AsyncPipe, SlicePipe, PercentPipe, I18nPluralPipe, NgLocalization, I18nSelectPipe, KeyValuePipe, UpperCasePipe, LowerCasePipe, JsonPipe, DecimalPipe, TitleCasePipe, CurrencyPipe, CommonModule } from '@angular/common';
import { LRUCache, $appDigest, isDefined, triggerFn, fetchContent, AbstractHttpService, AbstractDialogService, App, AbstractSpinnerService, AbstractI18nService, stringStartsWith, loadStyleSheets, loadScripts, noop as noop$1, ScriptLoaderService, Viewport, UtilsService, $invokeWatchers, muteWatchers, AbstractNavigationService, isIos, isAndroid, unMuteWatchers, $watch, isIE, getWmProjectProperties, StatePersistence, AbstractToasterService, ConstantService, FieldTypeService, FieldWidgetService, DynamicComponentRefProvider, EventNotifier, isString, setCSS, _WM_APP_PROJECT, isMobile, isMobileApp, setSessionStorageItem, getSessionStorageItem, replace, AppDefaults, CustomPipeManager, setPipeProvider, setNgZone, setAppRef, addClass, removeClass, hasCordova, extendProto, $parseExpr, isObject, isIphone, isIpod, isIpad, CoreModule, loadScript } from '@wm/core';
import { SecurityService, SecurityModule } from '@wm/security';
import { CONSTANTS, routerService, $rootScope, VariablesService, MetadataService, appManager, httpService, VariablesModule } from '@wm/variables';
import { PageDirective } from '@wm/components/page';
import { Subject } from 'rxjs';
import { WidgetRef, PartialDirective, FileIconClassPipe, FileExtensionFromMimePipe, StateClassPipe, FileSizePipe, FilterPipe, ToDatePipe, ToNumberPipe, ToCurrencyPipe, PrefixPipe, SuffixPipe, TimeFromNowPipe, NumberToStringPipe, StringToNumberPipe, CustomPipe, WmComponentsModule } from '@wm/components/base';
import { PrefabContainerDirective, PrefabDirective as PrefabDirective$1, PrefabModule } from '@wm/components/prefab';
import { HttpClient, HTTP_INTERCEPTORS, HttpClientModule } from '@angular/common/http';
import { ToastrService, ToastPackage, Toast, ToastrModule } from 'ngx-toastr';
import { DialogModule } from '@wm/components/dialogs';
import { ConfirmDialogModule } from '@wm/components/dialogs/confirm-dialog';
import { DesignDialogModule } from '@wm/components/dialogs/design-dialog';
import { MobileRuntimeModule } from '@wm/mobile/runtime';
import { WmHttpRequest, WmHttpResponse, HttpServiceModule } from '@wm/http';
import { OAuthService, OAuthModule } from '@wm/oAuth';
import { defineLocale } from 'ngx-bootstrap/chronos';
import { BsLocaleService } from 'ngx-bootstrap/datepicker';
import { setTheme } from 'ngx-bootstrap/utils';
import { tap } from 'rxjs/operators';
import { transpile } from '@wm/transpiler';
import { initComponentsBuildTask } from '@wm/build-task';

var ComponentType;
(function (ComponentType) {
    ComponentType[ComponentType["PAGE"] = 0] = "PAGE";
    ComponentType[ComponentType["PREFAB"] = 1] = "PREFAB";
    ComponentType[ComponentType["PARTIAL"] = 2] = "PARTIAL";
})(ComponentType || (ComponentType = {}));
var ComponentRefProvider = /** @class */ (function () {
    function ComponentRefProvider() {
    }
    ComponentRefProvider.prototype.clearComponentFactoryRefCache = function () { };
    ;
    return ComponentRefProvider;
}());
var PrefabConfigProvider = /** @class */ (function () {
    function PrefabConfigProvider() {
    }
    return PrefabConfigProvider;
}());
var AppJSProvider = /** @class */ (function () {
    function AppJSProvider() {
    }
    return AppJSProvider;
}());
var AppVariablesProvider = /** @class */ (function () {
    function AppVariablesProvider() {
    }
    return AppVariablesProvider;
}());
var AppExtensionProvider = /** @class */ (function () {
    function AppExtensionProvider() {
    }
    return AppExtensionProvider;
}());

var MAX_CACHE_SIZE = 'REUSE_ROUTE_STRATEGY.MAX_CACHE_SIZE';
var MAX_CACHE_AGE = 'REUSE_ROUTE_STRATEGY.MAX_CACHE_AGE';
/* Base Strategy with Default implementations */
var WmDefaultRouteReuseStrategy = /** @class */ (function () {
    function WmDefaultRouteReuseStrategy(maxCacheSize, maxCacheAge) {
        var _this = this;
        this.maxCacheSize = maxCacheSize;
        this.maxCacheAge = maxCacheAge;
        this.paramsToIgnore = [
            'wm_state' // state persistence
        ];
        this.getSize = function (obj) {
            return obj ? Object.keys(obj).length : 0;
        };
        this.cache = new LRUCache(maxCacheSize, maxCacheAge, function (key, handle) {
            if (_this.currentRouteKey === key) {
                _this.cache.set(key, handle);
            }
            else {
                handle.componentRef.destroy();
            }
        });
    }
    WmDefaultRouteReuseStrategy.prototype.getKey = function (route) {
        var _this = this;
        var queryParams = _.chain(route.queryParams)
            .keys()
            .filter(function (k) { return !_.includes(_this.paramsToIgnore, k); })
            .orderBy()
            .map(function (k) { return k + '=' + route.queryParams[k]; })
            .value().join('&');
        var pageName = route.params.pageName;
        if (route.data.pageName && route.routeConfig.path === '') {
            pageName = route.data.pageName;
        }
        return pageName && (pageName + '?' + queryParams);
    };
    WmDefaultRouteReuseStrategy.prototype.isSameQueryParams = function (future, current) {
        try {
            var fqParams = future.queryParams;
            var cqParams = current.queryParams;
            var fqParamsCount = fqParams ? this.getSize(fqParams) : 0;
            var cqParamsCount = cqParams ? this.getSize(cqParams) : 0;
            if (fqParamsCount === 0 && cqParamsCount === 0) {
                return true;
            }
            if (fqParamsCount !== cqParamsCount) {
                return false;
            }
            return JSON.stringify(fqParams) === JSON.stringify(cqParams);
        }
        catch (e) {
            return false;
        }
    };
    // DefaultRouteReuseStrategy : Begin
    WmDefaultRouteReuseStrategy.prototype.shouldDetach = function (route) {
        return !!route.data['__wm_page_reuse'];
    };
    WmDefaultRouteReuseStrategy.prototype.shouldAttach = function (route) {
        var key = this.getKey(route);
        this.currentRouteKey = key;
        return this.cache.has(key);
    };
    WmDefaultRouteReuseStrategy.prototype.store = function (route, handle) {
        if (!!route.data['__wm_page_reuse']) {
            var key = this.getKey(route);
            if (key) {
                this.cache.set(key, handle);
            }
        }
    };
    WmDefaultRouteReuseStrategy.prototype.retrieve = function (route) {
        var key = this.getKey(route);
        return this.cache.get(key);
    };
    WmDefaultRouteReuseStrategy.prototype.reset = function () {
        return this.cache.clear();
    };
    return WmDefaultRouteReuseStrategy;
}());
/* Custom Strategy specifically for preview & WaveMaker Deployments */
var WmRouteReuseStrategy = /** @class */ (function (_super) {
    __extends(WmRouteReuseStrategy, _super);
    function WmRouteReuseStrategy(maxCacheSize, maxCacheAge) {
        return _super.call(this, maxCacheSize, maxCacheAge) || this;
    }
    WmRouteReuseStrategy.prototype.isSameRoute = function (future, current) {
        // Incase of prefab project we have only one route So reloading the route everytime
        if (future.routeConfig && future.routeConfig.path === 'prefab-preview') {
            return false;
        }
        /*
        In WM Deployment, Navigation is handled by PageWrapperComponent
                          & Route Info is passed as a parameter
        */
        var fParams = future.params;
        var cParams = current.params;
        var fParamsCount = this.getSize(fParams);
        var cParamsCount = this.getSize(cParams);
        if (fParamsCount === 0 && cParamsCount === 0) {
            return true;
        }
        if (fParamsCount !== cParamsCount) {
            return false;
        }
        if (fParams['pageName'] === cParams['pageName']) {
            return this.isSameQueryParams(future, current);
        }
        return false;
    };
    WmRouteReuseStrategy.prototype.shouldReuseRoute = function (future, current) {
        return this.isSameRoute(future, current);
    };
    WmRouteReuseStrategy = __decorate([
        __param(0, Inject(MAX_CACHE_SIZE)),
        __param(1, Inject(MAX_CACHE_AGE)),
        __metadata("design:paramtypes", [Number, Number])
    ], WmRouteReuseStrategy);
    return WmRouteReuseStrategy;
}(WmDefaultRouteReuseStrategy));
/* Custom Strategy specifically for Angular Deployments */
var WmNgRouteReuseStrategy = /** @class */ (function (_super) {
    __extends(WmNgRouteReuseStrategy, _super);
    function WmNgRouteReuseStrategy(maxCacheSize, maxCacheAge) {
        return _super.call(this, maxCacheSize, maxCacheAge) || this;
    }
    WmNgRouteReuseStrategy.prototype.isSameRoute = function (future, current) {
        /*
        In Angular Deployment, Navigation is handled by Angular
                               & Route Info is passed by routeConfig
        */
        if (!future.routeConfig && !current.routeConfig) {
            return true;
        }
        if (future.routeConfig !== current.routeConfig) {
            return false;
        }
        if (future.routeConfig === current.routeConfig) {
            return this.isSameQueryParams(future, current);
        }
        return true;
    };
    WmNgRouteReuseStrategy.prototype.shouldReuseRoute = function (future, current) {
        return this.isSameRoute(future, current);
    };
    WmNgRouteReuseStrategy = __decorate([
        __param(0, Inject(MAX_CACHE_SIZE)),
        __param(1, Inject(MAX_CACHE_AGE)),
        __metadata("design:paramtypes", [Number, Number])
    ], WmNgRouteReuseStrategy);
    return WmNgRouteReuseStrategy;
}(WmDefaultRouteReuseStrategy));

var POST_MESSAGES;
(function (POST_MESSAGES) {
    POST_MESSAGES["HIDE_TEMPLATES_SHOW_CASE"] = "hide-templates-show-case";
    POST_MESSAGES["SHOW_TEMPLATES_SHOW_CASE"] = "show-templates-show-case";
    POST_MESSAGES["UPDATE_LOCATION"] = "update-location-path";
    POST_MESSAGES["SELECT_TEMPLATE"] = "select-template";
    POST_MESSAGES["TEMPLATEBUNDLE_CONFIG"] = "template-bundle-config";
    POST_MESSAGES["ON_LOAD"] = "on-load";
})(POST_MESSAGES || (POST_MESSAGES = {}));
var AppManagerService = /** @class */ (function () {
    function AppManagerService($http, $security, $dialog, $router, $app, $variables, $metadata, $spinner, $i18n, $datePipe, routeReuseStrategy) {
        var _this = this;
        this.$http = $http;
        this.$security = $security;
        this.$dialog = $dialog;
        this.$router = $router;
        this.$app = $app;
        this.$variables = $variables;
        this.$metadata = $metadata;
        this.$spinner = $spinner;
        this.$i18n = $i18n;
        this.$datePipe = $datePipe;
        this.routeReuseStrategy = routeReuseStrategy;
        this.appVariablesLoaded = false;
        this.appVariablesFired = false;
        this._noRedirect = false;
        // register method to invoke on session timeout
        this.$http.registerOnSessionTimeout(this.handle401.bind(this));
        this.$variables.registerDependency('appManager', this);
        this.$app.subscribe('toggle-variable-state', function (data) {
            var variable = data.variable, active = data.active;
            if (!_.isEmpty(_.trim(variable.spinnerContext))) {
                if (active) {
                    variable._spinnerId = variable._spinnerId || [];
                    var spinnerId = _this.$spinner.show(variable.spinnerMessage, variable._id + '_' + Date.now(), variable.spinnerclass, variable.spinnerContext);
                    variable._spinnerId.push(spinnerId);
                }
                else {
                    _this.$spinner.hide(variable._spinnerId.shift());
                }
            }
        });
        this.$app.subscribe('userLoggedIn', function () {
            _this.setLandingPage();
            if (_this.lastLoggedUserId) {
                _this.$security.getConfig(function (config) {
                    if (config && config.userInfo.userId !== _this.lastLoggedUserId) {
                        _this.clearCache();
                    }
                }, null);
            }
        });
        this.$app.subscribe('userLoggedOut', function () { return _this.setLandingPage().then(function () {
            _this.clearCache();
            // navigate to the landing page without reloading the window in device.
            if (window['cordova']) {
                _this.$router.navigate(["/"]);
            }
        }); });
        this.$app.subscribe('http401', function (d) {
            if (d === void 0) { d = {}; }
            return _this.handle401(d.page, d.options);
        });
    }
    AppManagerService.prototype.clearCache = function () {
        if (this.routeReuseStrategy instanceof WmRouteReuseStrategy) {
            this.routeReuseStrategy.reset();
        }
    };
    /**
     * On session timeout, if the session timeout config is set to a dialog, then open login dialog
     */
    AppManagerService.prototype.showLoginDialog = function () {
        this.$spinner.hide('globalSpinner');
        // Removing the close all dialogs call, so the existing dialogs remain open and
        // the login dialog comes on top of it.
        this.$dialog.open('CommonLoginDialog');
        // Since the login dialog is closed and opened its updated property isn't read by angular.
        // Hence we trigger the digest cycle
        $appDigest();
    };
    AppManagerService.prototype.loadAppJS = function () {
    };
    AppManagerService.prototype.loadCommonPage = function () {
    };
    AppManagerService.prototype.loadSecurityConfig = function (forceFlag) {
        var _this = this;
        return this.$security.load(forceFlag).then(function (r) {
            if (!_this.$app.landingPageName) {
                _this.setLandingPage();
            }
            return r;
        });
    };
    AppManagerService.prototype.loadMetadata = function () {
        return this.$metadata.load();
    };
    AppManagerService.prototype.loadAppVariables = function (variables) {
        var _this = this;
        if (this.appVariablesLoaded) {
            return Promise.resolve();
        }
        var init = function (response) {
            var data = _this.$variables.register('app', response, _this.$app);
            // not assigning directly to this.$app to keep the reference in tact
            _.extend(_this.$app.Variables, data.Variables);
            _.extend(_this.$app.Actions, data.Actions);
            _this.updateLoggedInUserVariable();
            _this.updateSupportedLocaleVariable();
            _this.appVariablesLoaded = true;
            _this.appVariablesFired = false;
        };
        if (isDefined(variables)) {
            init(variables);
            return Promise.resolve();
        }
        return this.$http.get('./app.variables.json').then(function (response) { return init(response); });
    };
    /**
     * getter and setter for the property appVariablesFired
     * this flag determines if the app variables(with startUpdate:true) have been fired
     * they should get fired only once through app lifecycle
     * @param {boolean} isFired
     * @returns {boolean}
     */
    AppManagerService.prototype.isAppVariablesFired = function (isFired) {
        if (isDefined(isFired)) {
            this.appVariablesFired = isFired;
        }
        return this.appVariablesFired;
    };
    AppManagerService.prototype.clearLoggedInUserVariable = function (variable) {
        variable.isAuthenticated = false;
        variable.roles = [];
        variable.name = undefined;
        variable.id = undefined;
        variable.tenantId = undefined;
    };
    AppManagerService.prototype.updateLoggedInUserVariable = function () {
        var _this = this;
        var loggedInUser = _.get(this.$app, 'Variables.loggedInUser.dataSet');
        // sanity check
        if (!loggedInUser) {
            return;
        }
        return this.$security.load().then(function () {
            var securityConfig = _this.$security.get();
            if (securityConfig && securityConfig.securityEnabled && securityConfig.authenticated) {
                loggedInUser.isAuthenticated = securityConfig.authenticated;
                loggedInUser.roles = securityConfig.userInfo.userRoles;
                loggedInUser.name = securityConfig.userInfo.userName;
                loggedInUser.id = securityConfig.userInfo.userId;
                loggedInUser.tenantId = securityConfig.userInfo.tenantId;
                loggedInUser.userAttributes = securityConfig.userInfo.userAttributes; // assign the extra userAttributes for custom usage.
            }
            else {
                _this.clearLoggedInUserVariable(loggedInUser);
                loggedInUser.isSecurityEnabled = securityConfig && securityConfig.securityEnabled;
                throw null;
            }
            return securityConfig;
        }).catch(function (err) {
            loggedInUser.isAuthenticated = false;
            loggedInUser.roles = [];
            loggedInUser.name = undefined;
            loggedInUser.id = undefined;
            loggedInUser.tenantId = undefined;
            loggedInUser.userAttributes = {};
        });
    };
    /**
     * Overriding the app variable supported locale with the wmProperties i18n DataValues
     *
     * TODO[Vibhu]:
     * Can write a simple migration to sync the supportedLocale variable with '_WM_APP_PROPERTIES.supportedLanguages'
     * Hence, this may not be required
     *
     */
    AppManagerService.prototype.updateSupportedLocaleVariable = function () {
        var supportedLocaleVar = _.get(this.$app, 'Variables.supportedLocale');
    };
    AppManagerService.prototype.handleSSOLogin = function (config) {
        var _this = this;
        var SSO_URL = 'services/security/ssologin', PREVIEW_WINDOW_NAME = 'WM_PREVIEW_WINDOW';
        var page, pageParams;
        // do not provide redirectTo page if fetching HOME page resulted 401
        // on app load, by default Home page is loaded
        page = this.$security.getRedirectPage(config);
        if (CONSTANTS.hasCordova) {
            // get previously loggedInUser name (if any)
            var lastLoggedInUsername_1 = _.get(this.$security.get(), 'userInfo.userName');
            this.$security.authInBrowser()
                .then(function () { return _this.reloadAppData(); })
                .then(function () {
                var presentLoggedInUsername = _.get(_this.$security.get(), 'userInfo.userName');
                if (presentLoggedInUsername && presentLoggedInUsername === lastLoggedInUsername_1) {
                    routerService.navigate([page]);
                }
                else {
                    routerService.navigate(["/"]);
                }
            });
        }
        else {
            page = page ? '?redirectPage=' + encodeURIComponent(page) : '';
            pageParams = this.$security.getQueryString(this.$security.getRedirectedRouteQueryParams());
            pageParams = pageParams ? '?' + pageParams : '';
            // showing a redirecting message
            document.body.textContent = _.get(this.getAppLocale(), ['MESSAGE_LOGIN_REDIRECTION']) || 'Redirecting to sso login...';
            // appending redirect to page and page params
            var ssoUrl = this.getDeployedURL() + SSO_URL + page + pageParams;
            /*
             * remove iFrame when redirected to IdP login page.
             * this is being done as IDPs do not allow to get themselves loaded into iFrames.
             * remove-toolbar has been assigned with a window name WM_PREVIEW_WINDOW, check if the iframe is our toolbar related and
             * safely change the location of the parent toolbar with current url.
             */
            if (window.self !== window.top && window.parent.name === PREVIEW_WINDOW_NAME) {
                window.parent.location.href = window.self.location.href;
                window.parent.name = '';
            }
            else {
                window.location.href = ssoUrl;
            }
        }
    };
    /**
     * Handles the app when a XHR request returns 401 response
     * If no user was logged in before 401 occurred, First time Login is simulated
     * Else, a session timeout has occurred and the same is simulated
     * @param page  if provided, represents the page name for which XHR request returned 401, on re-login
     *              if not provided, a service request returned 401
     * @param onSuccess success handler
     * @param onError error handler
     */
    AppManagerService.prototype.handle401 = function (page, options) {
        var sessionTimeoutConfig, sessionTimeoutMethod, loginConfig, loginMethod;
        var LOGIN_METHOD = {
            'DIALOG': 'DIALOG',
            'PAGE': 'PAGE',
            'SSO': 'SSO'
        };
        var config = this.$security.get();
        var queryParamsObj = {};
        loginConfig = config.loginConfig;
        this.lastLoggedUserId = config.userInfo && config.userInfo.userId;
        // if user found, 401 was thrown after session time
        if (config.userInfo && config.userInfo.userName) {
            config.authenticated = false;
            sessionTimeoutConfig = loginConfig.sessionTimeout || { 'type': LOGIN_METHOD.DIALOG };
            sessionTimeoutMethod = sessionTimeoutConfig.type.toUpperCase();
            switch (sessionTimeoutMethod) {
                case LOGIN_METHOD.DIALOG:
                    this.showLoginDialog();
                    break;
                case LOGIN_METHOD.PAGE:
                    if (!page) {
                        page = this.$security.getCurrentRoutePage();
                    }
                    queryParamsObj['redirectTo'] = page;
                    // Adding query params(page params of page being redirected to) to the URL.
                    queryParamsObj = _.merge(queryParamsObj, this.$security.getRedirectedRouteQueryParams());
                    // the redirect page should not be same as session timeout login page
                    if (page !== sessionTimeoutConfig.pageName) {
                        this.$router.navigate([sessionTimeoutConfig.pageName], { queryParams: queryParamsObj });
                    }
                    break;
                case LOGIN_METHOD.SSO:
                    this.handleSSOLogin(config);
                    break;
            }
            this.setLandingPage();
        }
        else {
            // if no user found, 401 was thrown for first time login
            loginMethod = loginConfig.type.toUpperCase();
            switch (loginMethod) {
                case LOGIN_METHOD.DIALOG:
                    // Through loginDialog, user will remain in the current state and failed calls will be executed post login through LoginVariableService.
                    // NOTE: user will be redirected to respective landing page only if dialog is opened manually(not through a failed 401 call).
                    this.noRedirect(true);
                    this.showLoginDialog();
                    break;
                case LOGIN_METHOD.PAGE:
                    // do not provide redirectTo page if fetching HOME page resulted 401
                    // on app load, by default Home page is loaded
                    page = this.$security.getRedirectPage(config, page);
                    queryParamsObj['redirectTo'] = page;
                    var extraQueryParams = (options && options.queryParams) || this.$security.getRedirectedRouteQueryParams();
                    queryParamsObj = _.merge(queryParamsObj, extraQueryParams);
                    this.$router.navigate([loginConfig.pageName], { queryParams: queryParamsObj });
                    this.$app.landingPageName = loginConfig.pageName;
                    break;
                case LOGIN_METHOD.SSO:
                    this.handleSSOLogin(config);
                    break;
            }
        }
    };
    /**
     * Updates data dependent on logged in user
     * Reloads security config, metadata
     * Updates the loggedInUserVariable
     * @returns {Promise<void>}
     */
    AppManagerService.prototype.reloadAppData = function () {
        var _this = this;
        return this.loadSecurityConfig(true).then(function () {
            return _this.loadMetadata().then(function () {
                return _this.updateLoggedInUserVariable();
            });
        });
    };
    AppManagerService.prototype.noRedirect = function (value) {
        if (_.isUndefined(value)) {
            return this._noRedirect;
        }
        this._noRedirect = value;
        return this._noRedirect;
    };
    /**
     * invokes session failure requests
     */
    AppManagerService.prototype.executeSessionFailureRequests = function () {
        this.$http.executeSessionFailureRequests();
    };
    AppManagerService.prototype.pushToSessionFailureRequests = function (callback) {
        this.$http.pushToSessionFailureQueue(callback);
    };
    AppManagerService.prototype.getDeployedURL = function () {
        return this.$app.deployedUrl ? this.$app.deployedUrl : $rootScope.project.deployedUrl;
    };
    /**
     * Fetches the customurlscheme for a mobile app
     * which is used for redirection back to the app from browser in implicit oAuth flow
     * @returns {string}
     */
    AppManagerService.prototype.getCustomUrlScheme = function () {
        return this.$app.customUrlScheme;
    };
    AppManagerService.prototype.notify = function (eventName, data) {
        this.$app.notify(eventName, data);
    };
    AppManagerService.prototype.subscribe = function (eventName, data) {
        return this.$app.subscribe(eventName, data);
    };
    AppManagerService.prototype.getActivePage = function () {
        return this.$app.activePage;
    };
    AppManagerService.prototype.getAppLocale = function () {
        return this.$app.appLocale;
    };
    AppManagerService.prototype.getSelectedLocale = function () {
        return this.$i18n.getSelectedLocale();
    };
    AppManagerService.prototype.notifyApp = function (template, type, title) {
        this.$app.notifyApp(template, type, title);
    };
    /**
     * Triggers the onBeforeService method defined in app.js of the app
     * @param requestParams
     */
    AppManagerService.prototype.appOnBeforeServiceCall = function (requestParams) {
        return triggerFn(this.$app.onBeforeServiceCall, requestParams);
    };
    /**
     * Triggers the onServiceSuccess method defined in app.js of the app
     * @param data
     * @param xhrObj
     */
    AppManagerService.prototype.appOnServiceSuccess = function (data, xhrObj) {
        return triggerFn(this.$app.onServiceSuccess, data, xhrObj);
    };
    /**
     * Triggers the onServiceError method defined in app.js of the app
     * @param data
     * @param xhrOb
     */
    AppManagerService.prototype.appOnServiceError = function (data, xhrOb) {
        return triggerFn(this.$app.onServiceError, data, xhrOb);
    };
    /**
     * Triggers the appVariablesReady method defined in app.js of the app
     */
    AppManagerService.prototype.appVariablesReady = function () {
        triggerFn(this.$app.onAppVariablesReady);
    };
    /**
     * Returns the pipe based on the input
     */
    AppManagerService.prototype.getPipe = function (pipe) {
        if (pipe === 'date') {
            return this.$datePipe;
        }
    };
    AppManagerService.prototype.setLandingPage = function () {
        var _this = this;
        return this.$security.getPageByLoggedInUser().then(function (p) { return _this.$app.landingPageName = p; });
    };
    /**
     * return true if prefab type app
     * @returns {boolean}
     */
    AppManagerService.prototype.isPrefabType = function () {
        return this.$app.isPrefabType;
    };
    /**
     * return true if template bundle type app
     * @returns {boolean}
     */
    AppManagerService.prototype.isTemplateBundleType = function () {
        return this.$app.isTemplateBundleType;
    };
    AppManagerService.prototype.postMessage = function (content) {
        window.top.postMessage(content, '*');
    };
    AppManagerService.prototype.showTemplate = function (idx) {
        var template = this.templates[idx];
        // scope.activeTemplateIndex = idx;
        this.$router.navigate([template.id]);
    };
    AppManagerService.prototype.postTemplateBundleInfo = function () {
        var _this = this;
        window.onmessage = function (evt) {
            var msgData = evt.data;
            if (!_.isObject(msgData)) {
                return;
            }
            var key = msgData.key;
            switch (key) {
                case POST_MESSAGES.HIDE_TEMPLATES_SHOW_CASE:
                    // scope.hideShowCase = true;
                    break;
                case POST_MESSAGES.SELECT_TEMPLATE:
                    _this.showTemplate(msgData.templateIndex);
                    break;
            }
        };
        setTimeout(function () {
            _this.postMessage({ key: POST_MESSAGES.ON_LOAD });
        });
        return fetchContent('json', './config.json', true, function (response) {
            _this.templates = [];
            if (!response.error) {
                _this.templates = response.templates;
                _this.postMessage({ 'key': POST_MESSAGES.TEMPLATEBUNDLE_CONFIG, 'config': response });
            }
        });
    };
    AppManagerService.prototype.postAppTypeInfo = function () {
        if (this.isTemplateBundleType()) {
            return this.postTemplateBundleInfo();
        }
    };
    AppManagerService.SERVICE_NAME = 'AppManagerService';
    AppManagerService.ctorParameters = function () { return [
        { type: AbstractHttpService },
        { type: SecurityService },
        { type: AbstractDialogService },
        { type: Router },
        { type: App },
        { type: VariablesService },
        { type: MetadataService },
        { type: AbstractSpinnerService },
        { type: AbstractI18nService },
        { type: DatePipe },
        { type: RouteReuseStrategy }
    ]; };
    AppManagerService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [AbstractHttpService,
            SecurityService,
            AbstractDialogService,
            Router,
            App,
            VariablesService,
            MetadataService,
            AbstractSpinnerService,
            AbstractI18nService,
            DatePipe,
            RouteReuseStrategy])
    ], AppManagerService);
    return AppManagerService;
}());

var isPrefabInPreview = function (prefabName) { return prefabName === '__self__'; };
var getPrefabBaseUrl = function (prefabName) { return isPrefabInPreview(prefabName) ? '.' : "app/prefabs/" + prefabName; };
var getPrefabConfigUrl = function (prefabName) { return getPrefabBaseUrl(prefabName) + "/config.json"; };
var getPrefabMinJsonUrl = function (prefabName) { return getPrefabBaseUrl(prefabName) + "/pages/Main/page.min.json"; };

var prefabsWithError = new Set();
var inProgress = new Map();
var resolvedPrefabs = new Set();
var getPrefabResourceUrl = function (resourcePath, resourceBasePath) {
    var _url = resourcePath;
    if (!stringStartsWith(resourcePath, 'http://|https://|//')) {
        _url = (resourceBasePath + _url).replace('//', '/');
    }
    return _url;
};
var ɵ0 = getPrefabResourceUrl;
var PrefabManagerService = /** @class */ (function () {
    function PrefabManagerService($metadata, prefabConfigProvider) {
        this.$metadata = $metadata;
        this.prefabConfigProvider = prefabConfigProvider;
    }
    PrefabManagerService.prototype.getConfig = function (prefabName) {
        return this.prefabConfigProvider.getConfig(prefabName);
    };
    PrefabManagerService.prototype.loadServiceDefs = function (prefabName) {
        return isPrefabInPreview(prefabName) ? Promise.resolve() : this.$metadata.load(prefabName);
    };
    PrefabManagerService.prototype.loadStyles = function (prefabName, _a) {
        var styles = (_a === void 0 ? { resources: { styles: [] } } : _a).resources.styles;
        var baseUrl = getPrefabBaseUrl(prefabName);
        var _styles = styles.map(function (url) {
            if (!_.endsWith(url, '/pages/Main/Main.css')) {
                return getPrefabResourceUrl(url, baseUrl);
            }
            return undefined;
        }).filter(function (url) { return !!url; });
        loadStyleSheets(_styles);
        return Promise.resolve();
    };
    // TODO [Vinay] - implement onPrefabResourceLoad
    PrefabManagerService.prototype.loadScripts = function (prefabName, _a) {
        var scripts = (_a === void 0 ? { resources: { scripts: [] } } : _a).resources.scripts;
        var baseUrl = getPrefabBaseUrl(prefabName);
        var _scripts = scripts.map(function (url) { return getPrefabResourceUrl(url, baseUrl); });
        return loadScripts(_scripts, false);
    };
    PrefabManagerService.prototype.setInProgress = function (prefabName) {
        var _res;
        var _rej;
        var _promise = new Promise(function (res, rej) {
            _res = res;
            _rej = rej;
        });
        _promise.resolve = _res;
        _promise.reject = _rej;
        inProgress.set(prefabName, _promise);
    };
    PrefabManagerService.prototype.resolveInProgress = function (prefabName) {
        if (inProgress.get(prefabName)) {
            inProgress.get(prefabName).resolve();
            inProgress.delete(prefabName);
        }
    };
    PrefabManagerService.prototype.loadDependencies = function (prefabName) {
        var _this = this;
        if (resolvedPrefabs.has(prefabName)) {
            return Promise.resolve();
        }
        if (prefabsWithError.has(prefabName)) {
            return Promise.reject('');
        }
        if (inProgress.get(prefabName)) {
            return inProgress.get(prefabName);
        }
        this.setInProgress(prefabName);
        return this.getConfig(prefabName)
            .then(function (config) {
            return Promise.all([
                _this.loadStyles(prefabName, config),
                _this.loadScripts(prefabName, config),
                _this.loadServiceDefs(prefabName)
            ]).then(function () {
                _this.resolveInProgress(prefabName);
                resolvedPrefabs.add(prefabName);
            });
        });
    };
    PrefabManagerService.ctorParameters = function () { return [
        { type: MetadataService },
        { type: PrefabConfigProvider }
    ]; };
    PrefabManagerService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [MetadataService,
            PrefabConfigProvider])
    ], PrefabManagerService);
    return PrefabManagerService;
}());

var FragmentMonitor = /** @class */ (function () {
    function FragmentMonitor() {
        this.fragments = 0;
        this.fragmentsLoaded$ = new Subject();
    }
    FragmentMonitor.prototype.init = function () {
        // console.log(`inside fragmentMonitor: Page-${(this as any).pageName}, Partial-${(this as any).partialName}`);
        var _this = this;
        this.viewInit$.subscribe(noop$1, noop$1, function () {
            _this.isViewInitialized = true;
            _this.isReady();
        });
    };
    FragmentMonitor.prototype.registerFragment = function () {
        this.fragments++;
    };
    FragmentMonitor.prototype.resolveFragment = function () {
        this.fragments--;
        this.isReady();
    };
    FragmentMonitor.prototype.isReady = function () {
        if (this.isViewInitialized && !this.fragments) {
            this.registerFragment = noop$1;
            this.resolveFragment = noop$1;
            this.fragmentsLoaded$.complete();
        }
    };
    FragmentMonitor = __decorate([
        Directive(),
        __metadata("design:paramtypes", [])
    ], FragmentMonitor);
    return FragmentMonitor;
}());

var commonPartialWidgets = {};
var BasePartialComponent = /** @class */ (function (_super) {
    __extends(BasePartialComponent, _super);
    function BasePartialComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.compileContent = false;
        _this.destroy$ = new Subject();
        _this.viewInit$ = new Subject();
        return _this;
    }
    BasePartialComponent.prototype.getContainerWidgetInjector = function () {
        return this.containerWidget.inj || this.containerWidget.injector;
    };
    BasePartialComponent.prototype.init = function () {
        var _this = this;
        this.App = this.injector.get(App);
        this.containerWidget = this.injector.get(WidgetRef);
        this.i18nService = this.injector.get(AbstractI18nService);
        this.scriptLoaderService = this.injector.get(ScriptLoaderService);
        this.Viewport = this.injector.get(Viewport);
        if (this.getContainerWidgetInjector().view.component.registerFragment) {
            this.getContainerWidgetInjector().view.component.registerFragment();
        }
        this.initUserScript();
        this.registerWidgets();
        this.initVariables();
        this.activePageName = this.App.activePageName; // Todo: remove this
        this.registerPageParams();
        this.defineI18nProps();
        this.viewInit$.subscribe(noop$1, noop$1, function () {
            _this.pageParams = _this.containerWidget.partialParams;
        });
        this.pageDirective = this.injector.get(PageDirective, null);
        if (this.pageDirective) {
            this.registerDestroyListener(this.pageDirective.subscribe('attach', function (data) { return _this.ngOnAttach(data.refreshData); }));
            this.registerDestroyListener(this.pageDirective.subscribe('detach', function () { return _this.ngOnDetach(); }));
        }
        _super.prototype.init.call(this);
    };
    BasePartialComponent.prototype.registerWidgets = function () {
        if (this.partialName === 'Common') {
            this.Widgets = commonPartialWidgets;
        }
        else {
            this.Widgets = Object.create(commonPartialWidgets);
        }
        this.containerWidget.Widgets = this.Widgets;
    };
    BasePartialComponent.prototype.registerDestroyListener = function (fn) {
        this.destroy$.subscribe(noop$1, noop$1, function () { return fn(); });
    };
    BasePartialComponent.prototype.initUserScript = function () {
        try {
            this.evalUserScript(this, this.App, this.injector.get(UtilsService));
        }
        catch (e) {
            console.error("Error in evaluating partial (" + this.partialName + ") script\n", e);
        }
    };
    BasePartialComponent.prototype.initVariables = function () {
        var _this = this;
        var variablesService = this.injector.get(VariablesService);
        // get variables and actions instances for the page
        var variableCollection = variablesService.register(this.partialName, this.getVariables(), this);
        // create namespace for Variables nad Actions on page/partial, which inherits the Variables and Actions from App instance
        this.Variables = Object.create(this.App.Variables);
        this.Actions = Object.create(this.App.Actions);
        this.containerWidget.Variables = this.Variables;
        this.containerWidget.Actions = this.Actions;
        // assign all the page variables to the pageInstance
        Object.entries(variableCollection.Variables).forEach(function (_a) {
            var _b = __read(_a, 2), name = _b[0], variable = _b[1];
            return _this.Variables[name] = variable;
        });
        Object.entries(variableCollection.Actions).forEach(function (_a) {
            var _b = __read(_a, 2), name = _b[0], action = _b[1];
            return _this.Actions[name] = action;
        });
        this.viewInit$.subscribe(noop$1, noop$1, function () {
            // TEMP: triggering watchers so variables watching over params are updated
            $invokeWatchers(true, true);
            variableCollection.callback(variableCollection.Variables).catch(noop$1);
            variableCollection.callback(variableCollection.Actions);
        });
    };
    BasePartialComponent.prototype.registerPageParams = function () {
        this.pageParams = this.containerWidget.partialParams;
    };
    BasePartialComponent.prototype.defineI18nProps = function () {
        this.appLocale = this.i18nService.getAppLocale();
    };
    BasePartialComponent.prototype.invokeOnReady = function () {
        var params;
        if (this.containerWidget.userComponentParams) {
            params = this.containerWidget.userComponentParams;
        }
        this.onReady(params);
        if (this.getContainerWidgetInjector().view.component.resolveFragment) {
            this.getContainerWidgetInjector().view.component.resolveFragment();
        }
    };
    BasePartialComponent.prototype.loadScripts = function () {
        var _this = this;
        return new Promise(function (resolve) {
            var _a;
            var scriptsRequired = _this.partialDirective.$element.attr('scripts-to-load');
            if (scriptsRequired) {
                (_a = _this.scriptLoaderService).load.apply(_a, __spread(scriptsRequired.split(','))).then(resolve);
            }
            else {
                resolve();
            }
        });
    };
    BasePartialComponent.prototype.mute = function () {
        var m = function (o) { o && o.mute && o.mute(); };
        _.each(this.Widgets, m);
        _.each(this.Variables, m);
        _.each(this.Actions, m);
    };
    BasePartialComponent.prototype.unmute = function () {
        var um = function (o) { o && o.unmute && o.unmute(); };
        _.each(this.Widgets, um);
        _.each(this.Variables, um);
        _.each(this.Actions, um);
    };
    BasePartialComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.loadScripts().then(function () {
            _this.compileContent = true;
            setTimeout(function () {
                _this.viewInit$.complete();
                _this.fragmentsLoaded$.subscribe(noop$1, noop$1, function () { return _this.invokeOnReady(); });
            }, 100);
        });
    };
    BasePartialComponent.prototype.ngOnDestroy = function () {
        this.destroy$.complete();
    };
    BasePartialComponent.prototype.ngOnAttach = function (refreshData) {
        this.unmute();
        if (refreshData) {
            var refresh = function (v) { v && v.startUpdate && v.invoke && v.invoke(); };
            _.each(this.Variables, refresh);
            _.each(this.Actions, refresh);
        }
        _.each(this.Widgets, function (w) { return w && w.ngOnAttach && w.ngOnAttach(); });
    };
    BasePartialComponent.prototype.ngOnDetach = function () {
        this.mute();
        _.each(this.Widgets, function (w) { return w && w.ngOnDetach && w.ngOnDetach(); });
    };
    BasePartialComponent.prototype.onReady = function (params) {
    };
    __decorate([
        ViewChild(PartialDirective),
        __metadata("design:type", Object)
    ], BasePartialComponent.prototype, "partialDirective", void 0);
    BasePartialComponent = __decorate([
        Directive()
    ], BasePartialComponent);
    return BasePartialComponent;
}(FragmentMonitor));

var BasePageComponent = /** @class */ (function (_super) {
    __extends(BasePageComponent, _super);
    function BasePageComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.startupVariablesLoaded = false;
        _this.pageTransitionCompleted = false;
        _this.destroy$ = new Subject();
        _this.viewInit$ = new Subject();
        return _this;
    }
    BasePageComponent_1 = BasePageComponent;
    BasePageComponent.prototype.init = function () {
        muteWatchers();
        this.App = this.injector.get(App);
        this.route = this.injector.get(ActivatedRoute);
        this.appManager = this.injector.get(AppManagerService);
        this.navigationService = this.injector.get(AbstractNavigationService);
        this.scriptLoaderService = this.injector.get(ScriptLoaderService);
        this.i18nService = this.injector.get(AbstractI18nService);
        this.router = this.injector.get(Router);
        this.Viewport = this.injector.get(Viewport);
        this.initUserScript();
        this.registerWidgets();
        this.initVariables();
        this.App.lastActivePageName = this.App.activePageName;
        this.App.activePageName = this.pageName;
        this.App.activePage = this;
        this.activePageName = this.pageName; // Todo: remove this
        this.registerPageParams();
        this.defineI18nProps();
        _super.prototype.init.call(this);
    };
    BasePageComponent.prototype.registerWidgets = function () {
        // common partial widgets should be accessible from page
        this.Widgets = Object.create(commonPartialWidgets);
        // expose current page widgets on app
        this.App.Widgets = Object.create(this.Widgets);
    };
    BasePageComponent.prototype.initUserScript = function () {
        try {
            this.evalUserScript(this, this.App, this.injector.get(UtilsService));
        }
        catch (e) {
            console.error("Error in evaluating page (" + this.pageName + ") script\n", e);
        }
    };
    BasePageComponent.prototype.registerPageParams = function () {
        var _this = this;
        var subscription = this.route.queryParams.subscribe(function (params) { return _this.pageParams = _this.App.pageParams = _.extend({}, params); });
        this.registerDestroyListener(function () { return subscription.unsubscribe(); });
    };
    BasePageComponent.prototype.registerDestroyListener = function (fn) {
        this.destroy$.subscribe(noop$1, noop$1, function () { return fn(); });
    };
    BasePageComponent.prototype.defineI18nProps = function () {
        this.appLocale = this.i18nService.getAppLocale();
    };
    BasePageComponent.prototype.initVariables = function () {
        var _this = this;
        var variablesService = this.injector.get(VariablesService);
        // get variables and actions instances for the page
        var variableCollection = variablesService.register(this.pageName, this.getVariables(), this);
        // create namespace for Variables nad Actions on page/partial, which inherits the Variables and Actions from App instance
        this.Variables = Object.create(this.App.Variables);
        this.Actions = Object.create(this.App.Actions);
        // assign all the page variables to the pageInstance
        Object.entries(variableCollection.Variables).forEach(function (_a) {
            var _b = __read(_a, 2), name = _b[0], variable = _b[1];
            return _this.Variables[name] = variable;
        });
        Object.entries(variableCollection.Actions).forEach(function (_a) {
            var _b = __read(_a, 2), name = _b[0], action = _b[1];
            return _this.Actions[name] = action;
        });
        var subscription = this.viewInit$.subscribe(noop$1, noop$1, function () {
            if (!_this.appManager.isAppVariablesFired()) {
                variableCollection.callback(_this.App.Variables).catch(noop$1).then(function () {
                    _this.appManager.notify('app-variables-data-loaded', { pageName: _this.pageName });
                });
                variableCollection.callback(_this.App.Actions);
                _this.appManager.appVariablesReady();
                _this.appManager.isAppVariablesFired(true);
            }
            variableCollection.callback(variableCollection.Variables)
                .catch(noop$1)
                .then(function () {
                _this.appManager.notify('page-variables-data-loaded', { pageName: _this.pageName });
                _this.startupVariablesLoaded = true;
                // hide the loader only after the some setTimeout for smooth page load.
                setTimeout(function () {
                    _this.showPageContent = true;
                }, 100);
            });
            variableCollection.callback(variableCollection.Actions);
            subscription.unsubscribe();
        });
    };
    BasePageComponent.prototype.runPageTransition = function (transition) {
        var _this = this;
        transition = transition || this.navigationService.getPageTransition();
        var lastPage = BasePageComponent_1.lastPageSnapShot;
        return new Promise(function (resolve) {
            if (transition
                && !transition.startsWith('none')
                && lastPage) {
                var $target_1 = lastPage.parent();
                var onTransitionEnd_1 = function (e) {
                    if (resolve && !(e && e.pseudoElement)) {
                        $target_1.off('animationend', onTransitionEnd_1);
                        $target_1.removeClass(transition);
                        $target_1.children().first().remove();
                        resolve();
                        resolve = null;
                    }
                };
                transition = 'page-transition page-transition-' + transition;
                lastPage.addClass('page-exit');
                _this.$page.addClass('page-entry');
                $target_1.addClass(transition);
                $target_1.on('animationend', onTransitionEnd_1);
                // Wait for a maximum of 1 second for transition to end.
                setTimeout(onTransitionEnd_1, 1000);
            }
            else {
                resolve();
            }
        }).then(function () {
            _this.$page && _this.$page.removeClass('page-entry');
            if (lastPage) {
                lastPage.remove();
                BasePageComponent_1.lastPageSnapShot = null;
            }
            _this.pageTransitionCompleted = true;
        });
    };
    BasePageComponent.prototype.invokeOnReady = function () {
        this.onReady();
        this.appManager.notify('pageReady', { 'name': this.pageName, instance: this });
        (this.App.onPageReady || noop$1)(this.pageName, this);
    };
    BasePageComponent.prototype.loadScripts = function () {
        var _this = this;
        return new Promise(function (resolve) {
            var _a;
            var scriptsRequired = _this.pageDirective && _this.pageDirective.$element.attr('scripts-to-load');
            if (scriptsRequired) {
                (_a = _this.scriptLoaderService).load.apply(_a, __spread(scriptsRequired.split(','))).then(resolve);
            }
            else {
                resolve();
            }
        });
    };
    BasePageComponent.prototype.restoreLastPageSnapshot = function () {
        if (BasePageComponent_1.lastPageSnapShot && this.$page) {
            this.$page.parent().prepend(BasePageComponent_1.lastPageSnapShot);
        }
    };
    BasePageComponent.prototype.savePageSnapShot = function () {
        if (BasePageComponent_1.lastPageSnapShot) {
            BasePageComponent_1.lastPageSnapShot.remove();
        }
        if (this.$page) {
            BasePageComponent_1.lastPageSnapShot = this.$page.clone();
            this.$page.parents('app-root').prepend(BasePageComponent_1.lastPageSnapShot);
        }
    };
    BasePageComponent.prototype.saveScrollPosition = function () {
        var fn = function ($el, key, recursive, $target) {
            if (recursive === void 0) { recursive = true; }
            if ($target === void 0) { $target = $el; }
            if (recursive) {
                $el.children().each(function (i, v) { return fn($(v), key); });
            }
            var scrollData = {
                x: $target.scrollLeft(),
                y: $target.scrollTop()
            };
            if (scrollData.x > 0 || scrollData.y > 0) {
                $el.attr(key, scrollData.x + ',' + scrollData.y);
            }
        };
        fn(this.$page, 'data-scroll-position');
        this.$page.attr('data-window-scroll-position', window.scrollX + ',' + window.scrollY);
    };
    BasePageComponent.prototype.restoreScrollPosition = function () {
        var fn = function ($el, key, recursive, $target) {
            if (recursive === void 0) { recursive = true; }
            if ($target === void 0) { $target = $el; }
            var scrollData = ($el.attr(key) || '').split(',');
            if (scrollData.length > 1) {
                $target.scrollLeft(scrollData[0]);
                $target.scrollTop(scrollData[1]);
            }
            $el.removeAttr(key);
            if (recursive) {
                $el.children().each(function (i, v) { return fn($(v), key); });
            }
        };
        fn(this.$page, 'data-scroll-position');
        fn(this.$page, 'data-window-scroll-position', false, $(window));
    };
    /**
     * canDeactivate is called before a route change.
     * This will internally call onBeforePageLeave method present
     * at page level and app level in the application and decide
     * whether to change route or not based on return value.
     */
    BasePageComponent.prototype.canDeactivate = function () {
        var retVal;
        // Calling onBeforePageLeave method present at page level
        retVal = this.onBeforePageLeave();
        // Calling onBeforePageLeave method present at app level only if page level method return true
        // or if there is no page level method
        if (retVal !== false) {
            retVal = (this.App.onBeforePageLeave || noop$1)(this.App.activePageName, this.App.activePage);
        }
        return retVal === undefined ? true : retVal;
    };
    BasePageComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.route.snapshot.data['__wm_page_reuse'] = this.canReuse();
        if (this.pageDirective) {
            this.$page = this.pageDirective.$element.parent();
            if (isIos()) {
                this.$page.addClass('ios-page');
            }
            if (isAndroid()) {
                this.$page.addClass('android-page');
            }
        }
        this.restoreLastPageSnapshot();
        this.loadScripts().then(function () {
            _this.runPageTransition()
                .then(function () {
                _this.compilePageContent = true;
                setTimeout(function () {
                    _this.onPageContentReady = function () {
                        _this.fragmentsLoaded$.subscribe(noop$1, noop$1, function () {
                            _this.invokeOnReady();
                        });
                        unMuteWatchers();
                        _this.viewInit$.complete();
                        _this.onPageContentReady = noop$1;
                    };
                }, 0);
            });
        });
    };
    BasePageComponent.prototype.ngOnDestroy = function () {
        this.savePageSnapShot();
        this.destroy$.complete();
    };
    BasePageComponent.prototype.onReady = function () { };
    BasePageComponent.prototype.onBeforePageLeave = function () { };
    BasePageComponent.prototype.onPageContentReady = function () { };
    BasePageComponent.prototype.canReuse = function () {
        return !!(this.pageDirective && this.pageDirective.cache);
    };
    BasePageComponent.prototype.mute = function () {
        var m = function (o) { o && o.mute && o.mute(); };
        _.each(this.Widgets, m);
        _.each(this.Variables, m);
        _.each(this.Actions, m);
    };
    BasePageComponent.prototype.unmute = function (c) {
        if (c === void 0) { c = this; }
        var um = function (o) { o && o.unmute && o.unmute(); };
        _.each(this.Widgets, um);
        _.each(this.Variables, um);
        _.each(this.Actions, um);
    };
    BasePageComponent.prototype.ngOnAttach = function () {
        var _this = this;
        this.route.snapshot.data['__wm_page_reuse'] = this.canReuse();
        this.registerPageParams();
        this.App.lastActivePageName = this.App.activePageName;
        this.App.activePageName = this.pageName;
        this.App.activePage = this;
        this.activePageName = this.pageName;
        this.restoreLastPageSnapshot();
        this.unmute();
        // expose current page widgets on app
        this.App.Widgets = Object.create(this.Widgets);
        if (this.pageDirective && this.pageDirective.refreshdataonattach) {
            var refresh = function (v) { v && v.startUpdate && v.invoke && v.invoke(); };
            _.each(this.Variables, refresh);
            _.each(this.Actions, refresh);
        }
        this.runPageTransition().then(function () {
            setTimeout(function () { return _this.restoreScrollPosition(); }, 100);
            _.each(_this.Widgets, function (w) { return w && w.ngOnAttach && w.ngOnAttach(); });
            _this.appManager.notify('pageAttach', { 'name': _this.pageName, instance: _this });
        });
    };
    BasePageComponent.prototype.ngOnDetach = function () {
        this.saveScrollPosition();
        this.savePageSnapShot();
        this.mute();
        _.each(this.Widgets, function (w) { return w && w.ngOnDetach && w.ngOnDetach(); });
        this.appManager.notify('pageDetach', { 'name': this.pageName, instance: this });
    };
    BasePageComponent.clear = function () {
        if (BasePageComponent_1.lastPageSnapShot) {
            BasePageComponent_1.lastPageSnapShot.remove();
            BasePageComponent_1.lastPageSnapShot = null;
        }
    };
    var BasePageComponent_1;
    BasePageComponent.lastPageSnapShot = null;
    __decorate([
        ViewChild(PageDirective),
        __metadata("design:type", Object)
    ], BasePageComponent.prototype, "pageDirective", void 0);
    __decorate([
        HostListener('window:beforeunload'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], BasePageComponent.prototype, "canDeactivate", null);
    BasePageComponent = BasePageComponent_1 = __decorate([
        Directive()
    ], BasePageComponent);
    return BasePageComponent;
}(FragmentMonitor));

var BasePrefabComponent = /** @class */ (function (_super) {
    __extends(BasePrefabComponent, _super);
    function BasePrefabComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.compileContent = false;
        _this.destroy$ = new Subject();
        _this.viewInit$ = new Subject();
        return _this;
    }
    BasePrefabComponent.prototype.getContainerWidgetInjector = function () {
        return this.containerWidget.inj || this.containerWidget.injector;
    };
    BasePrefabComponent.prototype.init = function () {
        var _this = this;
        this.App = this.injector.get(App);
        this.containerWidget = this.injector.get(WidgetRef);
        this.prefabMngr = this.injector.get(PrefabManagerService);
        this.i18nService = this.injector.get(AbstractI18nService);
        this.scriptLoaderService = this.injector.get(ScriptLoaderService);
        this.Viewport = this.injector.get(Viewport);
        if (this.getContainerWidgetInjector().view.component.registerFragment) {
            this.getContainerWidgetInjector().view.component.registerFragment();
        }
        this.pageDirective = this.injector.get(PageDirective, null);
        if (this.pageDirective) {
            this.registerDestroyListener(this.pageDirective.subscribe('attach', function (data) { return _this.ngOnAttach(data.refreshData); }));
            this.registerDestroyListener(this.pageDirective.subscribe('detach', function () { return _this.ngOnDetach(); }));
        }
        this.initUserScript();
        this.registerWidgets();
        this.initVariables();
        this.registerProps();
        this.defineI18nProps();
        _super.prototype.init.call(this);
    };
    BasePrefabComponent.prototype.registerWidgets = function () {
        this.Widgets = {};
        this.Widgets = {};
        this.containerWidget.Widgets = this.Widgets;
    };
    BasePrefabComponent.prototype.initUserScript = function () {
        try {
            this.evalUserScript(this, this.App, this.injector.get(UtilsService));
        }
        catch (e) {
            console.error("Error in evaluating prefab (" + this.prefabName + ") script\n", e);
        }
    };
    BasePrefabComponent.prototype.registerChangeListeners = function () {
        this.containerWidget.registerPropertyChangeListener(this.onPropertyChange);
        this.containerWidget.registerStyleChangeListener(this.onPropertyChange);
    };
    BasePrefabComponent.prototype.registerDestroyListener = function (fn) {
        this.destroy$.subscribe(noop$1, noop$1, function () { return fn(); });
    };
    BasePrefabComponent.prototype.defineI18nProps = function () {
        this.appLocale = this.i18nService.getPrefabLocaleBundle(this.prefabName);
    };
    BasePrefabComponent.prototype.registerProps = function () {
        var _this = this;
        this.prefabMngr.getConfig(this.prefabName)
            .then(function (config) {
            if (config) {
                _this.displayName = config.displayName;
                Object.entries((config.properties || {}))
                    .forEach(function (_a) {
                    var _b = __read(_a, 2), key = _b[0], prop = _b[1];
                    var expr;
                    var value = _.trim(prop.value);
                    if (_.startsWith(value, 'bind:')) {
                        expr = value.replace('bind:', '');
                    }
                    Object.defineProperty(_this, key, {
                        get: function () { return _this.containerWidget[key]; },
                        set: function (nv) { return _this.containerWidget.widget[key] = nv; }
                    });
                    if (expr) {
                        _this.registerDestroyListener($watch(expr, _this, {}, function (nv) { return _this.containerWidget.widget[key] = nv; }));
                    }
                });
                Object.entries((config.events || {}))
                    .forEach(function (_a) {
                    var _b = __read(_a, 2), key = _b[0], prop = _b[1];
                    _this[key] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        var eventName = key.substr(2).toLowerCase();
                        _this.containerWidget.invokeEventCallback(eventName, { $event: args[0], $data: args[1] });
                    };
                });
                Object.entries((config.methods || {}))
                    .forEach(function (_a) {
                    var _b = __read(_a, 2), key = _b[0], prop = _b[1];
                    _this.containerWidget[key] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        try {
                            if (_this[key]) {
                                return _this[key].apply(_this, args);
                            }
                        }
                        catch (e) {
                            console.warn("error in executing prefab-" + _this.prefabName + " method-" + key);
                        }
                    };
                });
            }
            _this.containerWidget.setProps(config);
            // Reassigning the proxy handler for prefab inbound properties as we
            // will get them only after the prefab config call.
            if (isIE()) {
                _this.containerWidget.widget = _this.containerWidget.createProxy();
            }
        });
    };
    BasePrefabComponent.prototype.initVariables = function () {
        var _this = this;
        var variablesService = this.injector.get(VariablesService);
        // get variables and actions instances for the page
        var variableCollection = variablesService.register(this.prefabName, this.getVariables(), this);
        // create namespace for Variables nad Actions on page/partial, which inherits the Variables and Actions from App instance
        this.Variables = {};
        this.Actions = {};
        this.containerWidget.Variables = this.Variables;
        this.containerWidget.Actions = this.Actions;
        // assign all the page variables to the pageInstance
        Object.entries(variableCollection.Variables).forEach(function (_a) {
            var _b = __read(_a, 2), name = _b[0], variable = _b[1];
            return _this.Variables[name] = variable;
        });
        Object.entries(variableCollection.Actions).forEach(function (_a) {
            var _b = __read(_a, 2), name = _b[0], action = _b[1];
            return _this.Actions[name] = action;
        });
        this.viewInit$.subscribe(noop$1, noop$1, function () {
            variableCollection.callback(variableCollection.Variables).catch(noop$1);
            variableCollection.callback(variableCollection.Actions);
        });
    };
    BasePrefabComponent.prototype.invokeOnReady = function () {
        // triggering watchers so variables and propertiers watching over an expression are updated
        $invokeWatchers(true, true);
        this.onReady();
        if (this.getContainerWidgetInjector().view.component.resolveFragment) {
            this.getContainerWidgetInjector().view.component.resolveFragment();
        }
        this.containerWidget.invokeEventCallback('load');
    };
    BasePrefabComponent.prototype.loadScripts = function () {
        var _this = this;
        return new Promise(function (resolve) {
            var _a;
            var scriptsRequired = _this.prefabContainerDirective.$element.attr('scripts-to-load');
            if (scriptsRequired) {
                (_a = _this.scriptLoaderService).load.apply(_a, __spread(scriptsRequired.split(','))).then(resolve);
            }
            else {
                resolve();
            }
        });
    };
    BasePrefabComponent.prototype.mute = function () {
        var m = function (o) { o && o.mute && o.mute(); };
        _.each(this.Widgets, m);
        _.each(this.Variables, m);
        _.each(this.Actions, m);
    };
    BasePrefabComponent.prototype.unmute = function () {
        var um = function (o) { o && o.unmute && o.unmute(); };
        _.each(this.Widgets, um);
        _.each(this.Variables, um);
        _.each(this.Actions, um);
    };
    BasePrefabComponent.prototype.ngOnAttach = function (refreshData) {
        this.unmute();
        if (refreshData) {
            var refresh = function (v) { v && v.startUpdate && v.invoke && v.invoke(); };
            _.each(this.Variables, refresh);
            _.each(this.Actions, refresh);
        }
        _.each(this.Widgets, function (w) { return w && w.ngOnAttach && w.ngOnAttach(); });
    };
    BasePrefabComponent.prototype.ngOnDetach = function () {
        this.mute();
        _.each(this.Widgets, function (w) { return w && w.ngOnDetach && w.ngOnDetach(); });
    };
    BasePrefabComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.loadScripts().then(function () {
            _this.compileContent = true;
            _this.registerChangeListeners();
            setTimeout(function () {
                // trigger viewInit$.complete after a timeout so that the widget listeners are ready before Variable xhr call.
                _this.viewInit$.complete();
                _this.fragmentsLoaded$.subscribe(noop$1, noop$1, function () { return _this.invokeOnReady(); });
            }, 100);
        });
    };
    BasePrefabComponent.prototype.ngOnDestroy = function () {
        this.destroy$.complete();
    };
    // user overrides this
    BasePrefabComponent.prototype.onPropertyChange = function () { };
    BasePrefabComponent.prototype.onReady = function () { };
    __decorate([
        ViewChild(PrefabContainerDirective),
        __metadata("design:type", Object)
    ], BasePrefabComponent.prototype, "prefabContainerDirective", void 0);
    BasePrefabComponent = __decorate([
        Directive()
    ], BasePrefabComponent);
    return BasePrefabComponent;
}(FragmentMonitor));

var USER_ROLE;
(function (USER_ROLE) {
    USER_ROLE["EVERYONE"] = "Everyone";
    USER_ROLE["ANONYMOUS"] = "Anonymous";
    USER_ROLE["AUTHENTICATED"] = "Authenticated";
})(USER_ROLE || (USER_ROLE = {}));
var AccessrolesDirective = /** @class */ (function () {
    function AccessrolesDirective(templateRef, viewContainerRef, securityService, inj) {
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        this.securityService = securityService;
        this.inj = inj;
        this.processed = false;
        var securityConfig = this.securityService.get();
        this.securityEnabled = _.get(securityConfig, 'securityEnabled');
        this.isUserAuthenticated = _.get(securityConfig, 'authenticated');
        this.userRoles = _.get(securityConfig, 'userInfo.userRoles');
    }
    /**
     * Returns array of roles from comma separated string of roles
     * Handles encoded commas
     * @param val
     * @returns {any}
     */
    AccessrolesDirective.prototype.getWidgetRolesArrayFromStr = function (val) {
        var UNICODE_COMMA_REGEX = /&#44;/g;
        val = val || '';
        if (val === '') {
            return [];
        }
        // replace the unicode equivalent of comma with comma
        return _.split(val, ',').map(function (v) {
            return _.trim(v).replace(UNICODE_COMMA_REGEX, ',');
        });
    };
    /**
     * Returns true if roles in first arrays is
     * @param widgetRoles
     * @param userRoles
     * @returns {any}
     */
    AccessrolesDirective.prototype.matchRoles = function (widgetRoles, userRoles) {
        return widgetRoles.some(function (item) {
            return _.includes(userRoles, item);
        });
    };
    /**
     * Decides whether the current logged in user has access to widget or not
     * @param widgetRoles
     * @param userRoles
     * @returns {any}
     */
    AccessrolesDirective.prototype.hasAccessToWidget = function (widgetRoles, userRoles) {
        // access the widget when 'Everyone' is chosen
        if (_.includes(widgetRoles, USER_ROLE.EVERYONE)) {
            return true;
        }
        // access the widget when 'Anonymous' is chosen and user is not authenticated
        if (_.includes(widgetRoles, USER_ROLE.ANONYMOUS) && !this.isUserAuthenticated) {
            return true;
        }
        // access the widget when 'Only Authenticated Users' is chosen and user is authenticated
        if (_.includes(widgetRoles, USER_ROLE.AUTHENTICATED) && this.isUserAuthenticated) {
            return true;
        }
        // access the widget when widget role and logged in user role matches
        return this.isUserAuthenticated && this.matchRoles(widgetRoles, userRoles);
    };
    Object.defineProperty(AccessrolesDirective.prototype, "accessroles", {
        set: function (roles) {
            // flag to compute the directive only once
            if (this.processed) {
                return;
            }
            this.processed = true;
            var widgetRoles = this.getWidgetRolesArrayFromStr(roles);
            var isAccessible = !this.securityEnabled || this.hasAccessToWidget(widgetRoles, this.userRoles);
            if (isAccessible) {
                // [WMS-19294] pass on the previous context as second param.
                this.viewContainerRef.createEmbeddedView(this.templateRef, this.inj.view.context);
            }
            else {
                this.viewContainerRef.clear();
            }
        },
        enumerable: true,
        configurable: true
    });
    AccessrolesDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: SecurityService },
        { type: Injector }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], AccessrolesDirective.prototype, "accessroles", null);
    AccessrolesDirective = __decorate([
        Directive({
            selector: '[accessroles]'
        }),
        __metadata("design:paramtypes", [TemplateRef,
            ViewContainerRef,
            SecurityService,
            Injector])
    ], AccessrolesDirective);
    return AccessrolesDirective;
}());

var AppSpinnerComponent = /** @class */ (function () {
    function AppSpinnerComponent() {
    }
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], AppSpinnerComponent.prototype, "show", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], AppSpinnerComponent.prototype, "spinnermessages", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AppSpinnerComponent.prototype, "classname", void 0);
    AppSpinnerComponent = __decorate([
        Component({
            selector: 'app-spinner',
            template: "\n        <div class=\"app-spinner\" [ngClass]=\"classname\" *ngIf=\"show\">\n            <div class=\"spinner-message\" aria-label=\"loading gif\">\n                <i class=\"spinner-image animated infinite fa fa-circle-o-notch fa-spin\"></i>\n                <div class=\"spinner-messages\">\n                    <p *ngFor=\"let value of spinnermessages\" [textContent]=\"value\"></p>\n                </div>\n            </div>\n        </div>\n    "
        }),
        __metadata("design:paramtypes", [])
    ], AppSpinnerComponent);
    return AppSpinnerComponent;
}());

var CustomToasterComponent = /** @class */ (function (_super) {
    __extends(CustomToasterComponent, _super);
    // constructor is only necessary when not using AoT
    function CustomToasterComponent(toastrService, toastPackage) {
        var _this = _super.call(this, toastrService, toastPackage) || this;
        _this.toastrService = toastrService;
        _this.toastPackage = toastPackage;
        _this.watchers = [];
        _this.params = {};
        _this.pagename = _this.message || '';
        _this.generateParams();
        return _this;
    }
    // Generate the params for partial page. If bound, watch the expression and set the value
    CustomToasterComponent.prototype.generateParams = function () {
        var _this = this;
        _.forEach(this.options.partialParams, function (param) {
            if (_.isString(param.value) && param.value.indexOf('bind:') === 0) {
                _this.watchers.push($watch(param.value.substr(5), _this.options.context, {}, function (nv) {
                    _this.params[param.name] = nv;
                    $appDigest();
                }));
            }
            else {
                _this.params[param.name] = param.value;
            }
        });
    };
    CustomToasterComponent.prototype.generateDynamicComponent = function () {
        return __awaiter(this, void 0, void 0, function () {
            var $targetLayout;
            return __generator(this, function (_a) {
                $targetLayout = $('.parent-custom-toast');
                this.customToastRef.clear();
                $targetLayout[0].appendChild(this.customToastRef.createEmbeddedView(this.customToastTmpl).rootNodes[0]);
                return [2 /*return*/];
            });
        });
    };
    CustomToasterComponent.prototype.ngAfterViewInit = function () {
        this.generateDynamicComponent();
    };
    CustomToasterComponent.prototype.ngOnDestroy = function () {
        _.forEach(this.watchers, function (watcher) { return watcher(); });
        _super.prototype.ngOnDestroy.call(this);
    };
    CustomToasterComponent.ctorParameters = function () { return [
        { type: ToastrService },
        { type: ToastPackage }
    ]; };
    __decorate([
        ViewChild('customToast', { static: true, read: ViewContainerRef }),
        __metadata("design:type", ViewContainerRef)
    ], CustomToasterComponent.prototype, "customToastRef", void 0);
    __decorate([
        ViewChild('customToastTmpl'),
        __metadata("design:type", TemplateRef)
    ], CustomToasterComponent.prototype, "customToastTmpl", void 0);
    CustomToasterComponent = __decorate([
        Component({
            selector: '[custom-toaster-component]',
            template: "\n        <div class=\"parent-custom-toast\"></div>\n        <ng-container #customToast></ng-container>\n        <ng-template #customToastTmpl>\n            <div wmContainer partialContainer content.bind=\"pagename\">\n                <div *ngFor=\"let param of params | keyvalue\" wmParam hidden\n                    [name]=\"param.key\" [value]=\"param.value\"></div>\n            </div>\n        </ng-template>",
            preserveWhitespaces: false
        }),
        __metadata("design:paramtypes", [ToastrService,
            ToastPackage])
    ], CustomToasterComponent);
    return CustomToasterComponent;
}(Toast));

var EmptyPageComponent = /** @class */ (function () {
    function EmptyPageComponent(route, securityService, router, app, appManger) {
        this.route = route;
        this.securityService = securityService;
        this.router = router;
        this.app = app;
        this.appManger = appManger;
    }
    EmptyPageComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.app.isPrefabType) {
            // there is only one route
            this.router.navigate(['prefab-preview']);
        }
        else if (this.app.isApplicationType) {
            this.securityService.getPageByLoggedInUser().then(function (page) {
                _this.router.navigate([page]);
            });
        }
        else {
            this.router.navigate([getWmProjectProperties().homePage]);
            this.appManger.postAppTypeInfo();
        }
    };
    EmptyPageComponent.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: SecurityService },
        { type: Router },
        { type: App },
        { type: AppManagerService }
    ]; };
    EmptyPageComponent = __decorate([
        Component({
            selector: 'app-empty-page',
            template: '<div></div>'
        }),
        __metadata("design:paramtypes", [ActivatedRoute,
            SecurityService,
            Router,
            App,
            AppManagerService])
    ], EmptyPageComponent);
    return EmptyPageComponent;
}());

var PrefabDirective = /** @class */ (function () {
    function PrefabDirective(componentInstance, vcRef, elRef, prefabMngr, resolver, injector, componentRefProvider) {
        var _this = this;
        this.componentInstance = componentInstance;
        this.vcRef = vcRef;
        this.elRef = elRef;
        this.prefabMngr = prefabMngr;
        this.resolver = resolver;
        this.injector = injector;
        this.componentRefProvider = componentRefProvider;
        var prefabName = this.componentInstance.prefabName;
        this.prefabMngr.loadDependencies(prefabName)
            .then(function () { return __awaiter(_this, void 0, void 0, function () {
            var componentFactory, instanceRef;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.componentRefProvider.getComponentFactoryRef(prefabName, ComponentType.PREFAB)];
                    case 1:
                        componentFactory = _a.sent();
                        if (componentFactory) {
                            instanceRef = this.vcRef.createComponent(componentFactory, 0, injector);
                            this.elRef.nativeElement.appendChild(instanceRef.location.nativeElement);
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    }
    PrefabDirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Self }, { type: Inject, args: [WidgetRef,] }] },
        { type: ViewContainerRef },
        { type: ElementRef },
        { type: PrefabManagerService },
        { type: ComponentFactoryResolver },
        { type: Injector },
        { type: ComponentRefProvider }
    ]; };
    PrefabDirective = __decorate([
        Directive({
            selector: '[wmPrefab][prefabname]'
        }),
        __param(0, Self()), __param(0, Inject(WidgetRef)),
        __metadata("design:paramtypes", [Object, ViewContainerRef,
            ElementRef,
            PrefabManagerService,
            ComponentFactoryResolver,
            Injector,
            ComponentRefProvider])
    ], PrefabDirective);
    return PrefabDirective;
}());

var injectorMap = {
    DialogService: AbstractDialogService,
    i18nService: AbstractI18nService,
    statePersistence: StatePersistence,
    SpinnerService: AbstractSpinnerService,
    StatePersistenceService: StatePersistence,
    Viewport: Viewport,
    ToasterService: AbstractToasterService,
    Utils: UtilsService,
    CONSTANTS: ConstantService,
    FIELD_TYPE: FieldTypeService,
    FIELD_WIDGET: FieldWidgetService,
    DynamicComponentService: DynamicComponentRefProvider
};
var noop = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
};
var ɵ0$1 = noop;
// Wraps httpService to behave as angular 1.x $http service.
var getHttpDependency = function () {
    var httpService = this.httpService;
    var fn = function (key, options) {
        var args = Array.from(arguments).slice(1);
        return Promise.resolve(httpService[key].apply(httpService, args));
    };
    var $http = function () {
        return fn.apply(undefined, __spread(['send'], Array.from(arguments)));
    };
    ['get', 'post', 'head', 'put', 'delete', 'jsonp', 'patch'].forEach(function (key) { return $http[key] = fn.bind(undefined, key); });
    return $http;
};
var ɵ1 = getHttpDependency;
var AppRef = /** @class */ (function () {
    function AppRef(inj, i18nService, statePersistence, httpService, securityService) {
        this.inj = inj;
        this.i18nService = i18nService;
        this.statePersistence = statePersistence;
        this.httpService = httpService;
        this.securityService = securityService;
        this.Variables = {};
        this.Actions = {};
        this.onAppVariablesReady = noop;
        this.onSessionTimeout = noop;
        this.onPageReady = noop;
        this.onBeforePageLeave = noop;
        this.onBeforeServiceCall = noop;
        this.onServiceSuccess = noop;
        this.onServiceError = noop;
        this.dynamicComponentContainerRef = {};
        this.changeLocale = this.i18nService.setSelectedLocale.bind(this.i18nService);
        this.getSelectedLocale = this.i18nService.getSelectedLocale.bind(this.i18nService);
        this._eventNotifier = new EventNotifier();
        this.landingPageName = getWmProjectProperties().homePage;
        var wmProjectProperties = getWmProjectProperties();
        this.projectName = wmProjectProperties.name;
        this.isPrefabType = wmProjectProperties.type === "PREFAB" /* PREFAB */;
        this.isApplicationType = wmProjectProperties.type === "APPLICATION" /* APPLICATION */;
        this.isTemplateBundleType = wmProjectProperties.type === "TEMPLATEBUNDLE" /* TEMPLATE_BUNDLE */;
        this.httpService.registerOnSessionTimeout(this.on401.bind(this));
        this.appLocale = this.i18nService.getAppLocale();
        this.httpService.setLocale(this.appLocale);
    }
    AppRef.prototype.reload = function () {
        window.location.reload();
    };
    AppRef.prototype.notify = function (eventName) {
        var data = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            data[_i - 1] = arguments[_i];
        }
        this._eventNotifier.notify.apply(this._eventNotifier, arguments);
    };
    AppRef.prototype.getDependency = function (injToken) {
        if (isString(injToken)) {
            if (injToken === 'HttpService') {
                return getHttpDependency.call(this);
            }
            var providerInstance_1 = injectorMap[injToken] && this.inj.get(injectorMap[injToken]);
            if (!providerInstance_1 && this.inj['_providers']) {
                _.forEach(this.inj['_providers'], function (val) {
                    if (_.isObject(val)) {
                        if (val.__proto__.constructor.SERVICE_NAME === injToken) {
                            providerInstance_1 = val;
                            return false;
                        }
                    }
                });
            }
            return providerInstance_1;
        }
        return this.inj.get(injToken);
    };
    /**
     * triggers the onSessionTimeout callback in app.js
     */
    AppRef.prototype.on401 = function () {
        var userInfo = _.get(this.securityService.get(), 'userInfo');
        // if a previous user exists, a session time out triggered
        if (!_.isEmpty(userInfo)) {
            this.onSessionTimeout();
        }
    };
    AppRef.prototype.subscribe = function (eventName, callback) {
        return this._eventNotifier.subscribe(eventName, callback);
    };
    AppRef.prototype.notifyApp = function (template, type, title) {
        var notificationAction = _.get(this, 'Actions.appNotification');
        var EXCLUDE_NOTIFICATION_MESSAGES = ['PROCESS_REJECTED_IN_QUEUE'];
        var skipDefaultNotification = EXCLUDE_NOTIFICATION_MESSAGES.indexOf(template) !== -1;
        if (notificationAction) {
            // do not notify the error to the app, just throw it in console
            if (skipDefaultNotification) {
                console.warn('App Error', template);
                return;
            }
            type = type || 'success';
            template = notificationAction.getMessage() || template;
            notificationAction.invoke({
                message: template,
                title: isDefined(title) ? title : type.toUpperCase(),
                class: type,
                // If the type is error do not close the toastr
                duration: type.toUpperCase() === 'ERROR' ? 0 : undefined
            });
        }
        else {
            console.warn('The default Action "appNotification" doesn\'t exist in the app. App notified following error:\n', template);
        }
    };
    AppRef.ctorParameters = function () { return [
        { type: Injector },
        { type: AbstractI18nService },
        { type: StatePersistence },
        { type: AbstractHttpService },
        { type: SecurityService }
    ]; };
    AppRef = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Injector,
            AbstractI18nService,
            StatePersistence,
            AbstractHttpService,
            SecurityService])
    ], AppRef);
    return AppRef;
}());

var ToasterServiceImpl = /** @class */ (function (_super) {
    __extends(ToasterServiceImpl, _super);
    function ToasterServiceImpl(toaster) {
        var _this = _super.call(this) || this;
        _this.toaster = toaster;
        return _this;
    }
    ToasterServiceImpl.prototype._showToaster = function (type, title, desc, options) {
        // backward compatibility (in 9.x, 4th param is timeout value).
        if (_.isNumber(options)) {
            options = { timeOut: options };
        }
        options = options || {};
        options.timeOut = isDefined(options.timeOut) ? options.timeOut : 0;
        options.enableHtml = isDefined(options.enableHtml);
        options.positionClass = options.positionClass || 'toast-bottom-right';
        options.toastClass = 'toast';
        // pop the toaster only if either title or description are defined
        if (title || desc) {
            // if the desc is an object, stringify it.
            if (!options.bodyOutputType && _.isObject(desc)) {
                desc = JSON.stringify(desc);
            }
            var fn = this.toaster[type];
            if (fn) {
                return fn.call(this.toaster, desc, title, options);
            }
        }
    };
    ToasterServiceImpl.prototype.success = function (title, desc) {
        return this._showToaster('success', title, desc, { timeOut: 5000 });
    };
    ToasterServiceImpl.prototype.error = function (title, desc) {
        return this._showToaster('error', title, desc, { timeOut: 0 });
    };
    ToasterServiceImpl.prototype.info = function (title, desc) {
        return this._showToaster('info', title, desc, { timeOut: 0 });
    };
    ToasterServiceImpl.prototype.warn = function (title, desc) {
        return this._showToaster('warning', title, desc, { timeOut: 0 });
    };
    ToasterServiceImpl.prototype.show = function (type, title, desc, options) {
        return this._showToaster(type, title, desc, options);
    };
    ToasterServiceImpl.prototype.hide = function (toasterObj) {
        // in studio just ignore the toasterObj and hide all the toasters
        if (!toasterObj) {
            this.toaster.clear();
            return;
        }
        this.toaster.clear(toasterObj.toastId);
    };
    ToasterServiceImpl.prototype.showCustom = function (page, options) {
        if (!page) {
            return;
        }
        options = options || {};
        options.toastComponent = CustomToasterComponent;
        options.toastClass = 'custom-toaster';
        options.timeOut = isDefined(options.timeOut) ? options.timeOut : 0;
        options.enableHtml = isDefined(options.enableHtml);
        options.positionClass = options.positionClass || 'toast-bottom-right';
        options.toastClass = 'toast';
        return this.toaster.show(page, '', options);
    };
    /**
     * Updates the Global Toaster options based on the passed object. Useful in cases where
     * a user wants to display multiple toasts at the same time, newest on bottom etc
     * @param {options} Object
     */
    ToasterServiceImpl.prototype.setToasterConfig = function (options) {
        if (_.isObject(options)) {
            _.merge(this.toaster.toastrConfig, options);
        }
        else {
            console.warn('Please pass a valid options object, For Example : {maxOpened: 1, autoDismiss: true}');
        }
    };
    ToasterServiceImpl.ctorParameters = function () { return [
        { type: ToastrService }
    ]; };
    ToasterServiceImpl = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [ToastrService])
    ], ToasterServiceImpl);
    return ToasterServiceImpl;
}(AbstractToasterService));

var APP_LOCALE_ROOT_PATH = 'resources/i18n';
var RTL_LANGUAGE_CODES = ['ar', 'ar-001', 'ar-ae', 'ar-bh', 'ar-dz', 'ar-eg', 'ar-iq', 'ar-jo', 'ar-kw', 'ar-lb', 'ar-ly',
    'ar-ma', 'ar-om', 'ar-qa', 'ar-sa', 'ar-sd', 'ar-sy', 'ar-tn', 'ar-ye', 'arc', 'bcc', 'bqi', 'ckb', 'dv', 'fa', 'glk',
    'he', 'ku', 'mzn', 'pnb', 'ps', 'sd', 'ug', 'ur', 'yi'];
var I18nServiceImpl = /** @class */ (function (_super) {
    __extends(I18nServiceImpl, _super);
    function I18nServiceImpl($http, bsLocaleService, appDefaults) {
        var _this = _super.call(this) || this;
        _this.$http = $http;
        _this.bsLocaleService = bsLocaleService;
        _this.appDefaults = appDefaults;
        _this.defaultSupportedLocale = 'en';
        _this._isAngularLocaleLoaded = false;
        _this.appLocale = {};
        _this.prefabLocale = new Map();
        return _this;
    }
    I18nServiceImpl.prototype.updateLocaleDirection = function () {
        var direction = 'ltr';
        if (RTL_LANGUAGE_CODES.includes(this.selectedLocale)) {
            direction = 'rtl';
        }
        setCSS(document.body, 'direction', direction);
    };
    I18nServiceImpl.prototype.init = function () {
        this.messages = {};
        Object.setPrototypeOf(this.appLocale, this.messages);
    };
    I18nServiceImpl.prototype.getSelectedLocale = function () {
        return this.selectedLocale;
    };
    I18nServiceImpl.prototype.getDefaultSupportedLocale = function () {
        return this.defaultSupportedLocale;
    };
    I18nServiceImpl.prototype.getAppLocale = function () {
        return this.appLocale;
    };
    I18nServiceImpl.prototype.getPrefabLocaleBundle = function (prefabName) {
        if (!this.prefabLocale.has(prefabName)) {
            this.prefabLocale.set(prefabName, Object.create(this.appLocale));
        }
        return this.prefabLocale.get(prefabName);
    };
    I18nServiceImpl.prototype.extendPrefabMessages = function (messages) {
        var _this = this;
        if (!messages.prefabMessages) {
            return;
        }
        Object.keys(messages.prefabMessages).forEach(function (prefabName) {
            var bundle = _this.prefabLocale.get(prefabName);
            if (!bundle) {
                bundle = Object.create(_this.appLocale);
                _this.prefabLocale.set(prefabName, bundle);
            }
            Object.assign(bundle, messages.prefabMessages[prefabName]);
        });
    };
    I18nServiceImpl.prototype.extendMessages = function (messages) {
        Object.assign(this.messages, messages);
    };
    I18nServiceImpl.prototype.loadResource = function (path) {
        return this.$http.get(path)
            .toPromise()
            .catch(function () {
            console.warn("error loading locale resource from " + path);
            Promise.resolve({});
        });
    };
    I18nServiceImpl.prototype.loadAppLocaleBundle = function () {
        var _this = this;
        this.loadResource(APP_LOCALE_ROOT_PATH + "/" + this.selectedLocale + ".json")
            .then(function (bundle) {
            _this.extendMessages(bundle.messages);
            _this.extendPrefabMessages(bundle);
            _this.appDefaults.setFormats(bundle.formats);
        });
    };
    I18nServiceImpl.prototype.loadMomentLocaleBundle = function (momentLocale) {
        var _this = this;
        var _cdnUrl = _WM_APP_PROJECT.cdnUrl || _WM_APP_PROJECT.ngDest;
        if (this.selectedLocale === this.defaultSupportedLocale) {
            moment.locale(this.defaultSupportedLocale);
            return;
        }
        var path = _cdnUrl + ("locales/moment/" + momentLocale + ".js");
        this.$http.get(path, { responseType: 'text' })
            .toPromise()
            .then(function (response) {
            var fn = new Function(response);
            // Call the script. In script, moment defines the loaded locale
            fn();
            moment.locale(_this.selectedLocale);
            // For ngx bootstrap locale, get the config from script and apply locale
            var _config;
            fn.apply({ moment: { defineLocale: function (code, config) { return _config = config; } } });
            // TODO: Moved ngxBootstrap locale configuration to app.module.ts
            defineLocale(_this.selectedLocale, _config);
            _this.bsLocaleService.use(_this.getSelectedLocale() || _this.defaultSupportedLocale);
        });
    };
    I18nServiceImpl.prototype.loadAngularLocaleBundle = function (angLocale) {
        var _this = this;
        return new Promise(function (resolve) {
            var _cdnUrl = _WM_APP_PROJECT.cdnUrl || _WM_APP_PROJECT.ngDest;
            if (_this.selectedLocale === _this.defaultSupportedLocale) {
                resolve();
                return;
            }
            var path = _cdnUrl + ("locales/angular/" + angLocale + ".js");
            _this.$http.get(path, { responseType: 'text' })
                .toPromise()
                .then(function (response) {
                var module = {}, exports = {};
                module.exports = exports;
                var fn = new Function('module', 'exports', response);
                fn(module, exports);
                registerLocaleData(exports.default);
                _this._isAngularLocaleLoaded = true;
                resolve();
            }, function () { return resolve(); });
        });
    };
    I18nServiceImpl.prototype.loadCalendarLocaleBundle = function (calendarLocale, force) {
        if (force === void 0) { force = false; }
        var _cdnUrl = _WM_APP_PROJECT.cdnUrl || _WM_APP_PROJECT.ngDest;
        var path;
        if (calendarLocale) {
            path = _cdnUrl + ("locales/fullcalendar/" + calendarLocale + ".js");
        }
        else {
            return Promise.resolve();
        }
        // return in case of mobile app or if selected locale is default supported locale.
        if (!force && (isMobile() || isMobileApp() || this.selectedLocale === this.defaultSupportedLocale)) {
            return;
        }
        this.$http.get(path, { responseType: 'text' })
            .toPromise()
            .then(function (response) {
            var fn = new Function(response);
            // Call the script. In script, moment defines the loaded locale
            fn();
        });
    };
    I18nServiceImpl.prototype.loadLocaleBundles = function (libLocale) {
        if (libLocale.moment) {
            this.loadMomentLocaleBundle(libLocale.moment);
        }
        if (libLocale.fullCalendar && window['FullCalendar']) {
            this.loadCalendarLocaleBundle(libLocale.fullCalendar);
        }
        if (libLocale.angular) {
            this.loadAppLocaleBundle();
        }
        return this.loadAngularLocaleBundle(libLocale.angular);
    };
    I18nServiceImpl.prototype.setSelectedLocale = function (locale) {
        var _this = this;
        // check if the event is propagated from the select or any such widget
        if (_.isObject(locale)) {
            locale = locale.datavalue;
        }
        var libLocale = getWmProjectProperties().supportedLanguages[locale];
        var supportedLocale = Object.keys(getWmProjectProperties().supportedLanguages);
        if (!_.includes(supportedLocale, locale)) {
            return Promise.resolve();
        }
        if (!locale || locale === this.selectedLocale) {
            return Promise.resolve();
        }
        setSessionStorageItem('selectedLocale', locale);
        this.selectedLocale = locale;
        // reset the localeData object
        this.init();
        // load the locale bundles of the selected locale
        return this.loadLocaleBundles(libLocale).then(function () { return _this.updateLocaleDirection(); });
    };
    I18nServiceImpl.prototype.deduceAppLocale = function () {
        // computation to find app default locale
        var _acceptLang = this.getAcceptedLanguages();
        _acceptLang.push(getWmProjectProperties().defaultLanguage);
        var _supportedLang = Object.keys(getWmProjectProperties().supportedLanguages) || [this.defaultSupportedLocale];
        // check for the session storage to load any pre-requested locale
        var _defaultLang = getSessionStorageItem('selectedLocale') || _.intersection(_acceptLang, _supportedLang)[0] || this.defaultSupportedLocale;
        // if the supportedLocale is not available set it to defaultLocale
        _supportedLang = _supportedLang || [_defaultLang];
        var defaultLanguage = _defaultLang || _supportedLang[0];
        return defaultLanguage;
    };
    I18nServiceImpl.prototype.loadDefaultLocale = function () {
        var locale = this.deduceAppLocale();
        return this.setSelectedLocale(locale);
    };
    I18nServiceImpl.prototype.getLocalizedMessage = function (message) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return replace(this.appLocale[message], args);
    };
    // This function returns the accepted languages list
    I18nServiceImpl.prototype.getAcceptedLanguages = function () {
        var languages;
        if (CONSTANTS.hasCordova) {
            languages = navigator.languages || [navigator.language];
        }
        else {
            languages = getWmProjectProperties().preferredLanguage || '';
            /**
             * Accept-Language Header will contain set of supported locale, so try splitting the string to proper locale set
             * Ex: en,en-US;q=0.9,de;q=0.6,ar;q=0.2,hi
             *
             * Split the above into [en,en-us,de,ar,hi]
             * @type {Array}
             */
            languages = languages.split(',').map(function (locale) {
                return locale.split(';')[0];
            });
        }
        return _.map(languages, _.toLower);
    };
    I18nServiceImpl.prototype.initCalendarLocale = function () {
        if (this.selectedLocale !== 'en') {
            return this.loadCalendarLocaleBundle(this.selectedLocale, true);
        }
        return Promise.resolve();
    };
    I18nServiceImpl.prototype.isAngularLocaleLoaded = function () {
        return this._isAngularLocaleLoaded;
    };
    I18nServiceImpl.ctorParameters = function () { return [
        { type: HttpClient },
        { type: BsLocaleService },
        { type: AppDefaults }
    ]; };
    I18nServiceImpl = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient,
            BsLocaleService,
            AppDefaults])
    ], I18nServiceImpl);
    return I18nServiceImpl;
}(AbstractI18nService));

var spinnerTemplate = "<div class=\"app-spinner\">\n                            <div class=\"spinner-message\" aria-label=\"loading gif\">\n                                <i class=\"spinner-image animated infinite fa fa-circle-o-notch fa-spin\"></i>\n                                <div class=\"spinner-messages\">\n                                    <p class=\"spinner-messages-container\"></p>\n                               </div>\n                            </div>\n                         </div>";
var SpinnerServiceImpl = /** @class */ (function (_super) {
    __extends(SpinnerServiceImpl, _super);
    function SpinnerServiceImpl() {
        var _this = _super.call(this) || this;
        _this.spinnerId = 0;
        _this.messageSource = new Subject();
        _this.messagesByContext = {};
        return _this;
    }
    /**
     * returns the message source subject
     * @returns {Subject<any>}
     */
    SpinnerServiceImpl.prototype.getMessageSource = function () {
        return this.messageSource;
    };
    /**
     * show spinner on a container element
     */
    SpinnerServiceImpl.prototype.showContextSpinner = function (ctx, message, id) {
        var ctxMarkup = $('[name="' + ctx + '"]');
        this.messagesByContext[ctx] = this.messagesByContext[ctx] || {};
        // If the spinner already exists on the context
        // then just append the message to the existing spinner message
        // else add a new spinner
        if (Object.keys(this.messagesByContext[ctx]).length !== 0) {
            this.messagesByContext[ctx][id] = message;
            this.messagesByContext[ctx]['finalMessage'] = this.messagesByContext[ctx]['finalMessage'] + ' ' + this.messagesByContext[ctx][id];
            ctxMarkup.find('.spinner-messages-container').html(this.messagesByContext[ctx]['finalMessage']);
        }
        else {
            var ctxSpinnerTemp = $(spinnerTemplate);
            this.messagesByContext[ctx][id] = message;
            this.messagesByContext[ctx]['finalMessage'] = this.messagesByContext[ctx][id];
            ctxSpinnerTemp.find('.spinner-messages-container').html(this.messagesByContext[ctx]['finalMessage']);
            ctxMarkup.prepend(ctxSpinnerTemp);
        }
        return id;
    };
    /**
     * show the app spinner with provided message
     * @param msg
     * @returns {string}
     */
    SpinnerServiceImpl.prototype.showAppSpinner = function (msg, id) {
        var ctx = 'page';
        this.messagesByContext[ctx] = this.messagesByContext[ctx] || {};
        this.messagesByContext[ctx][id] = msg;
        this.messageSource.next({
            show: true,
            message: msg,
            messages: _.values(this.messagesByContext[ctx])
        });
    };
    /**
     * hides the spinner on a particular container(context)
     * @param ctx
     * @param id
     */
    SpinnerServiceImpl.prototype.hideContextSpinner = function (ctx, id) {
        delete this.messagesByContext[ctx][id];
        if (Object.keys(this.messagesByContext[ctx]).length === 1) {
            this.messagesByContext[ctx] = {};
        }
        var ctxMarkup = $('[name="' + ctx + '"]');
        ctxMarkup.find('.app-spinner').remove();
    };
    /**
     * show spinner
     * @param message
     * @param id
     * @param spinnerClass
     * @param spinnerContext
     * @param variableScopeId
     * @returns {any}
     */
    SpinnerServiceImpl.prototype.show = function (message, id, spinnerClass, spinnerContext, variableScopeId) {
        id = id || ++this.spinnerId;
        // if spinnerContext is passed, then append the spinner to the element(default method for variable calls).
        if (spinnerContext && spinnerContext !== 'page') {
            // return after the compiled spinner is appended to the element reference
            return this.showContextSpinner(spinnerContext, message, id);
        }
        this.showAppSpinner(message, id);
        return id;
    };
    /**
     * hide the spinner
     * @param spinnerId
     */
    SpinnerServiceImpl.prototype.hide = function (id) {
        // find the spinner context of the id from the messagesByContext
        var ctx = _.findKey(this.messagesByContext, function (obj) {
            return _.includes(_.keys(obj), id);
        }) || 'page';
        // if spinnerContext exists just remove the spinner from the reference and destroy the scope associated.
        if (ctx !== 'page') {
            this.hideContextSpinner(ctx, id);
            return;
        }
        if (id) {
            delete this.messagesByContext[ctx][id];
            var messages = _.values(this.messagesByContext[ctx]);
            this.messageSource.next({
                show: messages.length ? true : false,
                messages: _.values(this.messagesByContext[ctx])
            });
        }
        else {
            this.messagesByContext[ctx] = {};
        }
    };
    SpinnerServiceImpl = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [])
    ], SpinnerServiceImpl);
    return SpinnerServiceImpl;
}(AbstractSpinnerService));

var parentSelector = 'body >app-root';
var NavigationServiceImpl = /** @class */ (function () {
    function NavigationServiceImpl(app, router) {
        var _this = this;
        this.app = app;
        this.router = router;
        this.history = new History();
        this.isPageAddedToHistory = false;
        this.router.events.subscribe(function (event) {
            if (event instanceof NavigationStart) {
                var url = event.url;
                var urlParams_1 = {};
                var pageName = void 0;
                if (!_this.isPageAddedToHistory) {
                    _this.isPageAddedToHistory = false;
                    if (url.indexOf('?') > 0) {
                        url.substr(url.indexOf('?') + 1)
                            .split('&')
                            .forEach(function (s) {
                            var splits = s.split('=');
                            urlParams_1[splits[0]] = splits[1];
                        });
                        pageName = url.substr(0, url.indexOf('?'));
                    }
                    else {
                        pageName = url;
                    }
                    if (pageName[0] === '/') {
                        pageName = pageName.substr(1);
                    }
                    if (pageName) {
                        /*
                         * Commenting this code, one client project has Home_Page configured as Login Page.
                         * So redirection to Home_Page post login is failing
                         // if login page is being loaded and user is logged in, cancel that.
                            if ($rs.isApplicationType) {
                                stopLoginPagePostLogin($p);
                            }
                         */
                        delete urlParams_1['name'];
                        _this.history.push(new PageInfo(pageName, urlParams_1, _this.transition));
                    }
                }
            }
        });
    }
    NavigationServiceImpl.prototype.getPageTransition = function () {
        if (_.isEmpty(this.transition) || _.isEqual('none', this.transition)) {
            return null;
        }
        return this.transition;
    };
    /**
     * Navigates to particular page
     * @param pageName
     * @param options
     */
    NavigationServiceImpl.prototype.goToPage = function (pageName, options) {
        this.transition = options.transition || '';
        // page is added to stack only when currentPage is available.
        if (this.history.getCurrentPage()) {
            this.isPageAddedToHistory = true;
        }
        this.history.push(new PageInfo(pageName, options.urlParams, this.transition));
        if (CONSTANTS.isWaveLens) {
            var location_1 = window['location'];
            var strQueryParams = _.map(options.urlParams || [], function (value, key) { return key + '=' + value; });
            var strQuery = (strQueryParams.length > 0 ? '?' + strQueryParams.join('&') : '');
            location_1.href = location_1.origin
                + location_1.pathname
                + '#/' + pageName
                + strQuery;
            return;
        }
        return this.router.navigate(["/" + pageName], { queryParams: options.urlParams });
    };
    /**
     * Navigates to last visited page.
     */
    NavigationServiceImpl.prototype.goToPrevious = function () {
        if (this.history.getPagesCount()) {
            this.transition = this.history.getCurrentPage().transition;
            if (!_.isEmpty(this.transition)) {
                this.transition += '-exit';
            }
            this.history.pop();
            this.isPageAddedToHistory = true;
            window.history.back();
        }
    };
    /** Todo[Shubham] Need to handle gotoElement in other partials
     * Navigates to particular view
     * @param viewName
     * @param options
     * @param variable
     */
    NavigationServiceImpl.prototype.goToView = function (viewName, options, variable) {
        var _this = this;
        options = options || {};
        var pageName = options.pageName;
        var transition = options.transition || '';
        var $event = options.$event;
        var activePage = this.app.activePage;
        var prefabName = variable && variable._context && variable._context.prefabName;
        // Check if app is Prefab
        if (this.app.isPrefabType) {
            this.goToElementView($(parentSelector).find('[name="' + viewName + '"]'), viewName, pageName, variable);
        }
        else {
            // checking if the element is present in the page or not, if no show an error toaster
            // if yes check if it is inside a partial/prefab in the page and then highlight the respective element
            // else goto the page in which the element exists and highlight the element
            if (pageName !== activePage.activePageName && !prefabName) {
                if (this.isPartialWithNameExists(pageName)) {
                    this.goToElementView($('[partialcontainer][content="' + pageName + '"]').find('[name="' + viewName + '"]'), viewName, pageName, variable);
                }
                else {
                    // Todo[Shubham]: Make an API call to get all pages and check if the page name
                    //  is a page and then do this call else show an error as:
                    //  this.app.notifyApp(CONSTANTS.WIDGET_DOESNT_EXIST, 'error');
                    this.goToPage(pageName, {
                        viewName: viewName,
                        $event: $event,
                        transition: transition,
                        urlParams: options.urlParams
                    });
                    // subscribe to an event named pageReady which notifies this subscriber
                    // when all widgets in page are loaded i.e when page is ready
                    var pageReadySubscriber_1 = this.app.subscribe('pageReady', function (page) {
                        _this.goToElementView($(parentSelector).find('[name="' + viewName + '"]'), viewName, pageName, variable);
                        pageReadySubscriber_1();
                    });
                }
            }
            else if (prefabName && this.isPrefabWithNameExists(prefabName)) {
                this.goToElementView($('[prefabName="' + prefabName + '"]').find('[name="' + viewName + '"]'), viewName, pageName, variable);
            }
            else if (!pageName || pageName === activePage.activePageName) {
                this.goToElementView($(parentSelector).find('[name="' + viewName + '"]'), viewName, pageName, variable);
            }
            else {
                this.app.notifyApp(CONSTANTS.WIDGET_DOESNT_EXIST, 'error');
            }
        }
    };
    /*
     * navigates the user to a view element with given name
     * if the element not found in the compiled markup, the same is searched in the available dialogs in the page
     */
    NavigationServiceImpl.prototype.goToElementView = function (viewElement, viewName, pageName, variable) {
        var _this = this;
        var $el, parentDialog;
        var activePage = this.app.activePage;
        if (viewElement.length) {
            if (!this.app.isPrefabType && pageName === activePage.activePageName) {
                viewElement = this.getViewElementInActivePage(viewElement);
            }
            $el = viewElement[0].widget;
            switch ($el.widgetType) {
                case 'wm-accordionpane':
                    this.showAncestors(viewElement, variable);
                    $el.expand();
                    break;
                case 'wm-tabpane':
                    this.showAncestors(viewElement, variable);
                    $el.select();
                    break;
                case 'wm-segment-content':
                    this.showAncestors(viewElement, variable);
                    $el.navigate();
                    break;
                case 'wm-panel':
                    /* flip the active flag */
                    $el.expanded = true;
                    break;
            }
        }
        else {
            parentDialog = this.showAncestorDialog(viewName);
            setTimeout(function () {
                if (parentDialog) {
                    _this.goToElementView($('[name="' + viewName + '"]'), viewName, pageName, variable);
                }
            });
        }
    };
    /* If page name is equal to active pageName, this function returns the element in the page.
     The element in the partial page is not selected.*/
    NavigationServiceImpl.prototype.getViewElementInActivePage = function ($el) {
        var selector;
        if ($el.length > 1) {
            selector = _.filter($el, function (childSelector) {
                if (_.isEmpty($(childSelector).closest('[data-role = "partial"]')) && _.isEmpty($(childSelector).closest('[wmprefabcontainer]'))) {
                    return childSelector;
                }
            });
            if (selector) {
                $el = $(selector);
            }
        }
        return $el;
    };
    /**
     * checks if the pagecontainer has the pageName.
     */
    NavigationServiceImpl.prototype.isPartialWithNameExists = function (name) {
        return $('[partialcontainer][content="' + name + '"]').length;
    };
    /**
     * checks if the pagecontainer has the prefab.
     */
    NavigationServiceImpl.prototype.isPrefabWithNameExists = function (prefabName) {
        return $('[prefabName="' + prefabName + '"]').length;
    };
    /*
     * shows all the parent container view elements for a given view element
     */
    NavigationServiceImpl.prototype.showAncestors = function (element, variable) {
        var ancestorSearchQuery = '[wm-navigable-element="true"]';
        element
            .parents(ancestorSearchQuery)
            .toArray()
            .reverse()
            .forEach(function (parent) {
            var $el = parent.widget;
            switch ($el.widgetType) {
                case 'wm-accordionpane':
                    $el.expand();
                    break;
                case 'wm-tabpane':
                    $el.select();
                    break;
                case 'wm-segment-content':
                    $el.navigate();
                    break;
                case 'wm-panel':
                    /* flip the active flag */
                    $el.expanded = true;
                    break;
            }
        });
    };
    /*
     * searches for a given view element inside the available dialogs in current page
     * if found, the dialog is displayed, the dialog id is returned.
     */
    NavigationServiceImpl.prototype.showAncestorDialog = function (viewName) {
        var dialogId;
        $('app-root [dialogtype]')
            .each(function () {
            var dialog = $(this);
            if ($(dialog.html()).find('[name="' + viewName + '"]').length) {
                dialogId = dialog.attr('name');
                return false;
            }
        });
        return dialogId;
    };
    NavigationServiceImpl.ctorParameters = function () { return [
        { type: App },
        { type: Router }
    ]; };
    NavigationServiceImpl = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [App, Router])
    ], NavigationServiceImpl);
    return NavigationServiceImpl;
}());
var PageInfo = /** @class */ (function () {
    function PageInfo(name, urlParams, transition) {
        this.name = name;
        this.urlParams = urlParams;
        this.transition = transition;
        this.transition = _.isEmpty(this.transition) ? null : this.transition;
    }
    PageInfo.prototype.isEqual = function (page1) {
        return page1 && page1.name === this.name && _.isEqual(page1.urlParams, this.urlParams);
    };
    return PageInfo;
}());
var History = /** @class */ (function () {
    function History() {
        this.stack = [];
    }
    History.prototype.getCurrentPage = function () {
        return this.currentPage;
    };
    History.prototype.getPagesCount = function () {
        return this.stack.length;
    };
    History.prototype.isLastVisitedPage = function (page) {
        return this.getLastPage().isEqual(page);
    };
    History.prototype.push = function (pageInfo) {
        if (this.currentPage) {
            this.stack.push(this.currentPage);
        }
        this.currentPage = pageInfo;
    };
    History.prototype.pop = function () {
        this.currentPage = this.stack.pop();
        return this.currentPage;
    };
    History.prototype.getLastPage = function () {
        return this.stack.length > 0 ? this.stack[this.stack.length - 1] : undefined;
    };
    return History;
}());

var AppDefaultsService = /** @class */ (function () {
    function AppDefaultsService() {
    }
    AppDefaultsService.prototype.setFormats = function (formats) {
        var dateFormat = formats.date;
        var timeFormat = formats.time;
        var dateTimeFormat = (dateFormat && timeFormat) ? dateFormat + ' ' + timeFormat : undefined;
        var currency = formats.currency;
        this.dateFormat = dateFormat;
        this.timeFormat = timeFormat;
        this.dateTimeFormat = dateTimeFormat;
        this.currencyCode = currency;
    };
    AppDefaultsService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [])
    ], AppDefaultsService);
    return AppDefaultsService;
}());

var securityConfigLoaded = false;
var AuthGuard = /** @class */ (function () {
    function AuthGuard(securityService, appManager) {
        this.securityService = securityService;
        this.appManager = appManager;
    }
    AuthGuard.prototype.loadSecurityConfig = function () {
        if (securityConfigLoaded) {
            return Promise.resolve(true);
        }
        return this.appManager.loadSecurityConfig().then(function () { return securityConfigLoaded = true; });
    };
    AuthGuard.prototype.isAuthenticated = function () {
        var _this = this;
        return this.loadSecurityConfig()
            .then(function () {
            return new Promise(function (resolve, reject) {
                _this.securityService.isAuthenticated(resolve, reject);
            });
        });
    };
    AuthGuard.prototype.canActivate = function (route) {
        var _this = this;
        return this.isAuthenticated()
            .then(function (isLoggedIn) {
            if (isLoggedIn) {
                return Promise.resolve(true);
            }
            _this.appManager.handle401(route.routeConfig.path, { queryParams: route.queryParams });
            return Promise.resolve(false);
        });
    };
    AuthGuard.ctorParameters = function () { return [
        { type: SecurityService },
        { type: AppManagerService }
    ]; };
    AuthGuard = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [SecurityService, AppManagerService])
    ], AuthGuard);
    return AuthGuard;
}());

var RoleGuard = /** @class */ (function () {
    function RoleGuard(securityService, authGuard, toasterService, app, appManager) {
        this.securityService = securityService;
        this.authGuard = authGuard;
        this.toasterService = toasterService;
        this.app = app;
        this.appManager = appManager;
    }
    RoleGuard.prototype.canActivate = function (route) {
        var _this = this;
        var allowedRoles = route.data.allowedRoles;
        return this.authGuard.isAuthenticated()
            .then(function (isLoggedIn) {
            if (isLoggedIn) {
                var userRoles = _this.securityService.get().userInfo.userRoles;
                var hasAccess = _.intersection(allowedRoles, userRoles).length > 0;
                if (hasAccess) {
                    return Promise.resolve(true);
                }
                // current loggedin user doesn't have access to the page that the user is trying to view
                _this.appManager.notifyApp(_this.app.appLocale.LABEL_ACCESS_DENIED || 'Access Denied', 'error');
                return Promise.resolve(false);
            }
            else {
                // redirect to Login
                _this.appManager.handle401(route.routeConfig.path, { queryParams: route.queryParams });
                return Promise.resolve(false);
            }
        });
    };
    RoleGuard.ctorParameters = function () { return [
        { type: SecurityService },
        { type: AuthGuard },
        { type: AbstractToasterService },
        { type: App },
        { type: AppManagerService }
    ]; };
    RoleGuard = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [SecurityService,
            AuthGuard,
            AbstractToasterService,
            App,
            AppManagerService])
    ], RoleGuard);
    return RoleGuard;
}());

var PageNotFoundGaurd = /** @class */ (function () {
    function PageNotFoundGaurd(app, appManager) {
        this.app = app;
        this.appManager = appManager;
    }
    PageNotFoundGaurd.prototype.canActivate = function (route) {
        this.appManager.notifyApp(this.app.appLocale.MESSAGE_PAGE_NOT_FOUND || 'The page you are trying to reach is not available', 'error');
        return Promise.resolve(false);
    };
    PageNotFoundGaurd.ctorParameters = function () { return [
        { type: App },
        { type: AppManagerService }
    ]; };
    PageNotFoundGaurd = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [App,
            AppManagerService])
    ], PageNotFoundGaurd);
    return PageNotFoundGaurd;
}());

var appJsLoaded = false;
var AppJSResolve = /** @class */ (function () {
    function AppJSResolve(inj, app, utilService, appJsProvider) {
        this.inj = inj;
        this.app = app;
        this.utilService = utilService;
        this.appJsProvider = appJsProvider;
    }
    AppJSResolve.prototype.resolve = function () {
        return __awaiter(this, void 0, void 0, function () {
            var appScriptFn, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (appJsLoaded) {
                            return [2 /*return*/, true];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.appJsProvider.getAppScriptFn()];
                    case 2:
                        appScriptFn = _a.sent();
                        appScriptFn(this.app, this.utilService, this.inj);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.warn('Error in executing app.js', e_1);
                        return [3 /*break*/, 4];
                    case 4:
                        appJsLoaded = true;
                        return [2 /*return*/, true];
                }
            });
        });
    };
    AppJSResolve.ctorParameters = function () { return [
        { type: Injector },
        { type: App },
        { type: UtilsService },
        { type: AppJSProvider }
    ]; };
    AppJSResolve = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Injector,
            App,
            UtilsService,
            AppJSProvider])
    ], AppJSResolve);
    return AppJSResolve;
}());

var appJsLoaded$1 = false;
var AppExtensionJSResolve = /** @class */ (function () {
    function AppExtensionJSResolve(appManager, appJsProvider, customPipeManager) {
        this.appManager = appManager;
        this.appJsProvider = appJsProvider;
        this.customPipeManager = customPipeManager;
    }
    AppExtensionJSResolve.prototype.resolve = function () {
        if (this.appManager.isPrefabType() || this.appManager.isTemplateBundleType()) {
            return true;
        }
        if (!appJsLoaded$1) {
            this.appJsProvider.loadFormatterConfigScript(this.loadedFormatterScript.bind(this));
            appJsLoaded$1 = true;
        }
        return appJsLoaded$1;
    };
    // Formatters load callback
    AppExtensionJSResolve.prototype.loadedFormatterScript = function (response) {
        try {
            var formatterObj = response;
            // If user defined the invalid formatters.
            if (!formatterObj) {
                console.warn('Please return valid formatter object');
            }
            for (var key in formatterObj) {
                this.customPipeManager.setCustomPipe(key, formatterObj[key]);
            }
        }
        catch (e) {
            console.warn('Error in reading formatters.js', e);
        }
    };
    AppExtensionJSResolve.ctorParameters = function () { return [
        { type: AppManagerService },
        { type: AppExtensionProvider },
        { type: CustomPipeManager }
    ]; };
    AppExtensionJSResolve = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [AppManagerService,
            AppExtensionProvider,
            CustomPipeManager])
    ], AppExtensionJSResolve);
    return AppExtensionJSResolve;
}());

var I18nResolve = /** @class */ (function () {
    function I18nResolve(i18nService) {
        this.i18nService = i18nService;
    }
    I18nResolve.prototype.resolve = function () {
        return this.i18nService.loadDefaultLocale();
    };
    I18nResolve.ctorParameters = function () { return [
        { type: AbstractI18nService }
    ]; };
    I18nResolve = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [AbstractI18nService])
    ], I18nResolve);
    return I18nResolve;
}());

var PipeProvider = /** @class */ (function () {
    function PipeProvider(compiler, injector) {
        var _this = this;
        this.compiler = compiler;
        this.injector = injector;
        this._locale = getSessionStorageItem('selectedLocale') || 'en';
        this.preparePipeMeta = function (reference, name, pure, diDeps) {
            if (diDeps === void 0) { diDeps = []; }
            return ({
                type: { reference: reference, diDeps: diDeps },
                name: name,
                pure: pure
            });
        };
        this._pipeData = [
            // TODO | NEED TO BE TESTED
            this.preparePipeMeta(AsyncPipe, 'async', false, [ChangeDetectorRef]),
            this.preparePipeMeta(SlicePipe, 'slice', false),
            this.preparePipeMeta(PercentPipe, 'percent', true, [this._locale]),
            this.preparePipeMeta(I18nPluralPipe, 'i18nPlural', true, [
                NgLocalization
            ]),
            this.preparePipeMeta(I18nSelectPipe, 'i18nSelect', true),
            this.preparePipeMeta(KeyValuePipe, 'keyvalue', false, [
                KeyValueDiffers
            ]),
            this.preparePipeMeta(FileIconClassPipe, 'fileIconClass', true),
            this.preparePipeMeta(FileExtensionFromMimePipe, 'fileExtensionFromMime', true),
            this.preparePipeMeta(StateClassPipe, 'stateClass', true),
            this.preparePipeMeta(FileSizePipe, 'filesize', true),
            // TESTED
            this.preparePipeMeta(FilterPipe, 'filter', true),
            this.preparePipeMeta(UpperCasePipe, 'uppercase', true),
            this.preparePipeMeta(LowerCasePipe, 'lowercase', true),
            this.preparePipeMeta(JsonPipe, 'json', false),
            this.preparePipeMeta(DecimalPipe, 'number', true, [this._locale]),
            this.preparePipeMeta(TitleCasePipe, 'titlecase', true),
            this.preparePipeMeta(CurrencyPipe, 'currency', true, [this._locale]),
            this.preparePipeMeta(DatePipe, 'date', true, [this._locale]),
            this.preparePipeMeta(ToDatePipe, 'toDate', true, [
                new DatePipe(this._locale)
            ]),
            this.preparePipeMeta(ToNumberPipe, 'toNumber', true, [
                new DecimalPipe(this._locale)
            ]),
            this.preparePipeMeta(ToCurrencyPipe, 'toCurrency', true, [
                new DecimalPipe(this._locale)
            ]),
            this.preparePipeMeta(PrefixPipe, 'prefix', true),
            this.preparePipeMeta(SuffixPipe, 'suffix', true),
            this.preparePipeMeta(TimeFromNowPipe, 'timeFromNow', true),
            this.preparePipeMeta(NumberToStringPipe, 'numberToString', true, [
                new DecimalPipe(this._locale)
            ]),
            this.preparePipeMeta(StringToNumberPipe, 'stringToNumber', true),
            this.preparePipeMeta(CustomPipe, 'custom', true, [this.injector.get(CustomPipeManager)])
        ];
        this._pipeMeta = new Map();
        this._pipeData.forEach(function (v) {
            _this._pipeMeta.set(v.name, v);
        });
    }
    PipeProvider.prototype.unknownPipe = function (name) {
        throw Error("The pipe '" + name + "' could not be found");
    };
    PipeProvider.prototype.meta = function (name) {
        var meta = this._pipeMeta.get(name);
        if (!meta) {
            this.unknownPipe(name);
        }
        return meta;
    };
    PipeProvider.prototype.getPipeNameVsIsPureMap = function () {
        var _map = new Map();
        this._pipeMeta.forEach(function (v, k) {
            _map.set(k, v.pure);
        });
        return _map;
    };
    PipeProvider.prototype.resolveDep = function (dep) {
        return this.injector.get(dep.token.identifier.reference);
    };
    PipeProvider.prototype.getInstance = function (name) {
        var e_1, _a;
        var _b = this.meta(name).type, ref = _b.reference, deps = _b.diDeps;
        if (!ref) {
            this.unknownPipe(name);
        }
        if (!deps.length) {
            return new ref();
        }
        else {
            var args = [];
            try {
                for (var deps_1 = __values(deps), deps_1_1 = deps_1.next(); !deps_1_1.done; deps_1_1 = deps_1.next()) {
                    var dep = deps_1_1.value;
                    args.push(dep);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (deps_1_1 && !deps_1_1.done && (_a = deps_1.return)) _a.call(deps_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return new (ref.bind.apply(ref, __spread([void 0], args)))();
        }
    };
    PipeProvider.ctorParameters = function () { return [
        { type: Compiler },
        { type: Injector }
    ]; };
    PipeProvider.ɵprov = ɵɵdefineInjectable({ factory: function PipeProvider_Factory() { return new PipeProvider(ɵɵinject(Compiler), ɵɵinject(INJECTOR)); }, token: PipeProvider, providedIn: "root" });
    PipeProvider = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [Compiler, Injector])
    ], PipeProvider);
    return PipeProvider;
}());

var AppComponent = /** @class */ (function () {
    function AppComponent(_pipeProvider, _appRef, elRef, oAuthService, dialogService, spinnerService, ngZone, router, app, appManager) {
        var _this = this;
        this.elRef = elRef;
        this.oAuthService = oAuthService;
        this.dialogService = dialogService;
        this.spinnerService = spinnerService;
        this.router = router;
        this.app = app;
        this.appManager = appManager;
        this.startApp = false;
        this.isApplicationType = false;
        this.spinner = { show: false, messages: [] };
        this.isOAuthDialogOpen = false;
        setPipeProvider(_pipeProvider);
        setNgZone(ngZone);
        setAppRef(_appRef);
        this.isApplicationType = getWmProjectProperties().type === 'APPLICATION';
        // subscribe to OAuth changes
        oAuthService.getOAuthProvidersAsObservable().subscribe(function (providers) {
            _this.providersConfig = providers;
            if (providers.length) {
                _this.showOAuthDialog();
            }
            else {
                _this.closeOAuthDialog();
            }
        });
        // Subscribe to the message source to show/hide app spinner
        this.spinnerService.getMessageSource().asObservable().subscribe(function (data) {
            // setTimeout is to avoid 'ExpressionChangedAfterItHasBeenCheckedError'
            setTimeout(function () {
                _this.spinner.show = data.show;
                _this.spinner.messages = data.messages;
            });
        });
        // set theme to bs3 on ngx-bootstrap. This avoids runtime calculation to determine bs theme. Thus resolves performance.
        setTheme('bs3');
        var spinnerId;
        var onPageRendered = noop$1;
        this.router.events.subscribe(function (e) {
            if (e instanceof NavigationStart) {
                spinnerId = _this.spinnerService.show('', 'globalSpinner');
                var node = document.querySelector('app-page-outlet');
                if (node) {
                    addClass(node, 'page-load-in-progress');
                }
                var page = e.url.split('?')[0];
                page = page.substring(1);
                var pageLoadStartTime_1 = Date.now();
                onPageRendered = function () {
                    _this.spinnerService.hide(spinnerId);
                    var node = document.querySelector('app-page-outlet');
                    if (node) {
                        removeClass(node, 'page-load-in-progress');
                    }
                    onPageRendered = noop$1;
                    _this.app.activePageLoadTime = Date.now() - pageLoadStartTime_1;
                };
            }
            else if (e instanceof NavigationEnd || e instanceof NavigationCancel || e instanceof NavigationError) {
                setTimeout(function () {
                    onPageRendered();
                }, 1000);
            }
        });
        this.appManager.subscribe('pageReady', function () {
            onPageRendered();
        });
        this.appManager.subscribe('pageAttach', function () {
            onPageRendered();
        });
    }
    AppComponent.prototype.showOAuthDialog = function () {
        if (!this.isOAuthDialogOpen) {
            this.isOAuthDialogOpen = true;
            this.dialogService.open('oAuthLoginDialog', this);
        }
    };
    AppComponent.prototype.closeOAuthDialog = function () {
        if (this.isOAuthDialogOpen) {
            this.isOAuthDialogOpen = false;
            this.dialogService.close('oAuthLoginDialog', this);
        }
    };
    AppComponent.prototype.start = function () {
        var _this = this;
        this.startApp = true;
        setTimeout(function () {
            _this.app.dynamicComponentContainerRef = _this.dynamicComponentContainerRef;
            _this.overrideRouterOutlet();
        }, 10);
    };
    AppComponent.prototype.overrideRouterOutlet = function () {
        var _this = this;
        //override the attach/detach methods
        var oAttach = this.routerOutlet.attach;
        var oDetach = this.routerOutlet.detach;
        this.routerOutlet.attach = function (componentRef) {
            oAttach.call(_this.routerOutlet, componentRef);
            componentRef.instance.ngOnAttach();
        };
        this.routerOutlet.detach = function () {
            _this.app.activePage.ngOnDetach();
            var componentRef = oDetach.call(_this.routerOutlet);
            return componentRef;
        };
    };
    AppComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (hasCordova() && !window['wmDeviceReady']) {
            document.addEventListener('wmDeviceReady', function () { return _this.start(); });
        }
        else {
            this.start();
        }
    };
    AppComponent.prototype.ngDoCheck = function () {
        $invokeWatchers();
    };
    AppComponent.ctorParameters = function () { return [
        { type: PipeProvider },
        { type: ApplicationRef },
        { type: ElementRef },
        { type: OAuthService },
        { type: AbstractDialogService },
        { type: AbstractSpinnerService },
        { type: NgZone },
        { type: Router },
        { type: App },
        { type: AppManagerService }
    ]; };
    __decorate([
        ViewChild(RouterOutlet),
        __metadata("design:type", RouterOutlet)
    ], AppComponent.prototype, "routerOutlet", void 0);
    __decorate([
        ViewChild('dynamicComponent', { read: ViewContainerRef }),
        __metadata("design:type", ViewContainerRef)
    ], AppComponent.prototype, "dynamicComponentContainerRef", void 0);
    AppComponent = __decorate([
        Component({
            selector: 'app-root',
            template: "<ng-container *ngIf=\"startApp\">\n    <router-outlet></router-outlet>\n    <div wmContainer partialContainer content=\"Common\" hidden class=\"ng-hide\" *ngIf=\"isApplicationType\"></div>\n    <app-spinner name=\"globalspinner\" classname=\"global-spinner\" [show]=\"spinner.show\" [spinnermessages]=\"spinner.messages\"></app-spinner>\n    <div wmDialog name=\"oAuthLoginDialog\" title.bind=\"'Application is requesting you to sign in with'\"\n         close.event=\"closeOAuthDialog()\">\n        <ng-template #dialogBody>\n            <ul class=\"list-items\">\n                <li class=\"list-item\" *ngFor=\"let provider of providersConfig\">\n                    <button class=\"btn\" (click)=\"provider.invoke()\">{{provider.name}}</button>\n                </li>\n            </ul>\n        </ng-template>\n    </div>\n    <div wmConfirmDialog name=\"_app-confirm-dialog\" title.bind=\"title\" message.bind=\"message\" oktext.bind=\"oktext\"\n         canceltext.bind=\"canceltext\" closable=\"false\" iconclass.bind=\"iconclass\" \n         escape.event=\"onEscape()\" ok.event=\"onOk()\" cancel.event=\"onCancel()\" close.event=\"onClose()\" opened.event=\"onOpen()\"></div>\n    <div wmAppExt></div>\n    <i id=\"wm-mobile-display\"></i>\n</ng-container>\n<!--Dummy container to create the component dynamically-->\n<ng-container #dynamicComponent></ng-container>\n",
            encapsulation: ViewEncapsulation.None
        }),
        __metadata("design:paramtypes", [PipeProvider,
            ApplicationRef,
            ElementRef,
            OAuthService,
            AbstractDialogService,
            AbstractSpinnerService,
            NgZone,
            Router,
            App,
            AppManagerService])
    ], AppComponent);
    return AppComponent;
}());

/**
 * This Interceptor intercepts all network calls and if a network call fails
 * due to session timeout, then it calls a function to handle session timeout.
 */
var HttpCallInterceptor = /** @class */ (function () {
    function HttpCallInterceptor() {
        this.wmHttpRequest = new WmHttpRequest();
        this.wmHttpResponse = new WmHttpResponse();
    }
    HttpCallInterceptor.prototype.createSubject = function () {
        return new Subject();
    };
    HttpCallInterceptor.prototype.intercept = function (request, next) {
        var _this = this;
        var modifiedReq;
        var modifiedResp;
        if (appManager && appManager.appOnBeforeServiceCall) {
            // Convert the angular HttpRequest to wm HttpRequest
            var req = this.wmHttpRequest.angularToWmRequest(request);
            // trigger the common onBeforeServiceCall handler present in app.js
            modifiedReq = appManager.appOnBeforeServiceCall(req);
            if (modifiedReq) {
                // Convert the wm HttpRequest to angular HttpRequest
                modifiedReq = this.wmHttpRequest.wmToAngularRequest(modifiedReq);
                request = modifiedReq;
            }
        }
        return next.handle(request).pipe(tap(function (response) {
            if (response && response.type === 4 && appManager && appManager.appOnServiceSuccess) {
                // Convert the angular HttpResponse to wm HttpResponse
                var resp = _this.wmHttpResponse.angularToWmResponse(response);
                // trigger the common success handler present in app.js
                modifiedResp = appManager.appOnServiceSuccess(resp.body, resp);
                if (modifiedResp) {
                    // Convert the wm HttpResponse to angular HttpResponse
                    modifiedResp = _this.wmHttpResponse.wmToAngularResponse(modifiedResp);
                    _.extend(response, modifiedResp);
                }
            }
        }, function (error) {
            error._401Subscriber = _this.createSubject();
            if (httpService.isPlatformSessionTimeout(error)) {
                httpService.handleSessionTimeout(request, error._401Subscriber);
            }
            if (appManager && appManager.appOnServiceError) {
                // Convert the angular HttpResponse to wm HttpResponse
                var err = _this.wmHttpResponse.angularToWmResponse(error);
                // trigger the common error handler present in app.js
                modifiedResp = appManager.appOnServiceError(err.message, err);
                if (modifiedResp) {
                    // Convert the wm HttpResponse to angular HttpResponse
                    modifiedResp = _this.wmHttpResponse.wmToAngularResponse(modifiedResp);
                    _.extend(error, modifiedResp);
                }
            }
        }));
    };
    HttpCallInterceptor = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [])
    ], HttpCallInterceptor);
    return HttpCallInterceptor;
}());

var PREFAB = 'PREFAB';
var PrefabPreviewComponent = /** @class */ (function () {
    function PrefabPreviewComponent(prefabManager) {
        var _this = this;
        this.prefabManager = prefabManager;
        window.addEventListener('message', function (e) {
            var context = e.data && e.data.context;
            if (context !== PREFAB) {
                return;
            }
            var action = e.data.action;
            var payload = e.data.payload;
            if (action === 'init') {
                _this.init();
            }
            else if (action === 'set-property') {
                _this.setProperty(payload);
            }
            else if (action === 'get-outbound-properties') {
                _this.getOutboundProps();
            }
            else if (action === 'invoke-script') {
                _this.invokeScript(payload);
            }
        });
    }
    PrefabPreviewComponent.prototype.postMessage = function (action, payload) {
        var data = {
            context: PREFAB,
            action: action,
            payload: payload
        };
        window.top.postMessage(data, '*');
    };
    PrefabPreviewComponent.prototype.setupEventListeners = function () {
        var _this = this;
        this.prefabInstance.invokeEventCallback = function (eventName, locals) {
            if (locals === void 0) { locals = {}; }
            _this.postMessage('event-log', { name: eventName, data: locals });
        };
    };
    PrefabPreviewComponent.prototype.init = function () {
        var _this = this;
        this.previewMode = true;
        this.prefabInstance.readyState.subscribe(function () { }, function () { }, function () {
            _this.prefabManager.getConfig('__self__')
                .then(function (config) {
                _this.config = config;
                _this.postMessage('config', config);
                _this.setupEventListeners();
            });
        });
    };
    PrefabPreviewComponent.prototype.setProperty = function (payload) {
        this.prefabInstance.widget[payload.name] = payload.value;
    };
    PrefabPreviewComponent.prototype.isOutBoundProp = function (info) {
        return info.bindable === 'out-bound' || info.bindable === 'in-out-bound';
    };
    PrefabPreviewComponent.prototype.getOutboundProps = function () {
        var e_1, _a;
        var payload = {};
        try {
            for (var _b = __values(Object.entries(this.config.properties || {})), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), name_1 = _d[0], info = _d[1];
                if (this.isOutBoundProp(info)) {
                    payload[name_1] = this.prefabInstance.widget[name_1];
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.postMessage('outbound-properties', payload);
    };
    PrefabPreviewComponent.prototype.invokeScript = function (payload) {
        var script = "\n return " + payload.script + ";";
        var fn = new Function('Prefab', script);
        var retVal = fn(this.prefabInstance);
        this.postMessage('method-output', { methodName: payload.methodName, output: retVal });
    };
    PrefabPreviewComponent.prototype.ngAfterViewInit = function () {
        this.setupEventListeners();
        this.postMessage('init');
    };
    PrefabPreviewComponent.ctorParameters = function () { return [
        { type: PrefabManagerService }
    ]; };
    __decorate([
        ViewChild(PrefabDirective$1, { static: true }),
        __metadata("design:type", Object)
    ], PrefabPreviewComponent.prototype, "prefabInstance", void 0);
    PrefabPreviewComponent = __decorate([
        Component({
            selector: 'wm-prefab-preview',
            template: "\n        <div class=\"prefab-preview row\">\n            <section wmPrefab name=\"prefab-preview\" prefabname=\"__self__\"></section>\n        </div>\n    "
        }),
        __metadata("design:paramtypes", [PrefabManagerService])
    ], PrefabPreviewComponent);
    return PrefabPreviewComponent;
}());

initComponentsBuildTask();
var componentFactoryRefCache = new Map();
var getDynamicModule = function (componentRef) {
    var DynamicModule = /** @class */ (function () {
        function DynamicModule() {
        }
        DynamicModule = __decorate([
            NgModule({
                declarations: [componentRef],
                imports: [
                    RuntimeBaseModule
                ],
                schemas: [CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA]
            })
        ], DynamicModule);
        return DynamicModule;
    }());
    return DynamicModule;
};
var ɵ0$2 = getDynamicModule;
var getDynamicComponent = function (selector, template, css) {
    if (css === void 0) { css = ''; }
    var componentDef = {
        template: template,
        styles: [css],
        encapsulation: ViewEncapsulation.None
    };
    var DynamicComponent = /** @class */ (function () {
        function DynamicComponent() {
        }
        DynamicComponent = __decorate([
            Component(__assign(__assign({}, componentDef), { selector: selector }))
        ], DynamicComponent);
        return DynamicComponent;
    }());
    return DynamicComponent;
};
var ɵ1$1 = getDynamicComponent;
var DynamicComponentRefProviderService = /** @class */ (function () {
    function DynamicComponentRefProviderService(app, appManager, compiler) {
        this.app = app;
        this.appManager = appManager;
        this.compiler = compiler;
        this.counter = 1;
    }
    DynamicComponentRefProviderService.prototype.getComponentFactoryRef = function (selector, markup, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var componentFactoryRef, componentDef_1, moduleDef;
            return __generator(this, function (_a) {
                componentFactoryRef = componentFactoryRefCache.get(selector);
                markup = options.transpile ? transpile(markup).markup : markup;
                if (!componentFactoryRef || options.noCache) {
                    componentDef_1 = getDynamicComponent(selector, markup, options.styles);
                    moduleDef = getDynamicModule(componentDef_1);
                    componentFactoryRef = this.compiler
                        .compileModuleAndAllComponentsSync(moduleDef)
                        .componentFactories
                        .filter(function (factory) { return factory.componentType === componentDef_1; })[0];
                    componentFactoryRefCache.set(selector, componentFactoryRef);
                }
                return [2 /*return*/, componentFactoryRef];
            });
        });
    };
    /**
     * Creates the component dynamically and add it to the DOM
     * @param target: HTML element where we need to append the created component
     * @param markup: Template of the component
     * @param context: Scope of the component
     * @param options: We have options like
                       selector: selector of the component
                       transpile: flag for transpiling HTML. By default it is true
                       nocache: flag for render it from cache or not. By default it is true
     */
    DynamicComponentRefProviderService.prototype.addComponent = function (target, markup, context, options) {
        if (context === void 0) { context = {}; }
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var componentFactoryRef, component;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.transpile = isDefined(options.transpile) ? options.transpile : true;
                        options.noCache = isDefined(options.noCache) ? options.noCache : true;
                        options.selector = isDefined(options.selector) ? options.selector : 'wm-dynamic-component-' + this.counter++;
                        return [4 /*yield*/, this.getComponentFactoryRef(options.selector, markup, options)];
                    case 1:
                        componentFactoryRef = _a.sent();
                        component = this.app.dynamicComponentContainerRef.createComponent(componentFactoryRef, 0, _.get(options, 'inj'));
                        extendProto(component.instance, context);
                        target.appendChild(component.location.nativeElement);
                        return [2 /*return*/];
                }
            });
        });
    };
    DynamicComponentRefProviderService.ctorParameters = function () { return [
        { type: App },
        { type: AppManagerService },
        { type: Compiler }
    ]; };
    DynamicComponentRefProviderService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [App,
            AppManagerService,
            Compiler])
    ], DynamicComponentRefProviderService);
    return DynamicComponentRefProviderService;
}());

/*
    canDeactivate guard for preview/WM deployment.
    [WMS-19159] - Moved CanDeactivate() from page-wrapper.component.ts to base-page.component.ts(which is common for both preview and angular)
    because beforepageleave is not calling for browser/tab close in angularmode
    here component is pagewrapper so adding custom implementation for route change
 */
var CanDeactivatePageGuard = /** @class */ (function () {
    function CanDeactivatePageGuard() {
    }
    CanDeactivatePageGuard.prototype.canDeactivate = function (component, route, state) {
        function invokeCompDeactivate() {
            var retVal;
            // Calling onBeforePageLeave method present at page level
            retVal = this.app.activePage && this.app.activePage.onBeforePageLeave();
            // Calling onBeforePageLeave method present at app level only if page level method return true
            // or if there is no page level method
            if (retVal !== false) {
                retVal = (this.app.onBeforePageLeave || noop$1)(this.app.activePageName, this.app.activePage);
            }
            return retVal === undefined ? true : retVal;
        }
        return invokeCompDeactivate.apply(component);
    };
    CanDeactivatePageGuard = __decorate([
        Injectable()
    ], CanDeactivatePageGuard);
    return CanDeactivatePageGuard;
}());
//  [WMS-18847] - canDeactivate guard for angular deployment.
var CanDeactivateNgPageGuard = /** @class */ (function () {
    function CanDeactivateNgPageGuard() {
    }
    CanDeactivateNgPageGuard.prototype.canDeactivate = function (component, route, state) {
        return component.canDeactivate ? component.canDeactivate() : true;
    };
    CanDeactivateNgPageGuard = __decorate([
        Injectable()
    ], CanDeactivateNgPageGuard);
    return CanDeactivateNgPageGuard;
}());

var initializeProjectDetails = function () {
    _WM_APP_PROJECT.id = location.href.split('/')[3];
    _WM_APP_PROJECT.cdnUrl = document.querySelector('[name="cdnUrl"]') && document.querySelector('[name="cdnUrl"]').getAttribute('content');
    _WM_APP_PROJECT.ngDest = 'ng-bundle/';
};
var ɵ0$3 = initializeProjectDetails;
var OS;
(function (OS) {
    OS["IOS"] = "ios";
    OS["ANDROID"] = "android";
})(OS || (OS = {}));
function getSettingProvider(key, defaultValue) {
    return {
        provide: key,
        useValue: defaultValue
    };
}
;
function InitializeApp(I18nService) {
    return function () {
        initializeProjectDetails();
        return I18nService.loadDefaultLocale();
    };
}
function setAngularLocale(I18nService) {
    initializeProjectDetails();
    return I18nService.deduceAppLocale();
}
var definitions = [
    AccessrolesDirective,
    AppSpinnerComponent,
    CustomToasterComponent,
    PrefabDirective,
    AppComponent,
    PrefabPreviewComponent,
    EmptyPageComponent
];
var REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS = [
    ConfirmDialogModule,
    DesignDialogModule,
    DialogModule
];
// setting parseExpr as exprEvaluator for swipeAnimation
$.fn.swipeAnimation.expressionEvaluator = $parseExpr;
var RuntimeBaseModule = /** @class */ (function () {
    function RuntimeBaseModule(mobileRuntimeModule, app, viewport) {
        RuntimeBaseModule_1.addCustomEventPolyfill();
        this.getDeviceDetails().then(function (details) {
            app.selectedViewPort = {
                os: details.os,
                category: details.selectedDeviceCategory
            };
            viewport.update(details);
            app.notify('on-viewport-details', details.os);
        });
    }
    RuntimeBaseModule_1 = RuntimeBaseModule;
    // this polyfill is to add support for CustomEvent in IE11
    RuntimeBaseModule.addCustomEventPolyfill = function () {
        if (typeof window['CustomEvent'] === 'function') {
            return false;
        }
        // Adding type as any to avoid error TS2322
        var CustomEvent = function (event, params) {
            params = params || { bubbles: false, cancelable: false, detail: null };
            var evt = document.createEvent('CustomEvent');
            evt.initCustomEvent(event, params.bubbles, params.cancelable, params.detail);
            return evt;
        };
        CustomEvent.prototype = window['Event'].prototype;
        // ### ANGULAR9TODO ###
        window['CustomEvent'] = CustomEvent;
    };
    RuntimeBaseModule.forRoot = function () {
        return {
            ngModule: RuntimeBaseModule_1,
            providers: [
                { provide: App, useClass: AppRef },
                { provide: AbstractToasterService, useClass: ToasterServiceImpl },
                { provide: AbstractI18nService, useClass: I18nServiceImpl },
                { provide: AbstractSpinnerService, useClass: SpinnerServiceImpl },
                { provide: AbstractNavigationService, useClass: NavigationServiceImpl },
                { provide: AppDefaults, useClass: AppDefaultsService },
                { provide: DynamicComponentRefProvider, useClass: DynamicComponentRefProviderService },
                {
                    provide: APP_INITIALIZER,
                    useFactory: InitializeApp,
                    deps: [AbstractI18nService],
                    multi: true
                },
                {
                    provide: LOCALE_ID,
                    useFactory: setAngularLocale,
                    deps: [AbstractI18nService]
                },
                {
                    provide: HTTP_INTERCEPTORS,
                    useClass: HttpCallInterceptor,
                    multi: true
                },
                DecimalPipe,
                DatePipe,
                AppManagerService,
                PrefabManagerService,
                AuthGuard,
                RoleGuard,
                PageNotFoundGaurd,
                CanDeactivatePageGuard,
                AppJSResolve,
                AppExtensionJSResolve,
                I18nResolve,
                getSettingProvider(MAX_CACHE_SIZE, 10),
                getSettingProvider(MAX_CACHE_AGE, 30 * 60)
            ]
        };
    };
    RuntimeBaseModule.prototype.getDeviceDetails = function () {
        return new Promise(function (resolve, reject) {
            var msgContent = { key: 'on-load' };
            // Notify preview window that application is ready. Otherwise, identify the OS.
            if (window.top !== window) {
                window.top.postMessage(msgContent, '*');
                // This is for preview page
                window.onmessage = function (msg) {
                    var data = msg.data;
                    if (isObject(data) && data.key === 'switch-device') {
                        resolve(data.device);
                    }
                };
            }
            else if (isIphone() || isIpod() || isIpad()) {
                resolve({ 'os': OS.IOS });
            }
            else {
                resolve({ 'os': OS.ANDROID });
            }
        });
    };
    var RuntimeBaseModule_1;
    RuntimeBaseModule.ctorParameters = function () { return [
        { type: MobileRuntimeModule },
        { type: App },
        { type: Viewport }
    ]; };
    RuntimeBaseModule = RuntimeBaseModule_1 = __decorate([
        NgModule({
            declarations: definitions,
            imports: [
                CommonModule,
                RouterModule,
                HttpClientModule,
                ToastrModule,
                WmComponentsModule,
                PrefabModule,
                MobileRuntimeModule,
                CoreModule,
                SecurityModule,
                OAuthModule,
                VariablesModule,
                HttpServiceModule,
                REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS
            ],
            exports: [
                definitions,
                CommonModule,
                WmComponentsModule,
                MobileRuntimeModule,
                CoreModule,
                SecurityModule,
                OAuthModule,
                VariablesModule,
                HttpServiceModule,
                REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS
            ],
            entryComponents: [CustomToasterComponent]
        }),
        __metadata("design:paramtypes", [MobileRuntimeModule,
            App,
            Viewport])
    ], RuntimeBaseModule);
    return RuntimeBaseModule;
}());
var WM_MODULES_FOR_ROOT = [
    WmComponentsModule.forRoot(),
    MobileRuntimeModule.forRoot(),
    CoreModule.forRoot(),
    SecurityModule.forRoot(),
    OAuthModule.forRoot(),
    VariablesModule.forRoot(),
    HttpServiceModule.forRoot(),
    RuntimeBaseModule.forRoot()
];

var APP_STORE_KEY = "WAVEMAKER_APP_ID";
var SPOTCUES_SCRIPT_URL = 'https://d2qztbtcmhe1gf.cloudfront.net/demoapps2/1593011200/spotcues-utils.js';
var createDirectory = function (parent, name) {
    return new Promise(function (resolve, reject) {
        window['resolveLocalFileSystemURL'](parent, function (fileSystem) {
            fileSystem.getDirectory(name, { create: true, exclusive: false }, resolve, reject);
        }, reject);
    });
};
var ɵ0$4 = createDirectory;
var setupFileSystem = function () {
    var cordova = window['cordova'];
    var appId = localStorage.getItem(APP_STORE_KEY);
    if (_.isEmpty(appId)) {
        appId = ($('title').first().text() || 'no_name') + '_' + Date.now();
        localStorage.setItem(APP_STORE_KEY, appId);
    }
    var wmDirectory = 'wavemaker_app_data';
    return createDirectory(cordova.file.dataDirectory, wmDirectory)
        .then(function () { return createDirectory(cordova.file.dataDirectory + wmDirectory + '/', appId); })
        .then(function () { return cordova.file.dataDirectory += wmDirectory + '/' + appId + '/'; })
        .then(function () { return createDirectory(cordova.file.cacheDirectory, wmDirectory); })
        .then(function () { return createDirectory(cordova.file.cacheDirectory + wmDirectory + '/', appId); })
        .then(function () { return cordova.file.cacheDirectory += wmDirectory + '/' + appId + '/'; });
};
var ɵ1$2 = setupFileSystem;
var initSpotCues = function () {
    return Promise.resolve().then(function () {
        if (!window['SPOTCUES_UTILS']) {
            return loadScript(SPOTCUES_SCRIPT_URL, false, true);
        }
    }).then(function () {
        return new Promise(function (resolve) {
            window['SPOTCUES_UTILS'].loadCordova(function () {
                document.addEventListener('deviceready', function () {
                    setupFileSystem().then(resolve);
                });
            });
        });
    });
};

var appVariablesLoaded = false;
var AppVariablesResolve = /** @class */ (function () {
    function AppVariablesResolve(appManager, appVariablesProvider) {
        this.appManager = appManager;
        this.appVariablesProvider = appVariablesProvider;
    }
    AppVariablesResolve.prototype.resolve = function () {
        var _this = this;
        // execute app.js
        if (appVariablesLoaded) {
            return true;
        }
        return Promise.all([this.appManager.loadSecurityConfig(), this.appManager.loadMetadata(), this.appVariablesProvider.getAppVariables()])
            .then(function (data) { return _this.appManager.loadAppVariables(data[2]); })
            .then(function () { return appVariablesLoaded = true; });
    };
    AppVariablesResolve.ctorParameters = function () { return [
        { type: AppManagerService },
        { type: AppVariablesProvider }
    ]; };
    AppVariablesResolve.ɵprov = ɵɵdefineInjectable({ factory: function AppVariablesResolve_Factory() { return new AppVariablesResolve(ɵɵinject(AppManagerService), ɵɵinject(AppVariablesProvider)); }, token: AppVariablesResolve, providedIn: "root" });
    AppVariablesResolve = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [AppManagerService,
            AppVariablesProvider])
    ], AppVariablesResolve);
    return AppVariablesResolve;
}());

var metadataResolved = false;
var MetadataResolve = /** @class */ (function () {
    function MetadataResolve(appManager) {
        this.appManager = appManager;
    }
    MetadataResolve.prototype.resolve = function () {
        return metadataResolved || this.appManager.loadMetadata().then(function () { return metadataResolved = true; });
    };
    MetadataResolve.ctorParameters = function () { return [
        { type: AppManagerService }
    ]; };
    MetadataResolve.ɵprov = ɵɵdefineInjectable({ factory: function MetadataResolve_Factory() { return new MetadataResolve(ɵɵinject(AppManagerService)); }, token: MetadataResolve, providedIn: "root" });
    MetadataResolve = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [AppManagerService])
    ], MetadataResolve);
    return MetadataResolve;
}());

var SecurityConfigResolve = /** @class */ (function () {
    function SecurityConfigResolve(appManager) {
        this.appManager = appManager;
        // if the project type is PREFAB, setting this flag will not trigger security/info call
        this.loaded = this.appManager.isPrefabType() || this.appManager.isTemplateBundleType() || !getWmProjectProperties().securityEnabled;
    }
    SecurityConfigResolve.prototype.resolve = function () {
        var _this = this;
        return this.loaded || this.appManager.loadSecurityConfig().then(function () {
            _this.loaded = true;
        });
    };
    SecurityConfigResolve.ctorParameters = function () { return [
        { type: AppManagerService }
    ]; };
    SecurityConfigResolve.ɵprov = ɵɵdefineInjectable({ factory: function SecurityConfigResolve_Factory() { return new SecurityConfigResolve(ɵɵinject(AppManagerService)); }, token: SecurityConfigResolve, providedIn: "root" });
    SecurityConfigResolve = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [AppManagerService])
    ], SecurityConfigResolve);
    return SecurityConfigResolve;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { AppComponent, AppExtensionJSResolve, AppExtensionProvider, AppJSProvider, AppJSResolve, AppManagerService, AppVariablesProvider, AppVariablesResolve, AuthGuard, BasePageComponent, BasePartialComponent, BasePrefabComponent, CanDeactivateNgPageGuard, CanDeactivatePageGuard, ComponentRefProvider, ComponentType, EmptyPageComponent, I18nResolve, InitializeApp, MAX_CACHE_AGE, MAX_CACHE_SIZE, MetadataResolve, PageNotFoundGaurd, PrefabConfigProvider, PrefabManagerService, PrefabPreviewComponent, REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS, RoleGuard, RuntimeBaseModule, SecurityConfigResolve, WM_MODULES_FOR_ROOT, WmNgRouteReuseStrategy, WmRouteReuseStrategy, commonPartialWidgets, getPrefabBaseUrl, getPrefabConfigUrl, getPrefabMinJsonUrl, getSettingProvider, initSpotCues, isPrefabInPreview, setAngularLocale, ɵ0, FragmentMonitor as ɵa, AccessrolesDirective as ɵb, AppSpinnerComponent as ɵc, CustomToasterComponent as ɵd, PrefabDirective as ɵe, PipeProvider as ɵf, AppRef as ɵg, ToasterServiceImpl as ɵh, I18nServiceImpl as ɵi, SpinnerServiceImpl as ɵj, NavigationServiceImpl as ɵk, AppDefaultsService as ɵl, DynamicComponentRefProviderService as ɵm, HttpCallInterceptor as ɵn };
//# sourceMappingURL=index.js.map
