import { ActivatedRouteSnapshot, DetachedRouteHandle, RouteReuseStrategy } from '@angular/router';
export declare const MAX_CACHE_SIZE = "REUSE_ROUTE_STRATEGY.MAX_CACHE_SIZE";
export declare const MAX_CACHE_AGE = "REUSE_ROUTE_STRATEGY.MAX_CACHE_AGE";
declare class WmDefaultRouteReuseStrategy {
    private maxCacheSize;
    private maxCacheAge;
    private cache;
    private currentRouteKey;
    private paramsToIgnore;
    constructor(maxCacheSize: number, maxCacheAge: number);
    private getKey;
    protected getSize: (obj: object) => number;
    protected isSameQueryParams(future: any, current: any): boolean;
    shouldDetach(route: ActivatedRouteSnapshot): boolean;
    shouldAttach(route: ActivatedRouteSnapshot): boolean;
    store(route: ActivatedRouteSnapshot, handle: DetachedRouteHandle): void;
    retrieve(route: ActivatedRouteSnapshot): DetachedRouteHandle | null;
    reset(): void;
}
export declare class WmRouteReuseStrategy extends WmDefaultRouteReuseStrategy implements RouteReuseStrategy {
    constructor(maxCacheSize: number, maxCacheAge: number);
    private isSameRoute;
    shouldReuseRoute(future: ActivatedRouteSnapshot, current: ActivatedRouteSnapshot): boolean;
}
export declare class WmNgRouteReuseStrategy extends WmDefaultRouteReuseStrategy implements RouteReuseStrategy {
    constructor(maxCacheSize: number, maxCacheAge: number);
    private isSameRoute;
    shouldReuseRoute(future: ActivatedRouteSnapshot, current: ActivatedRouteSnapshot): boolean;
}
export {};
