import { Injector, ViewContainerRef, ApplicationRef, NgZone, ElementRef, Component, ɵɵdefineInjectable, ɵɵinject, Injectable, NgModule, CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA, ViewEncapsulation, Compiler, enableProdMode } from '@angular/core';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { __awaiter, __decorate, __metadata } from 'tslib';
import { BrowserModule } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';
import { ActivatedRoute, Router, RouterModule, RouteReuseStrategy } from '@angular/router';
import { HttpClient, HttpClientXsrfModule, HttpClientModule } from '@angular/common/http';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { TypeaheadModule } from 'ngx-bootstrap/typeahead';
import { TimepickerModule } from 'ngx-bootstrap/timepicker';
import { ProgressbarModule } from 'ngx-bootstrap/progressbar';
import { PaginationModule } from 'ngx-bootstrap/pagination';
import { ModalModule } from 'ngx-bootstrap/modal';
import { TooltipModule } from 'ngx-bootstrap/tooltip';
import { BsDatepickerModule, DatepickerModule } from 'ngx-bootstrap/datepicker';
import { BsDropdownModule } from 'ngx-bootstrap/dropdown';
import { PopoverModule } from 'ngx-bootstrap/popover';
import { NgCircleProgressModule } from 'ng-circle-progress';
import { ToastNoAnimationModule } from 'ngx-toastr';
import { CarouselModule } from 'ngx-bootstrap/carousel';
import { App, AbstractSpinnerService, AbstractHttpService, appendScriptToHead, UserDefinedExecutionContext, getValidJSON, getWmProjectProperties, PartialRefProvider, isSpotcues } from '@wm/core';
import { BasicModule } from '@wm/components/basic';
import { ProgressModule } from '@wm/components/basic/progress';
import { RichTextEditorModule } from '@wm/components/basic/rich-text-editor';
import { SearchModule } from '@wm/components/basic/search';
import { TreeModule } from '@wm/components/basic/tree';
import { InputModule } from '@wm/components/input';
import { CalendarModule } from '@wm/components/input/calendar';
import { ChipsModule } from '@wm/components/input/chips';
import { ColorPickerModule } from '@wm/components/input/color-picker';
import { CurrencyModule } from '@wm/components/input/currency';
import { EpochModule } from '@wm/components/input/epoch';
import { FileUploadModule } from '@wm/components/input/file-upload';
import { RatingModule } from '@wm/components/input/rating';
import { SliderModule } from '@wm/components/input/slider';
import { MOBILE_COMPONENT_MODULES_FOR_ROOT } from '@wm/mobile/runtime/dynamic';
import { CardModule } from '@wm/components/data/card';
import { FormModule } from '@wm/components/data/form';
import { ListModule } from '@wm/components/data/list';
import { LiveTableModule } from '@wm/components/data/live-table';
import { PaginationModule as PaginationModule$1 } from '@wm/components/data/pagination';
import { TableModule } from '@wm/components/data/table';
import { ChartModule } from '@wm/components/chart';
import { AccordionModule } from '@wm/components/containers/accordion';
import { LayoutGridModule } from '@wm/components/containers/layout-grid';
import { PanelModule } from '@wm/components/containers/panel';
import { TabsModule } from '@wm/components/containers/tabs';
import { TileModule } from '@wm/components/containers/tile';
import { WizardModule } from '@wm/components/containers/wizard';
import { AlertDialogModule } from '@wm/components/dialogs/alert-dialog';
import { IframeDialogModule } from '@wm/components/dialogs/iframe-dialog';
import { LoginDialogModule } from '@wm/components/dialogs/login-dialog';
import { PartialDialogModule } from '@wm/components/dialogs/partial-dialog';
import { BreadcrumbModule } from '@wm/components/navigation/breadcrumb';
import { MenuModule } from '@wm/components/navigation/menu';
import { NavbarModule } from '@wm/components/navigation/navbar';
import { PopoverModule as PopoverModule$1 } from '@wm/components/navigation/popover';
import { CarouselModule as CarouselModule$1 } from '@wm/components/advanced/carousel';
import { LoginModule } from '@wm/components/advanced/login';
import { MarqueeModule } from '@wm/components/advanced/marquee';
import { PageModule } from '@wm/components/page';
import { FooterModule } from '@wm/components/page/footer';
import { HeaderModule } from '@wm/components/page/header';
import { LeftPanelModule } from '@wm/components/page/left-panel';
import { RightPanelModule } from '@wm/components/page/right-panel';
import { TopNavModule } from '@wm/components/page/top-nav';
import { PrefabModule } from '@wm/components/prefab';
import { ComponentType, BasePageComponent, AppManagerService, ComponentRefProvider, SecurityConfigResolve, MetadataResolve, AppJSResolve, AppExtensionJSResolve, EmptyPageComponent, PrefabPreviewComponent, CanDeactivatePageGuard, AppJSProvider, AppVariablesProvider, AppExtensionProvider, getPrefabMinJsonUrl, RuntimeBaseModule, BasePrefabComponent, BasePartialComponent, PrefabConfigProvider, getPrefabConfigUrl, REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS, WM_MODULES_FOR_ROOT, WmRouteReuseStrategy, AppComponent, initSpotCues } from '@wm/runtime/base';
import { MetadataService } from '@wm/variables';
import { SecurityService } from '@wm/security';
import { transpile, scopeComponentStyles } from '@wm/transpiler';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

let PageWrapperComponent = class PageWrapperComponent {
    constructor(injector, route, vcRef, appRef, metadataService, securityService, appManager, app, ngZone, elRef, spinnerService, componentRefProvider, router) {
        this.injector = injector;
        this.route = route;
        this.vcRef = vcRef;
        this.appRef = appRef;
        this.metadataService = metadataService;
        this.securityService = securityService;
        this.appManager = appManager;
        this.app = app;
        this.ngZone = ngZone;
        this.elRef = elRef;
        this.spinnerService = spinnerService;
        this.componentRefProvider = componentRefProvider;
        this.router = router;
    }
    getTargetNode() {
        return this.elRef.nativeElement;
    }
    resetViewContainer() {
        this.vcRef.clear();
        const $target = this.getTargetNode();
        $target.innerHTML = '';
    }
    renderPage(pageName) {
        const $target = this.getTargetNode();
        this.appManager.loadAppVariables()
            .then(() => __awaiter(this, void 0, void 0, function* () {
            const pageComponentFactoryRef = yield this.componentRefProvider.getComponentFactoryRef(pageName, ComponentType.PAGE);
            if (pageComponentFactoryRef) {
                const componentRef = this.vcRef.createComponent(pageComponentFactoryRef, 0, this.injector);
                this.instance = componentRef.instance;
                $target.appendChild(componentRef.location.nativeElement);
            }
            else {
                BasePageComponent.clear();
            }
            if (this.vcRef.length > 1) {
                this.vcRef.remove(1);
            }
        }));
    }
    renderPrefabPreviewPage() {
        this.router.navigate(['prefab-preview']);
    }
    loadPage(pageName) {
        this.ngZone.run(() => {
            if (pageName) {
                this.renderPage(pageName);
            }
        });
    }
    ngOnInit() {
        if (this.app.isPrefabType) {
            // there is only one route
            this.renderPrefabPreviewPage();
        }
        else {
            $(this.getTargetNode()).find('>div').first().remove();
            this.subscription = this.route.params.subscribe(({ pageName }) => {
                this.loadPage(pageName);
            });
        }
    }
    ngOnDestroy() {
        this.vcRef.clear();
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    ngOnAttach() {
        this.getTargetNode().appendChild(this.instance.$page[0]);
        this.instance.ngOnAttach();
    }
    ngOnDetach() {
        this.instance.ngOnDetach();
    }
};
PageWrapperComponent.ctorParameters = () => [
    { type: Injector },
    { type: ActivatedRoute },
    { type: ViewContainerRef },
    { type: ApplicationRef },
    { type: MetadataService },
    { type: SecurityService },
    { type: AppManagerService },
    { type: App },
    { type: NgZone },
    { type: ElementRef },
    { type: AbstractSpinnerService },
    { type: ComponentRefProvider },
    { type: Router }
];
PageWrapperComponent = __decorate([
    Component({
        selector: 'app-page-outlet',
        template: '<div></div>'
    }),
    __metadata("design:paramtypes", [Injector,
        ActivatedRoute,
        ViewContainerRef,
        ApplicationRef,
        MetadataService,
        SecurityService,
        AppManagerService,
        App,
        NgZone,
        ElementRef,
        AbstractSpinnerService,
        ComponentRefProvider,
        Router])
], PageWrapperComponent);

const appDependenciesResolve = {
    securityConfig: SecurityConfigResolve,
    metadata: MetadataResolve,
    appJS: AppJSResolve,
    appMetaConfig: AppExtensionJSResolve
};
const routes = [
    {
        path: '',
        pathMatch: 'full',
        resolve: appDependenciesResolve,
        component: EmptyPageComponent
    },
    {
        path: 'prefab-preview',
        pathMatch: 'full',
        resolve: appDependenciesResolve,
        component: PrefabPreviewComponent
    },
    {
        path: ':pageName',
        pathMatch: 'full',
        resolve: appDependenciesResolve,
        component: PageWrapperComponent,
        canDeactivate: [CanDeactivatePageGuard]
    }
];

let AppJSProviderService = class AppJSProviderService extends AppJSProvider {
    constructor($http) {
        super();
        this.$http = $http;
    }
    getAppScriptFn() {
        return this.$http.get('./app.js', { responseType: 'text' })
            .toPromise()
            .then(script => new Function('App', 'Utils', 'Injector', script));
    }
};
AppJSProviderService.ctorParameters = () => [
    { type: HttpClient }
];
AppJSProviderService.ɵprov = ɵɵdefineInjectable({ factory: function AppJSProviderService_Factory() { return new AppJSProviderService(ɵɵinject(HttpClient)); }, token: AppJSProviderService, providedIn: "root" });
AppJSProviderService = __decorate([
    Injectable({
        providedIn: 'root'
    }),
    __metadata("design:paramtypes", [HttpClient])
], AppJSProviderService);

const cache = new Map();
let AppResourceManagerService = class AppResourceManagerService {
    constructor($http) {
        this.$http = $http;
    }
    get(url, useCache) {
        const cachedResponse = cache.get(url);
        if (cachedResponse) {
            return Promise.resolve(cachedResponse);
        }
        return this.$http.get(url).then(response => {
            if (useCache) {
                cache.set(url, response);
            }
            return response;
        });
    }
    clearCache() {
        cache.clear();
    }
};
AppResourceManagerService.ctorParameters = () => [
    { type: AbstractHttpService }
];
AppResourceManagerService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [AbstractHttpService])
], AppResourceManagerService);

let AppVariablesProviderService = class AppVariablesProviderService extends AppVariablesProvider {
    constructor(resourceManager) {
        super();
        this.resourceManager = resourceManager;
    }
    getAppVariables() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.resourceManager.get('./app.variables.json');
        });
    }
};
AppVariablesProviderService.ctorParameters = () => [
    { type: AppResourceManagerService }
];
AppVariablesProviderService.ɵprov = ɵɵdefineInjectable({ factory: function AppVariablesProviderService_Factory() { return new AppVariablesProviderService(ɵɵinject(AppResourceManagerService)); }, token: AppVariablesProviderService, providedIn: "root" });
AppVariablesProviderService = __decorate([
    Injectable({
        providedIn: 'root'
    }),
    __metadata("design:paramtypes", [AppResourceManagerService])
], AppVariablesProviderService);

let AppExtensionProviderService = class AppExtensionProviderService extends AppExtensionProvider {
    // With renderer create element, added onloaded callback the append to the body
    loadFormatterConfigScript(callback) {
        try {
            appendScriptToHead(callback);
        }
        catch (e) {
            console.warn('Error while loading the formatters.js file');
        }
    }
};
AppExtensionProviderService.ɵprov = ɵɵdefineInjectable({ factory: function AppExtensionProviderService_Factory() { return new AppExtensionProviderService(); }, token: AppExtensionProviderService, providedIn: "root" });
AppExtensionProviderService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], AppExtensionProviderService);

const fragmentCache = new Map();
window.resourceCache = fragmentCache;
const componentFactoryRefCache = new Map();
componentFactoryRefCache.set(ComponentType.PAGE, new Map());
componentFactoryRefCache.set(ComponentType.PARTIAL, new Map());
componentFactoryRefCache.set(ComponentType.PREFAB, new Map());
const _decodeURIComponent = (str) => decodeURIComponent(str.replace(/\+/g, ' '));
const ɵ0 = _decodeURIComponent;
const getFragmentUrl = (fragmentName, type) => {
    if (type === ComponentType.PAGE || type === ComponentType.PARTIAL) {
        return `./pages/${fragmentName}/page.min.json`;
    }
    else if (type === ComponentType.PREFAB) {
        return getPrefabMinJsonUrl(fragmentName);
    }
};
const ɵ1 = getFragmentUrl;
const scriptCache = new Map();
const execScript = (script, identifier, ctx, instance, app, utils) => {
    let fn = scriptCache.get(identifier);
    if (!fn) {
        fn = new Function(ctx, 'App', 'Utils', script);
        scriptCache.set(identifier, fn);
    }
    fn(instance, app, utils);
};
const ɵ2 = execScript;
class BaseDynamicComponent {
    init() { }
}
const getDynamicModule = (componentRef) => {
    let DynamicModule = class DynamicModule {
    };
    DynamicModule = __decorate([
        NgModule({
            declarations: [componentRef],
            imports: [
                RuntimeBaseModule
            ],
            schemas: [CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA]
        })
    ], DynamicModule);
    return DynamicModule;
};
const ɵ3 = getDynamicModule;
const getDynamicComponent = (componentName, type, template, css, script, variables) => {
    var DynamicComponent_1;
    const componentDef = {
        template,
        styles: [css],
        encapsulation: ViewEncapsulation.None
    };
    let BaseClass = BaseDynamicComponent;
    let selector = '';
    let context = '';
    switch (type) {
        case ComponentType.PAGE:
            BaseClass = BasePageComponent;
            selector = `app-page-${componentName}`;
            context = 'Page';
            break;
        case ComponentType.PARTIAL:
            BaseClass = BasePartialComponent;
            selector = `app-partial-${componentName}`;
            context = 'Partial';
            break;
        case ComponentType.PREFAB:
            BaseClass = BasePrefabComponent;
            selector = `app-prefab-${componentName}`;
            context = 'Prefab';
            break;
    }
    let DynamicComponent = DynamicComponent_1 = class DynamicComponent extends BaseClass {
        constructor(injector) {
            super();
            this.injector = injector;
            switch (type) {
                case ComponentType.PAGE:
                    this.pageName = componentName;
                    break;
                case ComponentType.PARTIAL:
                    this.partialName = componentName;
                    break;
                case ComponentType.PREFAB:
                    this.prefabName = componentName;
                    break;
            }
            super.init();
        }
        evalUserScript(instance, appContext, utils) {
            execScript(script, selector, context, instance, appContext, utils);
        }
        getVariables() {
            return JSON.parse(variables);
        }
    };
    DynamicComponent.ctorParameters = () => [
        { type: Injector }
    ];
    DynamicComponent = DynamicComponent_1 = __decorate([
        Component(Object.assign(Object.assign({}, componentDef), { selector, providers: [
                {
                    provide: UserDefinedExecutionContext,
                    useExisting: DynamicComponent_1
                }
            ] })),
        __metadata("design:paramtypes", [Injector])
    ], DynamicComponent);
    return DynamicComponent;
};
const ɵ4 = getDynamicComponent;
let ComponentRefProviderService = class ComponentRefProviderService extends ComponentRefProvider {
    constructor(resouceMngr, app, appManager, compiler) {
        super();
        this.resouceMngr = resouceMngr;
        this.app = app;
        this.appManager = appManager;
        this.compiler = compiler;
    }
    loadResourcesOfFragment(componentName, componentType) {
        const url = getFragmentUrl(componentName, componentType);
        const resource = fragmentCache.get(url);
        if (resource) {
            return Promise.resolve(resource);
        }
        return this.resouceMngr.get(url, true)
            .then(({ markup, script, styles, variables }) => {
            const response = {
                markup: transpile(_decodeURIComponent(markup)).markup,
                script: _decodeURIComponent(script),
                styles: scopeComponentStyles(componentName, componentType, _decodeURIComponent(styles)),
                variables: getValidJSON(_decodeURIComponent(variables))
            };
            fragmentCache.set(url, response);
            return response;
        }, e => {
            const status = e.details.status;
            const errorMsgMap = {
                404: this.app.appLocale.MESSAGE_PAGE_NOT_FOUND || 'The page you are trying to reach is not available',
                403: this.app.appLocale.LABEL_ACCESS_DENIED || 'Access Denied'
            };
            return Promise.reject(errorMsgMap[status]);
        });
    }
    getComponentFactoryRef(componentName, componentType) {
        return __awaiter(this, void 0, void 0, function* () {
            // check in the cache.
            const componentFactoryMap = componentFactoryRefCache.get(componentType);
            let componentFactoryRef;
            if (componentFactoryMap) {
                componentFactoryRef = componentFactoryMap.get(componentName);
                if (componentFactoryRef) {
                    return componentFactoryRef;
                }
            }
            return this.loadResourcesOfFragment(componentName, componentType)
                .then(({ markup, script, styles, variables }) => {
                const componentDef = getDynamicComponent(componentName, componentType, markup, styles, script, JSON.stringify(variables));
                const moduleDef = getDynamicModule(componentDef);
                componentFactoryRef = this.compiler
                    .compileModuleAndAllComponentsSync(moduleDef)
                    .componentFactories
                    .filter(factory => factory.componentType === componentDef)[0];
                componentFactoryRefCache.get(componentType).set(componentName, componentFactoryRef);
                return componentFactoryRef;
            }, (err) => {
                if (err) {
                    const msg = "Error while loading page";
                    // console the error for easy debugging
                    console.log(msg, err);
                    this.appManager.notifyApp(_.isString(err) ? err : msg + ', check browser console for error details', 'error');
                }
            });
        });
    }
    // clears the cache map
    clearComponentFactoryRefCache() {
        this.resouceMngr.clearCache();
        fragmentCache.clear();
        componentFactoryRefCache.forEach(map => {
            map.clear();
        });
    }
};
ComponentRefProviderService.ctorParameters = () => [
    { type: AppResourceManagerService },
    { type: App },
    { type: AppManagerService },
    { type: Compiler }
];
ComponentRefProviderService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [AppResourceManagerService,
        App,
        AppManagerService,
        Compiler])
], ComponentRefProviderService);

const cache$1 = new Map();
let PrefabConfigProviderService = class PrefabConfigProviderService extends PrefabConfigProvider {
    constructor(resourceMngr) {
        super();
        this.resourceMngr = resourceMngr;
    }
    getConfig(prefabName) {
        const config = cache$1.get(prefabName);
        if (config) {
            return Promise.resolve(config);
        }
        return this.resourceMngr.get(getPrefabConfigUrl(prefabName))
            .then(_config => {
            cache$1.set(prefabName, _config);
            return _config;
        });
    }
};
PrefabConfigProviderService.ctorParameters = () => [
    { type: AppResourceManagerService }
];
PrefabConfigProviderService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [AppResourceManagerService])
], PrefabConfigProviderService);

const routerModule = RouterModule.forRoot(routes, { useHash: true, scrollPositionRestoration: 'top' });
const toastrModule = ToastNoAnimationModule.forRoot({ maxOpened: 1, autoDismiss: true });
const httpClientXsrfModule = HttpClientXsrfModule.withOptions({
    cookieName: 'wm_xsrf_token',
    headerName: getWmProjectProperties().xsrf_header_name
});
const modalModule = ModalModule.forRoot();
const bsDatePickerModule = BsDatepickerModule.forRoot();
const datepickerModule = DatepickerModule.forRoot();
const timepickerModule = TimepickerModule.forRoot();
const bsDropdownModule = BsDropdownModule.forRoot();
const paginationModule = PaginationModule.forRoot();
const typeaheadModule = TypeaheadModule.forRoot();
const progressbarModule = ProgressbarModule.forRoot();
const carouselModule = CarouselModule.forRoot();
const popoverModule = PopoverModule.forRoot();
const ngCircleProgressModule = NgCircleProgressModule.forRoot({});
const tooltipModule = TooltipModule.forRoot();
const componentsModule = [
    // NGX Bootstrap
    BsDatepickerModule,
    DatepickerModule,
    TimepickerModule,
    BsDropdownModule,
    PaginationModule,
    TypeaheadModule,
    ProgressbarModule,
    CarouselModule,
    PopoverModule,
    NgCircleProgressModule,
    TooltipModule,
    // Basic widgets
    BasicModule,
    ProgressModule,
    RichTextEditorModule,
    SearchModule,
    TreeModule,
    // Input
    CalendarModule,
    ChipsModule,
    ColorPickerModule,
    CurrencyModule,
    EpochModule,
    FileUploadModule,
    InputModule,
    RatingModule,
    SliderModule,
    // Data
    CardModule,
    FormModule,
    ListModule,
    LiveTableModule,
    PaginationModule$1,
    TableModule,
    // chart
    ChartModule,
    // container modules
    AccordionModule,
    LayoutGridModule,
    PanelModule,
    TabsModule,
    TileModule,
    WizardModule,
    // dialogs
    AlertDialogModule,
    IframeDialogModule,
    LoginDialogModule,
    PartialDialogModule,
    // navigation
    BreadcrumbModule,
    MenuModule,
    NavbarModule,
    PopoverModule$1,
    // Advanced
    CarouselModule$1,
    LoginModule,
    MarqueeModule,
    PageModule,
    FooterModule,
    HeaderModule,
    LeftPanelModule,
    RightPanelModule,
    TopNavModule,
    PrefabModule
];
REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push(...componentsModule);
REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push(...MOBILE_COMPONENT_MODULES_FOR_ROOT);
REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push(FormsModule, ReactiveFormsModule);
let AppModule = class AppModule {
    constructor(app, inj, componentRefProvider) {
        this.app = app;
        this.inj = inj;
        this.componentRefProvider = componentRefProvider;
        if (window['cordova']) {
            // clear the cached urls on logout, to load the Login Page and not the Main Page as app reload(window.location.reload) is not invoked in mobile
            this.app.subscribe('userLoggedOut', this.componentRefProvider.clearComponentFactoryRefCache.bind(this.componentRefProvider));
        }
    }
};
AppModule.ctorParameters = () => [
    { type: App },
    { type: Injector },
    { type: ComponentRefProvider }
];
AppModule = __decorate([
    NgModule({
        declarations: [
            PageWrapperComponent
        ],
        imports: [
            BrowserModule,
            BrowserAnimationsModule,
            CommonModule,
            RouterModule,
            HttpClientModule,
            modalModule,
            bsDatePickerModule,
            datepickerModule,
            timepickerModule,
            bsDropdownModule,
            paginationModule,
            typeaheadModule,
            tooltipModule,
            progressbarModule,
            carouselModule,
            popoverModule,
            ngCircleProgressModule,
            routerModule,
            toastrModule,
            httpClientXsrfModule,
            WM_MODULES_FOR_ROOT
        ],
        providers: [
            AppResourceManagerService,
            { provide: AppJSProvider, useClass: AppJSProviderService },
            { provide: AppVariablesProvider, useClass: AppVariablesProviderService },
            { provide: AppExtensionProvider, useClass: AppExtensionProviderService },
            { provide: ComponentRefProvider, useClass: ComponentRefProviderService },
            { provide: PartialRefProvider, useClass: ComponentRefProviderService },
            { provide: PrefabConfigProvider, useClass: PrefabConfigProviderService },
            { provide: RouteReuseStrategy, useClass: WmRouteReuseStrategy }
        ],
        bootstrap: [AppComponent]
    }),
    __metadata("design:paramtypes", [App, Injector, ComponentRefProvider])
], AppModule);

const DEBUG_MODE = 'debugMode';
if (sessionStorage.getItem(DEBUG_MODE) !== 'true') {
    enableProdMode();
}
console.time('bootstrap');
document.addEventListener('DOMContentLoaded', () => {
    new Promise(resolve => {
        if (isSpotcues) {
            initSpotCues().then(resolve);
        }
        else if (window['cordova']) {
            document.addEventListener('deviceready', resolve);
        }
        else {
            resolve();
        }
    }).then(() => platformBrowserDynamic().bootstrapModule(AppModule))
        .then((appModuleRef) => {
        const applicationRef = appModuleRef.injector.get(ApplicationRef);
        window.addEventListener('unload', () => {
            applicationRef.components.map(c => c && c.destroy());
        });
        console.timeEnd('bootstrap');
    }, err => console.log(err));
});
window.debugMode = function (on) {
    if (_.isEmpty(on)) {
        on = true;
    }
    const value = on ? 'true' : 'false';
    if (sessionStorage.getItem(DEBUG_MODE) !== value) {
        sessionStorage.setItem(DEBUG_MODE, value);
        window.location.reload();
    }
};
var main = () => { };

/**
 * Generated bundle index. Do not edit.
 */

export { AppModule, AppResourceManagerService, bsDatePickerModule, bsDropdownModule, carouselModule, datepickerModule, httpClientXsrfModule, modalModule, ngCircleProgressModule, paginationModule, popoverModule, progressbarModule, routerModule, timepickerModule, toastrModule, tooltipModule, typeaheadModule, routes as ɵa, PageWrapperComponent as ɵb, AppJSProviderService as ɵc, AppVariablesProviderService as ɵd, AppExtensionProviderService as ɵe, ComponentRefProviderService as ɵf, PrefabConfigProviderService as ɵg };
//# sourceMappingURL=index.js.map
