import { Injector, ViewContainerRef, ApplicationRef, NgZone, ElementRef, Component, ɵɵdefineInjectable, ɵɵinject, Injectable, NgModule, CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA, ViewEncapsulation, Compiler, enableProdMode } from '@angular/core';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { __awaiter, __generator, __decorate, __metadata, __extends, __assign, __spread } from 'tslib';
import { BrowserModule } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';
import { ActivatedRoute, Router, RouterModule, RouteReuseStrategy } from '@angular/router';
import { HttpClient, HttpClientXsrfModule, HttpClientModule } from '@angular/common/http';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { TypeaheadModule } from 'ngx-bootstrap/typeahead';
import { TimepickerModule } from 'ngx-bootstrap/timepicker';
import { ProgressbarModule } from 'ngx-bootstrap/progressbar';
import { PaginationModule } from 'ngx-bootstrap/pagination';
import { ModalModule } from 'ngx-bootstrap/modal';
import { TooltipModule } from 'ngx-bootstrap/tooltip';
import { BsDatepickerModule, DatepickerModule } from 'ngx-bootstrap/datepicker';
import { BsDropdownModule } from 'ngx-bootstrap/dropdown';
import { PopoverModule } from 'ngx-bootstrap/popover';
import { NgCircleProgressModule } from 'ng-circle-progress';
import { ToastNoAnimationModule } from 'ngx-toastr';
import { CarouselModule } from 'ngx-bootstrap/carousel';
import { App, AbstractSpinnerService, AbstractHttpService, appendScriptToHead, UserDefinedExecutionContext, getValidJSON, getWmProjectProperties, PartialRefProvider, isSpotcues } from '@wm/core';
import { BasicModule } from '@wm/components/basic';
import { ProgressModule } from '@wm/components/basic/progress';
import { RichTextEditorModule } from '@wm/components/basic/rich-text-editor';
import { SearchModule } from '@wm/components/basic/search';
import { TreeModule } from '@wm/components/basic/tree';
import { InputModule } from '@wm/components/input';
import { CalendarModule } from '@wm/components/input/calendar';
import { ChipsModule } from '@wm/components/input/chips';
import { ColorPickerModule } from '@wm/components/input/color-picker';
import { CurrencyModule } from '@wm/components/input/currency';
import { EpochModule } from '@wm/components/input/epoch';
import { FileUploadModule } from '@wm/components/input/file-upload';
import { RatingModule } from '@wm/components/input/rating';
import { SliderModule } from '@wm/components/input/slider';
import { MOBILE_COMPONENT_MODULES_FOR_ROOT } from '@wm/mobile/runtime/dynamic';
import { CardModule } from '@wm/components/data/card';
import { FormModule } from '@wm/components/data/form';
import { ListModule } from '@wm/components/data/list';
import { LiveTableModule } from '@wm/components/data/live-table';
import { PaginationModule as PaginationModule$1 } from '@wm/components/data/pagination';
import { TableModule } from '@wm/components/data/table';
import { ChartModule } from '@wm/components/chart';
import { AccordionModule } from '@wm/components/containers/accordion';
import { LayoutGridModule } from '@wm/components/containers/layout-grid';
import { PanelModule } from '@wm/components/containers/panel';
import { TabsModule } from '@wm/components/containers/tabs';
import { TileModule } from '@wm/components/containers/tile';
import { WizardModule } from '@wm/components/containers/wizard';
import { AlertDialogModule } from '@wm/components/dialogs/alert-dialog';
import { IframeDialogModule } from '@wm/components/dialogs/iframe-dialog';
import { LoginDialogModule } from '@wm/components/dialogs/login-dialog';
import { PartialDialogModule } from '@wm/components/dialogs/partial-dialog';
import { BreadcrumbModule } from '@wm/components/navigation/breadcrumb';
import { MenuModule } from '@wm/components/navigation/menu';
import { NavbarModule } from '@wm/components/navigation/navbar';
import { PopoverModule as PopoverModule$1 } from '@wm/components/navigation/popover';
import { CarouselModule as CarouselModule$1 } from '@wm/components/advanced/carousel';
import { LoginModule } from '@wm/components/advanced/login';
import { MarqueeModule } from '@wm/components/advanced/marquee';
import { PageModule } from '@wm/components/page';
import { FooterModule } from '@wm/components/page/footer';
import { HeaderModule } from '@wm/components/page/header';
import { LeftPanelModule } from '@wm/components/page/left-panel';
import { RightPanelModule } from '@wm/components/page/right-panel';
import { TopNavModule } from '@wm/components/page/top-nav';
import { PrefabModule } from '@wm/components/prefab';
import { BasePageComponent, ComponentType, AppManagerService, ComponentRefProvider, SecurityConfigResolve, MetadataResolve, AppJSResolve, AppExtensionJSResolve, EmptyPageComponent, PrefabPreviewComponent, CanDeactivatePageGuard, AppJSProvider, AppVariablesProvider, AppExtensionProvider, getPrefabMinJsonUrl, RuntimeBaseModule, BasePrefabComponent, BasePartialComponent, getPrefabConfigUrl, PrefabConfigProvider, REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS, WM_MODULES_FOR_ROOT, WmRouteReuseStrategy, AppComponent, initSpotCues } from '@wm/runtime/base';
import { MetadataService } from '@wm/variables';
import { SecurityService } from '@wm/security';
import { transpile, scopeComponentStyles } from '@wm/transpiler';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

var PageWrapperComponent = /** @class */ (function () {
    function PageWrapperComponent(injector, route, vcRef, appRef, metadataService, securityService, appManager, app, ngZone, elRef, spinnerService, componentRefProvider, router) {
        this.injector = injector;
        this.route = route;
        this.vcRef = vcRef;
        this.appRef = appRef;
        this.metadataService = metadataService;
        this.securityService = securityService;
        this.appManager = appManager;
        this.app = app;
        this.ngZone = ngZone;
        this.elRef = elRef;
        this.spinnerService = spinnerService;
        this.componentRefProvider = componentRefProvider;
        this.router = router;
    }
    PageWrapperComponent.prototype.getTargetNode = function () {
        return this.elRef.nativeElement;
    };
    PageWrapperComponent.prototype.resetViewContainer = function () {
        this.vcRef.clear();
        var $target = this.getTargetNode();
        $target.innerHTML = '';
    };
    PageWrapperComponent.prototype.renderPage = function (pageName) {
        var _this = this;
        var $target = this.getTargetNode();
        this.appManager.loadAppVariables()
            .then(function () { return __awaiter(_this, void 0, void 0, function () {
            var pageComponentFactoryRef, componentRef;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.componentRefProvider.getComponentFactoryRef(pageName, ComponentType.PAGE)];
                    case 1:
                        pageComponentFactoryRef = _a.sent();
                        if (pageComponentFactoryRef) {
                            componentRef = this.vcRef.createComponent(pageComponentFactoryRef, 0, this.injector);
                            this.instance = componentRef.instance;
                            $target.appendChild(componentRef.location.nativeElement);
                        }
                        else {
                            BasePageComponent.clear();
                        }
                        if (this.vcRef.length > 1) {
                            this.vcRef.remove(1);
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    };
    PageWrapperComponent.prototype.renderPrefabPreviewPage = function () {
        this.router.navigate(['prefab-preview']);
    };
    PageWrapperComponent.prototype.loadPage = function (pageName) {
        var _this = this;
        this.ngZone.run(function () {
            if (pageName) {
                _this.renderPage(pageName);
            }
        });
    };
    PageWrapperComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.app.isPrefabType) {
            // there is only one route
            this.renderPrefabPreviewPage();
        }
        else {
            $(this.getTargetNode()).find('>div').first().remove();
            this.subscription = this.route.params.subscribe(function (_a) {
                var pageName = _a.pageName;
                _this.loadPage(pageName);
            });
        }
    };
    PageWrapperComponent.prototype.ngOnDestroy = function () {
        this.vcRef.clear();
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    PageWrapperComponent.prototype.ngOnAttach = function () {
        this.getTargetNode().appendChild(this.instance.$page[0]);
        this.instance.ngOnAttach();
    };
    PageWrapperComponent.prototype.ngOnDetach = function () {
        this.instance.ngOnDetach();
    };
    PageWrapperComponent.ctorParameters = function () { return [
        { type: Injector },
        { type: ActivatedRoute },
        { type: ViewContainerRef },
        { type: ApplicationRef },
        { type: MetadataService },
        { type: SecurityService },
        { type: AppManagerService },
        { type: App },
        { type: NgZone },
        { type: ElementRef },
        { type: AbstractSpinnerService },
        { type: ComponentRefProvider },
        { type: Router }
    ]; };
    PageWrapperComponent = __decorate([
        Component({
            selector: 'app-page-outlet',
            template: '<div></div>'
        }),
        __metadata("design:paramtypes", [Injector,
            ActivatedRoute,
            ViewContainerRef,
            ApplicationRef,
            MetadataService,
            SecurityService,
            AppManagerService,
            App,
            NgZone,
            ElementRef,
            AbstractSpinnerService,
            ComponentRefProvider,
            Router])
    ], PageWrapperComponent);
    return PageWrapperComponent;
}());

var appDependenciesResolve = {
    securityConfig: SecurityConfigResolve,
    metadata: MetadataResolve,
    appJS: AppJSResolve,
    appMetaConfig: AppExtensionJSResolve
};
var routes = [
    {
        path: '',
        pathMatch: 'full',
        resolve: appDependenciesResolve,
        component: EmptyPageComponent
    },
    {
        path: 'prefab-preview',
        pathMatch: 'full',
        resolve: appDependenciesResolve,
        component: PrefabPreviewComponent
    },
    {
        path: ':pageName',
        pathMatch: 'full',
        resolve: appDependenciesResolve,
        component: PageWrapperComponent,
        canDeactivate: [CanDeactivatePageGuard]
    }
];

var AppJSProviderService = /** @class */ (function (_super) {
    __extends(AppJSProviderService, _super);
    function AppJSProviderService($http) {
        var _this = _super.call(this) || this;
        _this.$http = $http;
        return _this;
    }
    AppJSProviderService.prototype.getAppScriptFn = function () {
        return this.$http.get('./app.js', { responseType: 'text' })
            .toPromise()
            .then(function (script) { return new Function('App', 'Utils', 'Injector', script); });
    };
    AppJSProviderService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    AppJSProviderService.ɵprov = ɵɵdefineInjectable({ factory: function AppJSProviderService_Factory() { return new AppJSProviderService(ɵɵinject(HttpClient)); }, token: AppJSProviderService, providedIn: "root" });
    AppJSProviderService = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [HttpClient])
    ], AppJSProviderService);
    return AppJSProviderService;
}(AppJSProvider));

var cache = new Map();
var AppResourceManagerService = /** @class */ (function () {
    function AppResourceManagerService($http) {
        this.$http = $http;
    }
    AppResourceManagerService.prototype.get = function (url, useCache) {
        var cachedResponse = cache.get(url);
        if (cachedResponse) {
            return Promise.resolve(cachedResponse);
        }
        return this.$http.get(url).then(function (response) {
            if (useCache) {
                cache.set(url, response);
            }
            return response;
        });
    };
    AppResourceManagerService.prototype.clearCache = function () {
        cache.clear();
    };
    AppResourceManagerService.ctorParameters = function () { return [
        { type: AbstractHttpService }
    ]; };
    AppResourceManagerService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [AbstractHttpService])
    ], AppResourceManagerService);
    return AppResourceManagerService;
}());

var AppVariablesProviderService = /** @class */ (function (_super) {
    __extends(AppVariablesProviderService, _super);
    function AppVariablesProviderService(resourceManager) {
        var _this = _super.call(this) || this;
        _this.resourceManager = resourceManager;
        return _this;
    }
    AppVariablesProviderService.prototype.getAppVariables = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.resourceManager.get('./app.variables.json')];
            });
        });
    };
    AppVariablesProviderService.ctorParameters = function () { return [
        { type: AppResourceManagerService }
    ]; };
    AppVariablesProviderService.ɵprov = ɵɵdefineInjectable({ factory: function AppVariablesProviderService_Factory() { return new AppVariablesProviderService(ɵɵinject(AppResourceManagerService)); }, token: AppVariablesProviderService, providedIn: "root" });
    AppVariablesProviderService = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [AppResourceManagerService])
    ], AppVariablesProviderService);
    return AppVariablesProviderService;
}(AppVariablesProvider));

var AppExtensionProviderService = /** @class */ (function (_super) {
    __extends(AppExtensionProviderService, _super);
    function AppExtensionProviderService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // With renderer create element, added onloaded callback the append to the body
    AppExtensionProviderService.prototype.loadFormatterConfigScript = function (callback) {
        try {
            appendScriptToHead(callback);
        }
        catch (e) {
            console.warn('Error while loading the formatters.js file');
        }
    };
    AppExtensionProviderService.ɵprov = ɵɵdefineInjectable({ factory: function AppExtensionProviderService_Factory() { return new AppExtensionProviderService(); }, token: AppExtensionProviderService, providedIn: "root" });
    AppExtensionProviderService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], AppExtensionProviderService);
    return AppExtensionProviderService;
}(AppExtensionProvider));

var fragmentCache = new Map();
window.resourceCache = fragmentCache;
var componentFactoryRefCache = new Map();
componentFactoryRefCache.set(ComponentType.PAGE, new Map());
componentFactoryRefCache.set(ComponentType.PARTIAL, new Map());
componentFactoryRefCache.set(ComponentType.PREFAB, new Map());
var _decodeURIComponent = function (str) { return decodeURIComponent(str.replace(/\+/g, ' ')); };
var ɵ0 = _decodeURIComponent;
var getFragmentUrl = function (fragmentName, type) {
    if (type === ComponentType.PAGE || type === ComponentType.PARTIAL) {
        return "./pages/" + fragmentName + "/page.min.json";
    }
    else if (type === ComponentType.PREFAB) {
        return getPrefabMinJsonUrl(fragmentName);
    }
};
var ɵ1 = getFragmentUrl;
var scriptCache = new Map();
var execScript = function (script, identifier, ctx, instance, app, utils) {
    var fn = scriptCache.get(identifier);
    if (!fn) {
        fn = new Function(ctx, 'App', 'Utils', script);
        scriptCache.set(identifier, fn);
    }
    fn(instance, app, utils);
};
var ɵ2 = execScript;
var BaseDynamicComponent = /** @class */ (function () {
    function BaseDynamicComponent() {
    }
    BaseDynamicComponent.prototype.init = function () { };
    return BaseDynamicComponent;
}());
var getDynamicModule = function (componentRef) {
    var DynamicModule = /** @class */ (function () {
        function DynamicModule() {
        }
        DynamicModule = __decorate([
            NgModule({
                declarations: [componentRef],
                imports: [
                    RuntimeBaseModule
                ],
                schemas: [CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA]
            })
        ], DynamicModule);
        return DynamicModule;
    }());
    return DynamicModule;
};
var ɵ3 = getDynamicModule;
var getDynamicComponent = function (componentName, type, template, css, script, variables) {
    var componentDef = {
        template: template,
        styles: [css],
        encapsulation: ViewEncapsulation.None
    };
    var BaseClass = BaseDynamicComponent;
    var selector = '';
    var context = '';
    switch (type) {
        case ComponentType.PAGE:
            BaseClass = BasePageComponent;
            selector = "app-page-" + componentName;
            context = 'Page';
            break;
        case ComponentType.PARTIAL:
            BaseClass = BasePartialComponent;
            selector = "app-partial-" + componentName;
            context = 'Partial';
            break;
        case ComponentType.PREFAB:
            BaseClass = BasePrefabComponent;
            selector = "app-prefab-" + componentName;
            context = 'Prefab';
            break;
    }
    var DynamicComponent = /** @class */ (function (_super) {
        __extends(DynamicComponent, _super);
        function DynamicComponent(injector) {
            var _this = _super.call(this) || this;
            _this.injector = injector;
            switch (type) {
                case ComponentType.PAGE:
                    _this.pageName = componentName;
                    break;
                case ComponentType.PARTIAL:
                    _this.partialName = componentName;
                    break;
                case ComponentType.PREFAB:
                    _this.prefabName = componentName;
                    break;
            }
            _super.prototype.init.call(_this);
            return _this;
        }
        DynamicComponent_1 = DynamicComponent;
        DynamicComponent.prototype.evalUserScript = function (instance, appContext, utils) {
            execScript(script, selector, context, instance, appContext, utils);
        };
        DynamicComponent.prototype.getVariables = function () {
            return JSON.parse(variables);
        };
        var DynamicComponent_1;
        DynamicComponent.ctorParameters = function () { return [
            { type: Injector }
        ]; };
        DynamicComponent = DynamicComponent_1 = __decorate([
            Component(__assign(__assign({}, componentDef), { selector: selector, providers: [
                    {
                        provide: UserDefinedExecutionContext,
                        useExisting: DynamicComponent_1
                    }
                ] })),
            __metadata("design:paramtypes", [Injector])
        ], DynamicComponent);
        return DynamicComponent;
    }(BaseClass));
    return DynamicComponent;
};
var ɵ4 = getDynamicComponent;
var ComponentRefProviderService = /** @class */ (function (_super) {
    __extends(ComponentRefProviderService, _super);
    function ComponentRefProviderService(resouceMngr, app, appManager, compiler) {
        var _this = _super.call(this) || this;
        _this.resouceMngr = resouceMngr;
        _this.app = app;
        _this.appManager = appManager;
        _this.compiler = compiler;
        return _this;
    }
    ComponentRefProviderService.prototype.loadResourcesOfFragment = function (componentName, componentType) {
        var _this = this;
        var url = getFragmentUrl(componentName, componentType);
        var resource = fragmentCache.get(url);
        if (resource) {
            return Promise.resolve(resource);
        }
        return this.resouceMngr.get(url, true)
            .then(function (_a) {
            var markup = _a.markup, script = _a.script, styles = _a.styles, variables = _a.variables;
            var response = {
                markup: transpile(_decodeURIComponent(markup)).markup,
                script: _decodeURIComponent(script),
                styles: scopeComponentStyles(componentName, componentType, _decodeURIComponent(styles)),
                variables: getValidJSON(_decodeURIComponent(variables))
            };
            fragmentCache.set(url, response);
            return response;
        }, function (e) {
            var status = e.details.status;
            var errorMsgMap = {
                404: _this.app.appLocale.MESSAGE_PAGE_NOT_FOUND || 'The page you are trying to reach is not available',
                403: _this.app.appLocale.LABEL_ACCESS_DENIED || 'Access Denied'
            };
            return Promise.reject(errorMsgMap[status]);
        });
    };
    ComponentRefProviderService.prototype.getComponentFactoryRef = function (componentName, componentType) {
        return __awaiter(this, void 0, void 0, function () {
            var componentFactoryMap, componentFactoryRef;
            var _this = this;
            return __generator(this, function (_a) {
                componentFactoryMap = componentFactoryRefCache.get(componentType);
                if (componentFactoryMap) {
                    componentFactoryRef = componentFactoryMap.get(componentName);
                    if (componentFactoryRef) {
                        return [2 /*return*/, componentFactoryRef];
                    }
                }
                return [2 /*return*/, this.loadResourcesOfFragment(componentName, componentType)
                        .then(function (_a) {
                        var markup = _a.markup, script = _a.script, styles = _a.styles, variables = _a.variables;
                        var componentDef = getDynamicComponent(componentName, componentType, markup, styles, script, JSON.stringify(variables));
                        var moduleDef = getDynamicModule(componentDef);
                        componentFactoryRef = _this.compiler
                            .compileModuleAndAllComponentsSync(moduleDef)
                            .componentFactories
                            .filter(function (factory) { return factory.componentType === componentDef; })[0];
                        componentFactoryRefCache.get(componentType).set(componentName, componentFactoryRef);
                        return componentFactoryRef;
                    }, function (err) {
                        if (err) {
                            var msg = "Error while loading page";
                            // console the error for easy debugging
                            console.log(msg, err);
                            _this.appManager.notifyApp(_.isString(err) ? err : msg + ', check browser console for error details', 'error');
                        }
                    })];
            });
        });
    };
    // clears the cache map
    ComponentRefProviderService.prototype.clearComponentFactoryRefCache = function () {
        this.resouceMngr.clearCache();
        fragmentCache.clear();
        componentFactoryRefCache.forEach(function (map) {
            map.clear();
        });
    };
    ComponentRefProviderService.ctorParameters = function () { return [
        { type: AppResourceManagerService },
        { type: App },
        { type: AppManagerService },
        { type: Compiler }
    ]; };
    ComponentRefProviderService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [AppResourceManagerService,
            App,
            AppManagerService,
            Compiler])
    ], ComponentRefProviderService);
    return ComponentRefProviderService;
}(ComponentRefProvider));

var cache$1 = new Map();
var PrefabConfigProviderService = /** @class */ (function (_super) {
    __extends(PrefabConfigProviderService, _super);
    function PrefabConfigProviderService(resourceMngr) {
        var _this = _super.call(this) || this;
        _this.resourceMngr = resourceMngr;
        return _this;
    }
    PrefabConfigProviderService.prototype.getConfig = function (prefabName) {
        var config = cache$1.get(prefabName);
        if (config) {
            return Promise.resolve(config);
        }
        return this.resourceMngr.get(getPrefabConfigUrl(prefabName))
            .then(function (_config) {
            cache$1.set(prefabName, _config);
            return _config;
        });
    };
    PrefabConfigProviderService.ctorParameters = function () { return [
        { type: AppResourceManagerService }
    ]; };
    PrefabConfigProviderService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [AppResourceManagerService])
    ], PrefabConfigProviderService);
    return PrefabConfigProviderService;
}(PrefabConfigProvider));

var routerModule = RouterModule.forRoot(routes, { useHash: true, scrollPositionRestoration: 'top' });
var toastrModule = ToastNoAnimationModule.forRoot({ maxOpened: 1, autoDismiss: true });
var httpClientXsrfModule = HttpClientXsrfModule.withOptions({
    cookieName: 'wm_xsrf_token',
    headerName: getWmProjectProperties().xsrf_header_name
});
var modalModule = ModalModule.forRoot();
var bsDatePickerModule = BsDatepickerModule.forRoot();
var datepickerModule = DatepickerModule.forRoot();
var timepickerModule = TimepickerModule.forRoot();
var bsDropdownModule = BsDropdownModule.forRoot();
var paginationModule = PaginationModule.forRoot();
var typeaheadModule = TypeaheadModule.forRoot();
var progressbarModule = ProgressbarModule.forRoot();
var carouselModule = CarouselModule.forRoot();
var popoverModule = PopoverModule.forRoot();
var ngCircleProgressModule = NgCircleProgressModule.forRoot({});
var tooltipModule = TooltipModule.forRoot();
var componentsModule = [
    // NGX Bootstrap
    BsDatepickerModule,
    DatepickerModule,
    TimepickerModule,
    BsDropdownModule,
    PaginationModule,
    TypeaheadModule,
    ProgressbarModule,
    CarouselModule,
    PopoverModule,
    NgCircleProgressModule,
    TooltipModule,
    // Basic widgets
    BasicModule,
    ProgressModule,
    RichTextEditorModule,
    SearchModule,
    TreeModule,
    // Input
    CalendarModule,
    ChipsModule,
    ColorPickerModule,
    CurrencyModule,
    EpochModule,
    FileUploadModule,
    InputModule,
    RatingModule,
    SliderModule,
    // Data
    CardModule,
    FormModule,
    ListModule,
    LiveTableModule,
    PaginationModule$1,
    TableModule,
    // chart
    ChartModule,
    // container modules
    AccordionModule,
    LayoutGridModule,
    PanelModule,
    TabsModule,
    TileModule,
    WizardModule,
    // dialogs
    AlertDialogModule,
    IframeDialogModule,
    LoginDialogModule,
    PartialDialogModule,
    // navigation
    BreadcrumbModule,
    MenuModule,
    NavbarModule,
    PopoverModule$1,
    // Advanced
    CarouselModule$1,
    LoginModule,
    MarqueeModule,
    PageModule,
    FooterModule,
    HeaderModule,
    LeftPanelModule,
    RightPanelModule,
    TopNavModule,
    PrefabModule
];
REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push.apply(REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS, __spread(componentsModule));
REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push.apply(REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS, __spread(MOBILE_COMPONENT_MODULES_FOR_ROOT));
REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push(FormsModule, ReactiveFormsModule);
var AppModule = /** @class */ (function () {
    function AppModule(app, inj, componentRefProvider) {
        this.app = app;
        this.inj = inj;
        this.componentRefProvider = componentRefProvider;
        if (window['cordova']) {
            // clear the cached urls on logout, to load the Login Page and not the Main Page as app reload(window.location.reload) is not invoked in mobile
            this.app.subscribe('userLoggedOut', this.componentRefProvider.clearComponentFactoryRefCache.bind(this.componentRefProvider));
        }
    }
    AppModule.ctorParameters = function () { return [
        { type: App },
        { type: Injector },
        { type: ComponentRefProvider }
    ]; };
    AppModule = __decorate([
        NgModule({
            declarations: [
                PageWrapperComponent
            ],
            imports: [
                BrowserModule,
                BrowserAnimationsModule,
                CommonModule,
                RouterModule,
                HttpClientModule,
                modalModule,
                bsDatePickerModule,
                datepickerModule,
                timepickerModule,
                bsDropdownModule,
                paginationModule,
                typeaheadModule,
                tooltipModule,
                progressbarModule,
                carouselModule,
                popoverModule,
                ngCircleProgressModule,
                routerModule,
                toastrModule,
                httpClientXsrfModule,
                WM_MODULES_FOR_ROOT
            ],
            providers: [
                AppResourceManagerService,
                { provide: AppJSProvider, useClass: AppJSProviderService },
                { provide: AppVariablesProvider, useClass: AppVariablesProviderService },
                { provide: AppExtensionProvider, useClass: AppExtensionProviderService },
                { provide: ComponentRefProvider, useClass: ComponentRefProviderService },
                { provide: PartialRefProvider, useClass: ComponentRefProviderService },
                { provide: PrefabConfigProvider, useClass: PrefabConfigProviderService },
                { provide: RouteReuseStrategy, useClass: WmRouteReuseStrategy }
            ],
            bootstrap: [AppComponent]
        }),
        __metadata("design:paramtypes", [App, Injector, ComponentRefProvider])
    ], AppModule);
    return AppModule;
}());

var DEBUG_MODE = 'debugMode';
if (sessionStorage.getItem(DEBUG_MODE) !== 'true') {
    enableProdMode();
}
console.time('bootstrap');
document.addEventListener('DOMContentLoaded', function () {
    new Promise(function (resolve) {
        if (isSpotcues) {
            initSpotCues().then(resolve);
        }
        else if (window['cordova']) {
            document.addEventListener('deviceready', resolve);
        }
        else {
            resolve();
        }
    }).then(function () { return platformBrowserDynamic().bootstrapModule(AppModule); })
        .then(function (appModuleRef) {
        var applicationRef = appModuleRef.injector.get(ApplicationRef);
        window.addEventListener('unload', function () {
            applicationRef.components.map(function (c) { return c && c.destroy(); });
        });
        console.timeEnd('bootstrap');
    }, function (err) { return console.log(err); });
});
window.debugMode = function (on) {
    if (_.isEmpty(on)) {
        on = true;
    }
    var value = on ? 'true' : 'false';
    if (sessionStorage.getItem(DEBUG_MODE) !== value) {
        sessionStorage.setItem(DEBUG_MODE, value);
        window.location.reload();
    }
};
var main = (function () { });

/**
 * Generated bundle index. Do not edit.
 */

export { AppModule, AppResourceManagerService, bsDatePickerModule, bsDropdownModule, carouselModule, datepickerModule, httpClientXsrfModule, modalModule, ngCircleProgressModule, paginationModule, popoverModule, progressbarModule, routerModule, timepickerModule, toastrModule, tooltipModule, typeaheadModule, routes as ɵa, PageWrapperComponent as ɵb, AppJSProviderService as ɵc, AppVariablesProviderService as ɵd, AppExtensionProviderService as ɵe, ComponentRefProviderService as ɵf, PrefabConfigProviderService as ɵg };
//# sourceMappingURL=index.js.map
