import { __spread, __read, __values } from 'tslib';
import { HtmlParser, Element, getHtmlTagDefinition, Text, Comment } from '@angular/compiler';
import { isMobileApp } from '@wm/core';

var NG_FORM_MODULE = [{ from: '@angular/forms', name: 'FormsModule', as: 'ngFormsModule' }];
var NG_REACTIVE_FORM_MODULE = [{ from: '@angular/forms', name: 'ReactiveFormsModule', as: 'ngReactiveFormsModule' }];
var NGX_BS_DATE_PICKER = [{ from: 'ngx-bootstrap/datepicker', name: 'BsDatepickerModule', as: 'ngx_BsDatepickerModule' }];
var NGX_CAROUSEL_MODULE = [{ from: 'ngx-bootstrap/carousel', name: 'CarouselModule', as: 'ngxCarouselModule', forRoot: true }];
var NGX_COLOR_PICKER_MODULE = [{ from: 'ngx-color-picker', name: 'ColorPickerModule', as: 'ngx_ColorPickerModule' }];
var NGX_DROP_DOWN_MODULE = [{ from: 'ngx-bootstrap/dropdown', name: 'BsDropdownModule', as: 'ngxBsDropdownModule', forRoot: true }];
var NGX_DATE_PICKER = [{ from: 'ngx-bootstrap/datepicker', name: 'DatepickerModule', as: 'ngx_DatepickerModule', forRoot: true }];
var NGX_MODAL_MODULE = [{ from: 'ngx-bootstrap/modal', name: 'ModalModule', as: 'ngx_ModalModule' }];
var NGX_PAGINATION_MODULE = [{ from: 'ngx-bootstrap/pagination', name: 'PaginationModule', as: 'ngxPaginationModule', forRoot: true }];
var NGX_POPOVER_MODULE = [{ from: 'ngx-bootstrap/popover', name: 'PopoverModule', as: 'ngxPopoverModule', forRoot: true }];
var NGX_TIME_PICKER = [{ from: 'ngx-bootstrap/timepicker', name: 'TimepickerModule', as: 'ngx_TimepickerModule', forRoot: true }];
var NGX_TOOL_TIP_MODULE = [{ from: 'ngx-bootstrap/tooltip', name: 'TooltipModule', as: 'ngxTooltipModule', forRoot: true }];
var NGX_TYPE_HEAD_MODULE = [{ from: 'ngx-bootstrap/typeahead', name: 'TypeaheadModule', as: 'ngxTypeaheadModule', forRoot: true }];
var PROGRESS_MODULE = [{ from: '@wm/components/basic/progress', name: 'ProgressModule' }];
var MOBILE_BASIC_MODULE = __spread(PROGRESS_MODULE, [{ from: '@wm/mobile/components/basic', name: 'BasicModule', as: 'WM_MobileBasicModule', platformType: 'MOBILE' }]);
var MOBILE_FILE_UPLOAD_MODULE = [{ from: '@wm/mobile/components/input/file-upload', name: 'FileUploadModule', as: 'WM_MobileFileUploadModule', platformType: 'MOBILE' }];
var PAGE_MODULE = [{ from: '@wm/components/page', name: 'PageModule' },
    { from: '@wm/mobile/components/page', name: 'PageModule', as: 'WM_MobilePageModule', platformType: 'MOBILE' }];
var BASIC_MODULE = __spread([{ from: '@wm/components/basic', name: 'BasicModule' }], MOBILE_BASIC_MODULE);
var INPUT_MODULE = __spread(NG_FORM_MODULE, [{ from: '@wm/components/input', name: 'InputModule' }]);
var DIALOG_MODULE = __spread(NGX_MODAL_MODULE, INPUT_MODULE, [{ from: '@wm/components/dialogs', name: 'DialogModule' }]);
var PAGINATION_MODULE = __spread(NG_FORM_MODULE, NGX_PAGINATION_MODULE, [{ from: '@wm/components/data/pagination', name: 'PaginationModule' }]);
var SEARCH_MODULE = __spread(NG_FORM_MODULE, NGX_TYPE_HEAD_MODULE, [{ from: '@wm/components/basic/search', name: 'SearchModule' }]);
var ACCORDION_MODULE = [{ from: '@wm/components/containers/accordion', name: 'AccordionModule' }];
var ALERT_DIALOG_MODULE = __spread(DIALOG_MODULE, [{ from: '@wm/components/dialogs/alert-dialog', name: 'AlertDialogModule' }]);
var BARCODE_SCANNER_MODULE = [{ from: '@wm/mobile/components/device/barcode-scanner', name: 'BarcodeScannerModule' }];
var MENU_MODULE = __spread(BASIC_MODULE, NGX_DROP_DOWN_MODULE, INPUT_MODULE, [{ from: '@wm/components/navigation/menu', name: 'MenuModule' }]);
var BREAD_CRUMB_MODULE = __spread(MENU_MODULE, [{ from: '@wm/components/navigation/breadcrumb', name: 'BreadcrumbModule' }]);
var CAMERA_MODULE = [{ from: '@wm/mobile/components/device/camera', name: 'CameraModule' }];
var CALENDAR_MODULE = __spread(NG_FORM_MODULE, NGX_DATE_PICKER, [{ from: '@wm/components/input/calendar', name: 'CalendarModule' }]);
var CAROUSEL_MODULE = __spread(NGX_CAROUSEL_MODULE, [{ from: '@wm/components/advanced/carousel', name: 'CarouselModule' }]);
var CHART_MODULE = __spread(BASIC_MODULE, [{ from: '@wm/components/chart', name: 'ChartModule' }]);
var CHIPS_MODULE = __spread(SEARCH_MODULE, [{ from: '@wm/components/input/chips', name: 'ChipsModule' }]);
var COLOR_PICKER_MODULE = __spread(NG_FORM_MODULE, NGX_COLOR_PICKER_MODULE, [{ from: '@wm/components/input/color-picker', name: 'ColorPickerModule' }]);
var CONFIRM_DIALOG_MODULE = __spread(DIALOG_MODULE, [{ from: '@wm/components/dialogs/confirm-dialog', name: 'ConfirmDialogModule' }]);
var CONTENT_MODULE = [{ from: '@wm/components/page', name: 'PageModule' }];
var CURRENCY_MODULE = __spread(INPUT_MODULE, [{ from: '@wm/components/input/currency', name: 'CurrencyModule' }]);
var DESIGN_DIALOG_MODULE = __spread(DIALOG_MODULE, [{ from: '@wm/components/dialogs/design-dialog', name: 'DesignDialogModule' }]);
var EPOCH_MODULE = __spread(NG_FORM_MODULE, NGX_BS_DATE_PICKER, NGX_TIME_PICKER, NGX_DROP_DOWN_MODULE, NGX_DATE_PICKER, [{ from: '@wm/components/input/epoch', name: 'EpochModule' }]);
var FILE_UPLOAD_MODULE = __spread(MOBILE_FILE_UPLOAD_MODULE, [{ from: '@wm/components/input/file-upload', name: 'FileUploadModule' }]);
var FOOTER_MODULE = [{ from: '@wm/components/page/footer', name: 'FooterModule' }];
var HEADER_MODULE = [{ from: '@wm/components/page/header', name: 'HeaderModule' }];
var IFRAME_DIALOG_MODULE = __spread(BASIC_MODULE, DIALOG_MODULE, [{ from: '@wm/components/dialogs/iframe-dialog', name: 'IframeDialogModule' }]);
var LAYOUT_GRID_MODULE = [{ from: '@wm/components/containers/layout-grid', name: 'LayoutGridModule' }];
var LOGIN_DIALOG_MODULE = __spread(DIALOG_MODULE, [{ from: '@wm/components/dialogs/login-dialog', name: 'LoginDialogModule' }]);
var CARD_MODULE = __spread(NGX_DROP_DOWN_MODULE, MENU_MODULE, BASIC_MODULE, [{ from: '@wm/components/data/card', name: 'CardModule' }]);
var MARQUEE_MODULE = [{ from: '@wm/components/advanced/marquee', name: 'MarqueeModule' }];
var LEFT_PANEL_MODULE = [{ from: '@wm/components/page/left-panel', name: 'LeftPanelModule' },
    { from: '@wm/mobile/components/page/left-panel', name: 'LeftPanelModule', as: 'WM_MobileLeftPanelModule', platformType: 'MOBILE' }];
var LIST_MODULE = __spread(PAGINATION_MODULE, INPUT_MODULE, [{ from: '@wm/components/data/list', name: 'ListModule' }]);
var LOGIN_MODULE = [{ from: '@wm/components/advanced/login', name: 'LoginModule' }];
var MOBILE_NAV_BAR_MODULE = __spread(LEFT_PANEL_MODULE, SEARCH_MODULE, PAGE_MODULE, [{ from: '@wm/mobile/components/page/mobile-navbar', name: 'MobileNavbarModule' }]);
var MEDIA_LIST_MODULE = __spread(BASIC_MODULE, PAGE_MODULE, MOBILE_NAV_BAR_MODULE, [{ from: '@wm/mobile/components/data/media-list', name: 'MediaListModule' }]);
var MOBILE_TAB_BAR_MODULE = [{ from: '@wm/mobile/components/page/tab-bar', name: 'TabBarModule' }];
var NAVBAR_MODULE = [{ from: '@wm/components/navigation/navbar', name: 'NavbarModule' }];
var POPOVER_MODULE = __spread(NGX_POPOVER_MODULE, BASIC_MODULE, [{ from: '@wm/components/navigation/popover', name: 'PopoverModule' }]);
var PANEL_MODULE = __spread(MENU_MODULE, [{ from: '@wm/components/containers/panel', name: 'PanelModule' }]);
var PARTIAL_DIALOG_MODULE = __spread(DIALOG_MODULE, [{ from: '@wm/components/dialogs/partial-dialog', name: 'PartialDialogModule' }]);
var PREFAB_MODULE = [{ from: '@wm/components/prefab', name: 'PrefabModule' }];
var RATING_MODULE = [{ from: '@wm/components/input/rating', name: 'RatingModule' }];
var RICH_TEXT_EDITOR_MODULE = [{ from: '@wm/components/basic/rich-text-editor', name: 'RichTextEditorModule' }];
var RIGHT_PANEL_MODULE = [{ from: '@wm/components/page/right-panel', name: 'RightPanelModule' }];
var SEGMENTED_CONTROL_MODULE = [{ from: '@wm/mobile/components/containers/segmented-control', name: 'SegmentedControlModule' }];
var SLIDER_MODULE = __spread(NG_FORM_MODULE, [{ from: '@wm/components/input/slider', name: 'SliderModule' }]);
var TABS_MODULE = [{ from: '@wm/components/containers/tabs', name: 'TabsModule' }];
var TABLE_MODULE = __spread(NG_FORM_MODULE, NG_REACTIVE_FORM_MODULE, PAGINATION_MODULE, MENU_MODULE, BASIC_MODULE, INPUT_MODULE, NGX_TOOL_TIP_MODULE, LIST_MODULE, [{ from: '@wm/components/data/table', name: 'TableModule' }]);
var TILE_MODULE = [{ from: '@wm/components/containers/tile', name: 'TileModule' }];
var TOP_NAV_MODULE = [{ from: '@wm/components/page/top-nav', name: 'TopNavModule' }];
var TREE_MODULE = [{ from: '@wm/components/basic/tree', name: 'TreeModule' }];
var WIZARD_MODULE = __spread(NG_FORM_MODULE, [{ from: '@wm/components/containers/wizard', name: 'WizardModule' }]);
var LIVE_TABLE_MODULE = __spread(TABLE_MODULE, [{ from: '@wm/components/data/live-table', name: 'LiveTableModule' }]);
var FORM_MODULE = __spread(NG_FORM_MODULE, NG_REACTIVE_FORM_MODULE, BASIC_MODULE, INPUT_MODULE, PAGE_MODULE, DESIGN_DIALOG_MODULE, [{ from: '@wm/components/data/form', name: 'FormModule' }]);
var WIDGET_IMPORTS = new Map([
    ['wm-accordion', ACCORDION_MODULE],
    ['wm-accordionpane', ACCORDION_MODULE],
    ['wm-anchor', BASIC_MODULE],
    ['wm-alertdialog', ALERT_DIALOG_MODULE],
    ['wm-audio', BASIC_MODULE],
    ['wm-barcodescanner', BARCODE_SCANNER_MODULE],
    ['wm-button', INPUT_MODULE],
    ['wm-buttongroup', INPUT_MODULE],
    ['wm-breadcrumb', BREAD_CRUMB_MODULE],
    ['wm-camera', CAMERA_MODULE],
    ['wm-calendar', CALENDAR_MODULE],
    ['wm-card', CARD_MODULE],
    ['wm-card-actions', CARD_MODULE],
    ['wm-card-content', CARD_MODULE],
    ['wm-card-footer', CARD_MODULE],
    ['wm-carousel', CAROUSEL_MODULE],
    ['wm-carousel-content', CAROUSEL_MODULE],
    ['wm-carousel-template', CAROUSEL_MODULE],
    ['wm-chart', CHART_MODULE],
    ['wm-checkbox', INPUT_MODULE],
    ['wm-checkboxset', INPUT_MODULE],
    ['wm-chips', CHIPS_MODULE],
    ['wm-colorpicker', COLOR_PICKER_MODULE],
    ['wm-confirmdialog', CONFIRM_DIALOG_MODULE],
    ['wm-content', CONTENT_MODULE],
    ['wm-currency', CURRENCY_MODULE],
    ['wm-date', EPOCH_MODULE],
    ['wm-datetime', EPOCH_MODULE],
    ['wm-dialog', DESIGN_DIALOG_MODULE],
    ['wm-footer', FOOTER_MODULE],
    ['wm-form', FORM_MODULE],
    ['wm-form-action', FORM_MODULE],
    ['wm-form-field', FORM_MODULE],
    ['wm-filter-field', FORM_MODULE],
    ['wm-fileupload', FILE_UPLOAD_MODULE],
    ['wm-gridrow', LAYOUT_GRID_MODULE],
    ['wm-gridcolumn', LAYOUT_GRID_MODULE],
    ['wm-header', HEADER_MODULE],
    ['wm-html', BASIC_MODULE],
    ['wm-icon', BASIC_MODULE],
    ['wm-iframe', BASIC_MODULE],
    ['wm-iframedialog', IFRAME_DIALOG_MODULE],
    ['wm-label', BASIC_MODULE],
    ['wm-layoutgrid', LAYOUT_GRID_MODULE],
    ['wm-left-panel', LEFT_PANEL_MODULE],
    ['wm-list', LIST_MODULE],
    ['wm-livetable', LIVE_TABLE_MODULE],
    ['wm-login', LOGIN_MODULE],
    ['wm-logindialog', LOGIN_DIALOG_MODULE],
    ['wm-marquee', MARQUEE_MODULE],
    ['wm-menu', MENU_MODULE],
    ['wm-media-list', MEDIA_LIST_MODULE],
    ['wm-mobile-navbar', MOBILE_NAV_BAR_MODULE],
    ['wm-mobile-tabbar', MOBILE_TAB_BAR_MODULE],
    ['wm-nav', MENU_MODULE],
    ['wm-navbar', NAVBAR_MODULE],
    ['wm-nav-item', MENU_MODULE],
    ['wm-network-info-toaster', BASIC_MODULE],
    ['wm-number', INPUT_MODULE],
    ['wm-page', PAGE_MODULE],
    ['wm-page-content', PAGE_MODULE],
    ['wm-pagedialog', PARTIAL_DIALOG_MODULE],
    ['wm-pagination', PAGINATION_MODULE],
    ['wm-panel', PANEL_MODULE],
    ['wm-panel-footer', PANEL_MODULE],
    ['wm-picture', BASIC_MODULE],
    ['wm-popover', POPOVER_MODULE],
    ['wm-progress-bar', PROGRESS_MODULE],
    ['wm-prefab', PREFAB_MODULE],
    ['wm-prefab-container', PREFAB_MODULE],
    ['wm-progress-circle', PROGRESS_MODULE],
    ['wm-radioset', INPUT_MODULE],
    ['wm-rating', RATING_MODULE],
    ['wm-richtexteditor', RICH_TEXT_EDITOR_MODULE],
    ['wm-right-panel', RIGHT_PANEL_MODULE],
    ['wm-select', INPUT_MODULE],
    ['wm-search', SEARCH_MODULE],
    ['wm-segmented-content', SEGMENTED_CONTROL_MODULE],
    ['wm-segmented-control', SEGMENTED_CONTROL_MODULE],
    ['wm-slider', SLIDER_MODULE],
    ['wm-spinner', BASIC_MODULE],
    ['wm-switch', INPUT_MODULE],
    ['wm-table', TABLE_MODULE],
    ['wm-tabs', TABS_MODULE],
    ['wm-tabpane', TABS_MODULE],
    ['wm-text', INPUT_MODULE],
    ['wm-textarea', INPUT_MODULE],
    ['wm-time', EPOCH_MODULE],
    ['wm-tile', TILE_MODULE],
    ['wm-top-nav', TOP_NAV_MODULE],
    ['wm-tree', TREE_MODULE],
    ['wm-video', BASIC_MODULE],
    ['wm-wizard', WIZARD_MODULE],
    ['wm-wizardstep', WIZARD_MODULE],
]);

var CSS_REGEX = {
    COMMENTS_FORMAT: /\/\*((?!\*\/).|\n)+\*\//g,
    SELECTOR_FORMAT: /[^\{\}]*\{/gi,
    SELECTOR_EXCLUDE_FORMAT: /(@keyframes|@media|@font-face|@comment[0-9]+|from|to|[0-9]+%)\b/i
};
var isString = function (v) { return typeof v === 'string'; };
var ɵ0 = isString;
var OVERRIDES = {
    'accessroles': '*accessroles',
    'ng-if': '*ngIf',
    'showindevice': 'showInDevice',
    'ng-class': '[ngClass]',
    'data-ng-class': '[ngClass]',
    'data-ng-src': 'src',
    'ng-src': 'src',
    'data-ng-href': 'href',
    'ng-href': 'href',
    'ng-disabled': 'disabled',
    'data-ng-disabled': 'disabled',
    'ng-model': '[ngModelOptions]="{standalone: true}" [(ngModel)]'
};
var selfClosingTags = new Set(['img']);
var getBoundToExpr = function (value) {
    if (!value) {
        return null;
    }
    value = value.trim();
    if (value.startsWith('bind:')) {
        return value.substr(5);
    }
};
var quoteAttr = function (v) {
    return ('' + v) /* Forces the conversion to string. */
        .replace(/&/g, '&amp;') /* This MUST be the 1st replacement. */
        .replace(/'/g, '&apos;') /* The 4 other predefined entities, required. */
        .replace(/"/g, '&quot;')
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;');
};
var ɵ1 = quoteAttr;
var registry = new Map();
var htmlParser = new HtmlParser();
var ignoreComments = true;
var empty = function () { return ''; };
var ɵ2 = empty;
var isEvent = function (name) { return name[0] === 'o' && name[1] === 'n' && name[2] === '-'; };
var ɵ3 = isEvent;
var getEventName = function (key) { return key.substr(3); };
var ɵ4 = getEventName;
var processBinding = function (attr, expr) { return [attr.name + ".bind", quoteAttr(expr)]; };
var ɵ5 = processBinding;
var processEvent = function (attr) {
    var evtName = getEventName(attr.name);
    return [evtName + ".event", attr.value];
};
var ɵ6 = processEvent;
/**
 * Wraps the string with single quotes.
 * @param val
 */
var wrapWithApos = function (val) {
    return "&apos;" + val.replace(/&apos/g, '&quot').replace(/&quot/g, '\\&quot') + "&apos;";
};
var ɵ7 = wrapWithApos;
var ELE_PREFIX = '.wm-app';
var processAttr = function (attr) {
    var overridden = OVERRIDES[attr.name];
    var value = attr.valueSpan ? attr.value : undefined;
    // do not append showInDevice attribute for mobile application.
    if (attr.name === 'showindevice' && isMobileApp()) {
        overridden = '';
    }
    if (overridden) {
        /**
         * wrap value for accessroles with ''.
         * since accessroles is a structural directive, it will be transpiled to [accessroles]
         * hence, the value against it should be a computed string
         */
        if (attr.name === 'accessroles') {
            return [overridden, "'" + value + "'"];
        }
        return [overridden, quoteAttr(value)];
    }
    if (isEvent(attr.name)) {
        return processEvent(attr);
    }
    var boundExpr = getBoundToExpr(attr.value);
    if (boundExpr) {
        return processBinding(attr, boundExpr);
    }
    return [attr.name, quoteAttr(value)];
};
var ɵ8 = processAttr;
var getDataSource = function (dataSetExpr) {
    var parts = dataSetExpr.split('.');
    if (parts[0] === 'Variables' || parts[0] === 'Widgets') {
        return parts[0] + "." + parts[1];
    }
};
var ɵ9 = function () {
    var childAttrs = new Map();
    var validChildAttrs = [
        "required"
    ];
    return {
        set: function (attrs) {
            attrs.forEach(function (val, key) {
                validChildAttrs.includes(key) && (childAttrs.set(key, val));
            });
        },
        get: function (attrs) {
            var fltrAttrs = new Map();
            childAttrs.forEach(function (val, key) {
                !attrs.get(key) && fltrAttrs.set(key, val);
            });
            return fltrAttrs;
        },
        clear: function () {
            childAttrs.clear();
        }
    };
};
var widgetChildAttrs = (ɵ9)();
var setChildAttrs = function (attrs) {
    widgetChildAttrs.set(attrs);
    return '';
};
var getChildAttrs = function (attrs) {
    return getAttrMarkup(widgetChildAttrs.get(attrs));
};
var clearChildAttrs = function () {
    widgetChildAttrs.clear();
    return '';
};
var getFormMarkupAttr = function (attrs) {
    if (attrs.get('datavalue.bind')) {
        var onDataValueBinding = getDataSource(attrs.get('datavalue.bind'));
        attrs.set('datavaluesource.bind', onDataValueBinding);
    }
    return getAttrMarkup(attrs);
};
var getAttrMap = function (attrs) {
    var attrMap = new Map();
    attrs.forEach(function (attr) {
        var _a = __read(processAttr(attr), 2), attrName = _a[0], attrValue = _a[1];
        attrMap.set(attrName, attrValue);
    });
    if (attrMap.get('dataset.bind')) {
        var dataSource = getDataSource(attrMap.get('dataset.bind'));
        if (dataSource) {
            attrMap.set('datasource.bind', dataSource);
        }
    }
    return attrMap;
};
var ɵ10 = getAttrMap;
var getAttrMarkup = function (attrs) {
    var attrMarkup = '';
    attrs.forEach(function (v, k) {
        attrMarkup += " " + k;
        if (v) {
            v = v.trim();
            if (k === '[ngClass]' && v.startsWith('{')) {
                v = v.replace(/"/g, "'");
            }
            if (k === 'show.bind' && attrs.get('deferload') === 'true') {
                v = v + ("\" *lazyLoad=\"" + wrapWithApos(v));
            }
            attrMarkup += "=\"" + v + "\"";
            if (k === 'showindevice' && v !== 'all') {
                var condition = [];
                if (v.includes('xs')) {
                    condition.push('Viewport.isMobileType');
                }
                if (v.includes('sm')) {
                    condition.push('(Viewport.isTabletType && Viewport.orientation.isPortrait)');
                }
                if (v.includes('md')) {
                    condition.push('(Viewport.isTabletType && Viewport.orientation.isLandscape)');
                }
                attrMarkup += " *ngIf=\"" + condition.join(' || ') + "\"";
            }
        }
    });
    return attrMarkup;
};
var getRequiredProviders = function (nodeDef, providers, nodeAttrs) {
    if (!nodeDef.requires) {
        return [];
    }
    var requires = nodeDef.requires;
    if (isString(requires)) {
        requires = [requires];
    }
    if (!Array.isArray(requires)) {
        return [];
    }
    return requires.map(function (require) {
        // for dynamic table assigning parent provide map to the child,
        for (var i = nodeAttrs.length - 1; i >= 0; i--) {
            if (nodeAttrs[i].name === 'tableName') {
                return nodeDef[nodeAttrs[i].value];
            }
        }
        for (var i = providers.length - 1; i >= 0; i--) {
            if (providers[i].nodeName === require) {
                return providers[i].provide;
            }
        }
    });
};
var ɵ11 = getRequiredProviders;
var DIMENSION_PROPS = ['padding', 'borderwidth', 'margin'];
var SEPARATOR = ' ', UNSET = 'unset';
var setDimensionProp = function (cssObj, key, nv) {
    var cssKey = key, val, top, right, bottom, left, suffix = '';
    function setVal(prop, value) {
        // if the value is UNSET, reset the existing value
        if (value === UNSET) {
            value = '';
        }
        cssObj[cssKey + prop + suffix] = value;
    }
    if (key === 'borderwidth') {
        suffix = 'width';
        cssKey = 'border';
    }
    val = nv;
    if (val.indexOf(UNSET) !== -1) {
        val = val.split(SEPARATOR);
        top = val[0];
        right = val[1] || val[0];
        bottom = val[2] || val[0];
        left = val[3] || val[1] || val[0];
        setVal('top', top);
        setVal('right', right);
        setVal('bottom', bottom);
        setVal('left', left);
    }
    else {
        if (key === 'borderwidth') {
            cssKey = 'borderwidth';
        }
        cssObj[cssKey] = nv;
    }
};
var ɵ12 = setDimensionProp;
var processDimensionAttributes = function (attrMap) {
    var attrKeys = Array.from(attrMap.keys());
    attrKeys.forEach(function (attrKey) {
        if (DIMENSION_PROPS.includes(attrKey)) {
            var cssObj_1 = {}, attrValue = attrMap.get(attrKey);
            attrMap.delete(attrKey);
            setDimensionProp(cssObj_1, attrKey, attrValue);
            Object.keys(cssObj_1).forEach(function (key) {
                if (cssObj_1[key]) {
                    attrMap.set(key, cssObj_1[key]);
                }
            });
        }
    });
};
var ɵ13 = processDimensionAttributes;
// replace <:svg:svg> -> <svg>, <:svg:*> -> <svg:*>
var getNodeName = function (name) { return name.replace(':svg:svg', 'svg').replace(':svg:', 'svg:'); };
var ɵ14 = getNodeName;
var processNode = function (node, importCollector, providers) {
    var nodeDef = registry.get(node.name);
    var pre, post, template;
    if (nodeDef) {
        pre = nodeDef.pre || empty;
        post = nodeDef.post || empty;
        template = nodeDef.template || empty;
    }
    var markup = '';
    var attrMap;
    var requiredProviders;
    var shared;
    if (!providers) {
        providers = [];
    }
    var isElementType = node instanceof Element;
    if (isElementType) {
        var provideInfo = void 0;
        if (nodeDef) {
            requiredProviders = getRequiredProviders(nodeDef, providers, node.attrs);
            shared = new Map();
            template.apply(void 0, __spread([node, shared], requiredProviders));
        }
        attrMap = getAttrMap(node.attrs);
        processDimensionAttributes(attrMap);
        var nodeName = getNodeName(node.name);
        if (nodeDef) {
            markup = pre.apply(void 0, __spread([attrMap, shared], requiredProviders));
            if (nodeDef.provide) {
                provideInfo = {
                    nodeName: node.name,
                    provide: _.isFunction(nodeDef.provide) ? nodeDef.provide.apply(nodeDef, __spread([attrMap, shared], requiredProviders)) : nodeDef.provide
                };
                // For table node, assigning parent provide map to the child, as child requires some parent provide attrs.
                if (node.name === 'wm-table') {
                    var tableColNodeDefn = registry.get('wm-table-column');
                    tableColNodeDefn[_.find(node.attrs, function (el) { return el.name === 'name'; }).value] = provideInfo.provide;
                    registry.set('wm-table-column', tableColNodeDefn);
                }
                providers.push(provideInfo);
            }
        }
        else {
            markup = "<" + nodeName + " " + getAttrMarkup(attrMap) + ">";
        }
        node.children.forEach(function (child) { return markup += processNode(child, importCollector, providers); });
        if (nodeDef) {
            if (provideInfo) {
                providers.splice(providers.indexOf(provideInfo), 1);
            }
            markup += post.apply(void 0, __spread([attrMap, shared], requiredProviders));
        }
        else {
            if (node.endSourceSpan && !getHtmlTagDefinition(node.name).isVoid) {
                markup += "</" + nodeName + ">";
            }
        }
    }
    else if (node instanceof Text) {
        markup += node.value;
    }
    else if (node instanceof Comment) {
        if (!ignoreComments) {
            markup += node.value;
        }
    }
    importCollector(WIDGET_IMPORTS.get(node.name));
    if (nodeDef && nodeDef.imports) {
        var imports = [];
        if (typeof nodeDef.imports === 'function') {
            imports = nodeDef.imports(attrMap);
        }
        else {
            imports = nodeDef.imports;
        }
        imports.forEach(function (i) {
            importCollector(WIDGET_IMPORTS.get(i));
        });
    }
    return markup;
};
var transpile = function (markup) {
    var e_1, _a;
    if (markup === void 0) { markup = ''; }
    if (!markup.length) {
        return;
    }
    var requiredWMComponents = [];
    var nodes = htmlParser.parse(markup, '');
    if (nodes.errors.length) {
        return;
    }
    var output = '';
    try {
        for (var _b = __values(nodes.rootNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
            var node = _c.value;
            output += processNode(node, function (imports) {
                if (imports) {
                    requiredWMComponents = requiredWMComponents.concat(imports);
                }
            });
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    requiredWMComponents = _.uniqWith(requiredWMComponents, _.isEqual);
    requiredWMComponents = _.sortBy(requiredWMComponents, ['from', 'name']);
    return {
        markup: output,
        requiredWMComponents: requiredWMComponents
    };
};
var register = function (nodeName, nodeDefFn) { return registry.set(nodeName, nodeDefFn()); };
var scopeComponentStyles = function (componentName, componentType, styles) {
    if (styles === void 0) { styles = ''; }
    componentName = componentName.toLowerCase();
    var comments = {};
    var commentCount = 0;
    if (styles.startsWith('/*DISABLE_SCOPING*/')) {
        return styles;
    }
    styles = styles.replace(CSS_REGEX.COMMENTS_FORMAT, function (comment) {
        var key = "@comment" + commentCount++ + "{";
        comments[key] = comment;
        return key;
    });
    styles = styles.replace(CSS_REGEX.SELECTOR_FORMAT, function (selector) {
        if (!CSS_REGEX.SELECTOR_EXCLUDE_FORMAT.test(selector)) {
            var firstNonSpaceCharIndex = selector.match(/\S/).index;
            var prefixSpaceCharSeq = '';
            if (firstNonSpaceCharIndex > 0) {
                prefixSpaceCharSeq = selector.substring(0, firstNonSpaceCharIndex);
                selector = selector.substring(firstNonSpaceCharIndex);
            }
            if (!selector.startsWith('/*') && selector.trim().length > 0) {
                // splits the selector by commas and we iterate over the array and add page level scoping and join it.
                selector = selector.split(',').map(function (s) {
                    var prefix = ELE_PREFIX;
                    s = s.trim();
                    var spaceIndex = s.indexOf(' ');
                    if (s.startsWith(ELE_PREFIX)) {
                        if (spaceIndex > 0) {
                            prefix = s.substring(0, spaceIndex);
                            s = s.substring(spaceIndex + 1);
                        }
                        else {
                            return s;
                        }
                    }
                    if (componentType === 0 || componentType === 'PAGE') {
                        s = prefix + " app-page-" + componentName + " " + s;
                    }
                    else if (componentType === 1 || componentType === 'PREFAB') {
                        s = prefix + " app-prefab-" + componentName + " " + s;
                    }
                    else if (componentType === 2 || componentType === 'PARTIAL') {
                        s = prefix + " app-partial-" + componentName + " " + s;
                    }
                    return s;
                }).join(',');
            }
            selector = prefixSpaceCharSeq + selector;
        }
        return selector;
    });
    for (var key in comments) {
        styles = styles.replace(key, comments[key]);
    }
    return styles;
};

/**
 * Generated bundle index. Do not edit.
 */

export { clearChildAttrs, getAttrMarkup, getBoundToExpr, getChildAttrs, getDataSource, getFormMarkupAttr, processNode, register, scopeComponentStyles, setChildAttrs, transpile, ɵ0, ɵ1, ɵ10, ɵ11, ɵ12, ɵ13, ɵ14, ɵ2, ɵ3, ɵ4, ɵ5, ɵ6, ɵ7, ɵ8, ɵ9 };
//# sourceMappingURL=index.js.map
